/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/base.glsl"), digest: "d5ae695bab268b7d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/blend.glsl"), digest: "c24d37103d7732b9"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush.glsl"), digest: "e5ee25c2d4aa738b"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_blend.glsl"), digest: "7482c05bc782f2ac"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_image.glsl"), digest: "f7ac6503778cadcd"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "9e66ae7e64b0391a"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "1bc96f93637eff28"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "b3b23379b2228c1d"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_solid.glsl"), digest: "efccce9ae405459c"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "2fab35814d41473c"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/clip_shared.glsl"), digest: "5ae82392b0e0a84c"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/composite.glsl"), digest: "1366333accffa6ec"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_blur.glsl"), digest: "9db9e47bc08be02c"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "149b9539317e94a0"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "4cfda667054e095"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "41d3eea067b9f523"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "ee1b441ab4f2cfaf"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "7f5747ff5aeaa622"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "30380a1247fcd2a4"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "e4b4c4cdd05aeb2d"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "9aadaa3f6bba4023"});
    shaders.insert("cs_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_linear_gradient.glsl"), digest: "b2528fd224453c0"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "2c4b9775a7a08608"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_scale.glsl"), digest: "db0d150145f237af"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "fae5218c1bbf74e3"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/debug_color.glsl"), digest: "85a257c72a44c194"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/debug_font.glsl"), digest: "70331ec5f9cec064"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ellipse.glsl"), digest: "951dc637533b8416"});
    shaders.insert("gpu_buffer", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/gpu_buffer.glsl"), digest: "f7046c285ef0b3d1"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "208078c3cbd97aa7"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/gradient.glsl"), digest: "a6654a23448b185a"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "7b67c7ea1f0ce1ce"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/prim_shared.glsl"), digest: "f55fc26965f06896"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ps_clear.glsl"), digest: "97422f9c0208e35e"});
    shaders.insert("ps_copy", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ps_copy.glsl"), digest: "fee018569bc66328"});
    shaders.insert("ps_quad", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ps_quad.glsl"), digest: "cbe566bd5ef3e9a3"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "ecbb5ea587b8af57"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "8195c384e276b23e"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/rect.glsl"), digest: "a072b75695c59cf6"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/render_task.glsl"), digest: "c4574b7a23485833"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/shared.glsl"), digest: "df523dc077d5bcbf"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/transform.glsl"), digest: "ebd33622a0aa408e"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-112.0.2/gfx/wr/webrender/res/yuv.glsl"), digest: "8abf49ff1bdef080"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_Gl.frag"),
        digest: "d714cbb00328b6b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "40e8a9a370cb762b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "7f3909ba8f855813",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "48cdd19c7aae1c8b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "bde9ff378848ed56",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "3b451133c038a86",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "ad5e5e2081d3149c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "d4cfa74ddf939480",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "82a35a35fa048073",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "208136e8ac19d1a8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "cff8aac8df2bf4ce",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "da7f76821c315c8d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "c7beff4a9895b16a",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "6760b62f28382f35",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "94fd2e8ef9e55f6e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "1cef3075c795fa22",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "84fd5b66b4fc37c7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "6c9706bd115a62e4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "e98546abf9607236",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "9267b083acce1671",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "7726762798e75218",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "44e12609d5eebcc4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "cc1bf045b4c4c1cd",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_Gl.frag"),
        digest: "2e46dfe641e33d16",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "3398a4f3c66296e8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "768b0fc699f6cfad",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_Gl.frag"),
        digest: "2fabb4b9602b8b09",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "1fb4a066a88cfecb",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "4dc58354a530e898",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_Gl.frag"),
        digest: "3f16c39cd4d3a1e4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "76cf994622d61eb9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "d0de52d34d4c2670",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "cfcf9f2bdd6629c1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "7d328b23e161f99b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "8e9097d60e1c3133",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_Gl.frag"),
        digest: "f8272359f8877035",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "9d550824be694706",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "301fa68a24aa2deb",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "5c101eb764d9429e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f51ede4cbdc639ee",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "8eca34c33f070e49",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "d4729f5742875500",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "670bf3b99e6b5b96",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "87970f6167024782",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "b4abdac35adeca92",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "4ed90b4b39c4d003",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "49e6f09ccfcebfab",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "ff94e6c0fe6293bd",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "759b8621deb43f74",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "f10fba04f7c59437",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "e1ee6b18274ebea4",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "44b296e917f5ffe0",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_border_segment_Gl.frag"),
        digest: "8495134f5ed37bf5",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_border_solid_Gl.frag"),
        digest: "9fd688a8c266d2da",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "9f76c2a874c97310",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "b69a0fd2c6027778",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_rectangle_Gl.frag"),
        digest: "cabc2ef7edf7bd12",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "2504a7e464e09644",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_conic_gradient_Gl.frag"),
        digest: "653ad09c4b159697",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "3d4ec20a2b40f905",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_line_decoration_Gl.frag"),
        digest: "7943c68da0973c69",
    });
    shaders.insert((ShaderVersion::Gl, "cs_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_linear_gradient_Gl.frag"),
        digest: "ec6e7a133cbb1999",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_radial_gradient_Gl.frag"),
        digest: "ac62439ba9ff459c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "d30639d4f078578d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "29422e04bd4ba508",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/cs_svg_filter_Gl.frag"),
        digest: "aca9420acaec4776",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_clear_Gl.frag"),
        digest: "9ef2acc3bbd621e8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_copy"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_copy_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_copy_Gl.frag"),
        digest: "514726576460ee72",
    });
    shaders.insert((ShaderVersion::Gl, "ps_quad"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_quad_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_quad_Gl.frag"),
        digest: "394b0a8b4c3ce2c9",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_split_composite_Gl.frag"),
        digest: "9c48e025688a9b51",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "8bff6bcffbebd6ad",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "dd575950a903c8ba",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "4d6e30fc06596570",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "3b19da76a889ee4e",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "4aae4ef3ece9362a",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-112.0.2/objdir/aarch64-unknown-linux-gnu/release/build/webrender-8a32f21a3bd5610c/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "cead4141c1fe587c",
    });
    shaders
  };
}
