#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSFontPaletteValuesRule = 949,
  CSSGroupingRule = 974,
  CSSImportRule = 990,
  CSSKeyframeRule = 1004,
  CSSKeyframesRule = 1020,
  CSSLayerBlockRule = 1037,
  CSSLayerStatementRule = 1055,
  CSSMediaRule = 1077,
  CSSMozDocumentRule = 1090,
  CSSNamespaceRule = 1109,
  CSSPageRule = 1126,
  CSSPseudoElement = 1138,
  CSSRule = 1155,
  CSSRuleList = 1163,
  CSSStyleDeclaration = 1175,
  CSSStyleRule = 1195,
  CSSStyleSheet = 1208,
  CSSSupportsRule = 1222,
  CSSTransition = 1238,
  Cache = 1252,
  CacheStorage = 1258,
  CallbackDebuggerNotification = 1271,
  CanonicalBrowsingContext = 1300,
  CanvasCaptureMediaStream = 1325,
  CanvasGradient = 1350,
  CanvasPattern = 1365,
  CanvasRenderingContext2D = 1379,
  CaretPosition = 1404,
  CaretStateChangedEvent = 1418,
  ChannelMergerNode = 1441,
  ChannelSplitterNode = 1459,
  ChannelWrapper = 1479,
  CharacterData = 1494,
  CheckerboardReportService = 1508,
  ChildProcessMessageManager = 1534,
  ChildSHistory = 1561,
  ChromeMessageBroadcaster = 1575,
  ChromeMessageSender = 1600,
  ChromeNodeList = 1620,
  ChromeUtils = 1635,
  ChromeWorker = 1647,
  Client = 1660,
  Clients = 1667,
  Clipboard = 1675,
  ClipboardEvent = 1685,
  ClipboardItem = 1700,
  ClonedErrorHolder = 1714,
  CloseEvent = 1732,
  CommandEvent = 1743,
  Comment = 1756,
  CompositionEvent = 1764,
  ConsoleInstance = 1781,
  ConstantSourceNode = 1797,
  ContentFrameMessageManager = 1816,
  ContentProcessMessageManager = 1843,
  ContentVisibilityAutoStateChangeEvent = 1872,
  ConvolverNode = 1910,
  CountQueuingStrategy = 1924,
  CreateOfferRequest = 1945,
  Credential = 1964,
  CredentialsContainer = 1975,
  Crypto = 1996,
  CryptoKey = 2003,
  CustomElementRegistry = 2013,
  CustomEvent = 2035,
  DOMException = 2047,
  DOMImplementation = 2060,
  DOMLocalization = 2078,
  DOMMatrix = 2094,
  DOMMatrixReadOnly = 2104,
  DOMParser = 2122,
  DOMPoint = 2132,
  DOMPointReadOnly = 2141,
  DOMQuad = 2158,
  DOMRect = 2166,
  DOMRectList = 2174,
  DOMRectReadOnly = 2186,
  DOMRequest = 2202,
  DOMStringList = 2213,
  DOMStringMap = 2227,
  DOMTokenList = 2240,
  DataTransfer = 2253,
  DataTransferItem = 2266,
  DataTransferItemList = 2283,
  DebuggerNotification = 2304,
  DebuggerNotificationObserver = 2325,
  DedicatedWorkerGlobalScope = 2354,
  DelayNode = 2381,
  DeprecationReportBody = 2391,
  DeviceAcceleration = 2413,
  DeviceLightEvent = 2432,
  DeviceMotionEvent = 2449,
  DeviceOrientationEvent = 2467,
  DeviceRotationRate = 2490,
  Directory = 2509,
  Document = 2519,
  DocumentFragment = 2528,
  DocumentL10n = 2545,
  DocumentTimeline = 2558,
  DocumentType = 2575,
  DominatorTree = 2588,
  DragEvent = 2602,
  DynamicsCompressorNode = 2612,
  EXT_blend_minmax = 2635,
  EXT_color_buffer_float = 2652,
  EXT_color_buffer_half_float = 2675,
  EXT_disjoint_timer_query = 2703,
  EXT_float_blend = 2728,
  EXT_frag_depth = 2744,
  EXT_sRGB = 2759,
  EXT_shader_texture_lod = 2768,
  EXT_texture_compression_bptc = 2791,
  EXT_texture_compression_rgtc = 2820,
  EXT_texture_filter_anisotropic = 2849,
  EXT_texture_norm16 = 2880,
  Element = 2899,
  ElementInternals = 2907,
  ErrorEvent = 2924,
  Event = 2935,
  EventCallbackDebuggerNotification = 2941,
  EventCounts = 2975,
  EventSource = 2987,
  EventTarget = 2999,
  Exception = 3011,
  ExtendableEvent = 3021,
  ExtendableMessageEvent = 3037,
  ExtensionAlarms = 3060,
  ExtensionBrowser = 3076,
  ExtensionBrowserSettings = 3093,
  ExtensionBrowserSettingsColorManagement = 3118,
  ExtensionDns = 3158,
  ExtensionEventManager = 3171,
  ExtensionMockAPI = 3193,
  ExtensionPort = 3210,
  ExtensionProxy = 3224,
  ExtensionRuntime = 3239,
  ExtensionScripting = 3256,
  ExtensionSetting = 3275,
  ExtensionTest = 3292,
  External = 3306,
  FeaturePolicy = 3315,
  FeaturePolicyViolationReportBody = 3329,
  FetchEvent = 3362,
  FetchObserver = 3373,
  File = 3387,
  FileList = 3392,
  FileReader = 3401,
  FileReaderSync = 3412,
  FileSystem = 3427,
  FileSystemDirectoryEntry = 3438,
  FileSystemDirectoryHandle = 3463,
  FileSystemDirectoryHandle_AsyncIterator = 3489,
  FileSystemDirectoryIterator = 3529,
  FileSystemDirectoryReader = 3557,
  FileSystemEntry = 3583,
  FileSystemFileEntry = 3599,
  FileSystemFileHandle = 3619,
  FileSystemHandle = 3640,
  FileSystemSyncAccessHandle = 3657,
  FileSystemWritableFileStream = 3684,
  Flex = 3713,
  FlexItemValues = 3718,
  FlexLineValues = 3733,
  FluentBundle = 3748,
  FluentBundleAsyncIterator = 3761,
  FluentBundleIterator = 3787,
  FluentPattern = 3808,
  FluentResource = 3822,
  FocusEvent = 3837,
  FontFace = 3848,
  FontFaceSet = 3857,
  FontFaceSetIterator = 3869,
  FontFaceSetLoadEvent = 3889,
  FormData = 3910,
  FormData_Iterator = 3919,
  FormDataEvent = 3937,
  FrameCrashedEvent = 3951,
  FrameLoader = 3969,
  GPU = 3981,
  GPUAdapter = 3985,
  GPUBindGroup = 3996,
  GPUBindGroupLayout = 4009,
  GPUBuffer = 4028,
  GPUBufferUsage = 4038,
  GPUCanvasContext = 4053,
  GPUColorWrite = 4070,
  GPUCommandBuffer = 4084,
  GPUCommandEncoder = 4101,
  GPUCompilationInfo = 4119,
  GPUCompilationMessage = 4138,
  GPUComputePassEncoder = 4160,
  GPUComputePipeline = 4182,
  GPUDevice = 4201,
  GPUDeviceLostInfo = 4211,
  GPUMapMode = 4229,
  GPUOutOfMemoryError = 4240,
  GPUPipelineLayout = 4260,
  GPUQuerySet = 4278,
  GPUQueue = 4290,
  GPURenderBundle = 4299,
  GPURenderBundleEncoder = 4315,
  GPURenderPassEncoder = 4338,
  GPURenderPipeline = 4359,
  GPUSampler = 4377,
  GPUShaderModule = 4388,
  GPUShaderStage = 4404,
  GPUSupportedFeatures = 4419,
  GPUSupportedLimits = 4440,
  GPUTexture = 4459,
  GPUTextureUsage = 4470,
  GPUTextureView = 4486,
  GPUUncapturedErrorEvent = 4501,
  GPUValidationError = 4525,
  GainNode = 4544,
  Gamepad = 4553,
  GamepadAxisMoveEvent = 4561,
  GamepadButton = 4582,
  GamepadButtonEvent = 4596,
  GamepadEvent = 4615,
  GamepadHapticActuator = 4628,
  GamepadLightIndicator = 4650,
  GamepadPose = 4672,
  GamepadServiceTest = 4684,
  GamepadTouch = 4703,
  Geolocation = 4716,
  GeolocationCoordinates = 4728,
  GeolocationPosition = 4751,
  GeolocationPositionError = 4771,
  GetUserMediaRequest = 4796,
  GleanCategory = 4816,
  GleanImpl = 4830,
  GleanLabeled = 4840,
  GleanPingsImpl = 4853,
  Grid = 4868,
  GridArea = 4873,
  GridDimension = 4882,
  GridLine = 4896,
  GridLines = 4905,
  GridTrack = 4915,
  GridTracks = 4925,
  HTMLAllCollection = 4936,
  HTMLAnchorElement = 4954,
  HTMLAreaElement = 4972,
  HTMLAudioElement = 4988,
  HTMLBRElement = 5005,
  HTMLBaseElement = 5019,
  HTMLBodyElement = 5035,
  HTMLButtonElement = 5051,
  HTMLCanvasElement = 5069,
  HTMLCollection = 5087,
  HTMLDListElement = 5102,
  HTMLDataElement = 5119,
  HTMLDataListElement = 5135,
  HTMLDetailsElement = 5155,
  HTMLDialogElement = 5174,
  HTMLDirectoryElement = 5192,
  HTMLDivElement = 5213,
  HTMLDocument = 5228,
  HTMLElement = 5241,
  HTMLEmbedElement = 5253,
  HTMLFieldSetElement = 5270,
  HTMLFontElement = 5290,
  HTMLFormControlsCollection = 5306,
  HTMLFormElement = 5333,
  HTMLFrameElement = 5349,
  HTMLFrameSetElement = 5366,
  HTMLHRElement = 5386,
  HTMLHeadElement = 5400,
  HTMLHeadingElement = 5416,
  HTMLHtmlElement = 5435,
  HTMLIFrameElement = 5451,
  HTMLImageElement = 5469,
  HTMLInputElement = 5486,
  HTMLLIElement = 5503,
  HTMLLabelElement = 5517,
  HTMLLegendElement = 5534,
  HTMLLinkElement = 5552,
  HTMLMapElement = 5568,
  HTMLMarqueeElement = 5583,
  HTMLMediaElement = 5602,
  HTMLMenuElement = 5619,
  HTMLMetaElement = 5635,
  HTMLMeterElement = 5651,
  HTMLModElement = 5668,
  HTMLOListElement = 5683,
  HTMLObjectElement = 5700,
  HTMLOptGroupElement = 5718,
  HTMLOptionElement = 5738,
  HTMLOptionsCollection = 5756,
  HTMLOutputElement = 5778,
  HTMLParagraphElement = 5796,
  HTMLParamElement = 5817,
  HTMLPictureElement = 5834,
  HTMLPreElement = 5853,
  HTMLProgressElement = 5868,
  HTMLQuoteElement = 5888,
  HTMLScriptElement = 5905,
  HTMLSelectElement = 5923,
  HTMLSlotElement = 5941,
  HTMLSourceElement = 5957,
  HTMLSpanElement = 5975,
  HTMLStyleElement = 5991,
  HTMLTableCaptionElement = 6008,
  HTMLTableCellElement = 6032,
  HTMLTableColElement = 6053,
  HTMLTableElement = 6073,
  HTMLTableRowElement = 6090,
  HTMLTableSectionElement = 6110,
  HTMLTemplateElement = 6134,
  HTMLTextAreaElement = 6154,
  HTMLTimeElement = 6174,
  HTMLTitleElement = 6190,
  HTMLTrackElement = 6207,
  HTMLUListElement = 6224,
  HTMLUnknownElement = 6241,
  HTMLVideoElement = 6260,
  HashChangeEvent = 6277,
  Headers = 6293,
  Headers_Iterator = 6301,
  HeapSnapshot = 6318,
  Highlight = 6331,
  HighlightRegistry = 6341,
  History = 6359,
  IDBCursor = 6367,
  IDBCursorWithValue = 6377,
  IDBDatabase = 6396,
  IDBFactory = 6408,
  IDBIndex = 6419,
  IDBKeyRange = 6428,
  IDBLocaleAwareKeyRange = 6440,
  IDBObjectStore = 6463,
  IDBOpenDBRequest = 6478,
  IDBRequest = 6495,
  IDBTransaction = 6506,
  IDBVersionChangeEvent = 6521,
  IIRFilterNode = 6543,
  IOUtils = 6557,
  IdentityCredential = 6565,
  IdleDeadline = 6584,
  Image = 6597,
  ImageBitmap = 6603,
  ImageBitmapRenderingContext = 6615,
  ImageCapture = 6643,
  ImageCaptureError = 6656,
  ImageCaptureErrorEvent = 6674,
  ImageData = 6697,
  ImageDocument = 6707,
  InputEvent = 6721,
  InspectorFontFace = 6732,
  InspectorUtils = 6750,
  InstallTriggerImpl = 6765,
  IntersectionObserver = 6784,
  IntersectionObserverEntry = 6805,
  IntlUtils = 6831,
  JSProcessActorChild = 6841,
  JSProcessActorParent = 6861,
  JSWindowActorChild = 6882,
  JSWindowActorParent = 6901,
  KeyEvent = 6921,
  KeyboardEvent = 6930,
  KeyframeEffect = 6944,
  L10nFileSource = 6959,
  L10nOverlays = 6974,
  L10nRegistry = 6987,
  LegacyMozTCPSocket = 7000,
  Localization = 7019,
  Location = 7032,
  Lock = 7041,
  LockManager = 7046,
  MIDIAccess = 7058,
  MIDIConnectionEvent = 7069,
  MIDIInput = 7089,
  MIDIInputMap = 7099,
  MIDIMessageEvent = 7112,
  MIDIOutput = 7129,
  MIDIOutputMap = 7140,
  MIDIPort = 7154,
  MOZ_debug = 7163,
  MatchGlob = 7173,
  MatchPattern = 7183,
  MatchPatternSet = 7196,
  MathMLElement = 7212,
  MediaCapabilities = 7226,
  MediaCapabilitiesInfo = 7244,
  MediaControlService = 7266,
  MediaController = 7286,
  MediaDeviceInfo = 7302,
  MediaDevices = 7318,
  MediaElementAudioSourceNode = 7331,
  MediaEncryptedEvent = 7359,
  MediaError = 7379,
  MediaKeyError = 7390,
  MediaKeyMessageEvent = 7404,
  MediaKeySession = 7425,
  MediaKeyStatusMap = 7441,
  MediaKeyStatusMap_Iterator = 7459,
  MediaKeySystemAccess = 7486,
  MediaKeys = 7507,
  MediaList = 7517,
  MediaMetadata = 7527,
  MediaQueryList = 7541,
  MediaQueryListEvent = 7556,
  MediaRecorder = 7576,
  MediaRecorderErrorEvent = 7590,
  MediaSession = 7614,
  MediaSource = 7627,
  MediaStream = 7639,
  MediaStreamAudioDestinationNode = 7651,
  MediaStreamAudioSourceNode = 7683,
  MediaStreamError = 7710,
  MediaStreamEvent = 7727,
  MediaStreamTrack = 7744,
  MediaStreamTrackAudioSourceNode = 7761,
  MediaStreamTrackEvent = 7793,
  MerchantValidationEvent = 7815,
  MessageBroadcaster = 7839,
  MessageChannel = 7858,
  MessageEvent = 7873,
  MessageListenerManager = 7886,
  MessagePort = 7909,
  MessageSender = 7921,
  MimeType = 7935,
  MimeTypeArray = 7944,
  MouseEvent = 7958,
  MouseScrollEvent = 7969,
  MozCanvasPrintState = 7986,
  MozDocumentMatcher = 8006,
  MozDocumentObserver = 8025,
  MozQueryInterface = 8045,
  MozSharedMap = 8063,
  MozSharedMap_Iterator = 8076,
  MozSharedMapChangeEvent = 8098,
  MozStorageAsyncStatementParams = 8122,
  MozStorageStatementParams = 8153,
  MozStorageStatementRow = 8179,
  MozWritableSharedMap = 8202,
  MutationEvent = 8223,
  MutationObserver = 8237,
  MutationRecord = 8254,
  NamedNodeMap = 8269,
  NavigationPreloadManager = 8282,
  Navigator = 8307,
  NetworkInformation = 8317,
  Node = 8336,
  NodeFilter = 8341,
  NodeIterator = 8352,
  NodeList = 8365,
  Notification = 8374,
  NotificationEvent = 8387,
  NotifyPaintEvent = 8405,
  OES_draw_buffers_indexed = 8422,
  OES_element_index_uint = 8447,
  OES_fbo_render_mipmap = 8470,
  OES_standard_derivatives = 8492,
  OES_texture_float = 8517,
  OES_texture_float_linear = 8535,
  OES_texture_half_float = 8560,
  OES_texture_half_float_linear = 8583,
  OES_vertex_array_object = 8613,
  OVR_multiview2 = 8637,
  OfflineAudioCompletionEvent = 8652,
  OfflineAudioContext = 8680,
  OfflineResourceList = 8700,
  OffscreenCanvas = 8720,
  OffscreenCanvasRenderingContext2D = 8736,
  Option = 8770,
  OscillatorNode = 8777,
  PageTransitionEvent = 8792,
  PaintRequest = 8812,
  PaintRequestList = 8825,
  PaintWorkletGlobalScope = 8842,
  PannerNode = 8866,
  ParentProcessMessageManager = 8877,
  Path2D = 8905,
  PathUtils = 8912,
  PaymentAddress = 8922,
  PaymentMethodChangeEvent = 8937,
  PaymentRequest = 8962,
  PaymentRequestUpdateEvent = 8977,
  PaymentResponse = 9003,
  PeerConnectionImpl = 9019,
  PeerConnectionObserver = 9038,
  Performance = 9061,
  PerformanceEntry = 9073,
  PerformanceEntryEvent = 9090,
  PerformanceEventTiming = 9112,
  PerformanceMark = 9135,
  PerformanceMeasure = 9151,
  PerformanceNavigation = 9170,
  PerformanceNavigationTiming = 9192,
  PerformanceObserver = 9220,
  PerformanceObserverEntryList = 9240,
  PerformancePaintTiming = 9269,
  PerformanceResourceTiming = 9292,
  PerformanceServerTiming = 9318,
  PerformanceTiming = 9342,
  PeriodicWave = 9360,
  PermissionStatus = 9373,
  Permissions = 9390,
  PlacesBookmark = 9402,
  PlacesBookmarkAddition = 9417,
  PlacesBookmarkChanged = 9440,
  PlacesBookmarkGuid = 9462,
  PlacesBookmarkKeyword = 9481,
  PlacesBookmarkMoved = 9503,
  PlacesBookmarkRemoved = 9523,
  PlacesBookmarkTags = 9545,
  PlacesBookmarkTime = 9564,
  PlacesBookmarkTitle = 9583,
  PlacesBookmarkUrl = 9603,
  PlacesEvent = 9621,
  PlacesFavicon = 9633,
  PlacesHistoryCleared = 9647,
  PlacesObservers = 9668,
  PlacesPurgeCaches = 9684,
  PlacesRanking = 9702,
  PlacesVisit = 9716,
  PlacesVisitRemoved = 9728,
  PlacesVisitTitle = 9747,
  PlacesWeakCallbackWrapper = 9764,
  Plugin = 9790,
  PluginArray = 9797,
  PluginCrashedEvent = 9809,
  PointerEvent = 9828,
  PopStateEvent = 9841,
  PopupBlockedEvent = 9855,
  PopupPositionedEvent = 9873,
  PositionStateEvent = 9894,
  PrecompiledScript = 9913,
  ProcessMessageManager = 9931,
  ProcessingInstruction = 9953,
  ProgressEvent = 9975,
  PromiseDebugging = 9989,
  PromiseNativeHandler = 10006,
  PromiseRejectionEvent = 10027,
  PublicKeyCredential = 10049,
  PushEvent = 10069,
  PushManager = 10079,
  PushManagerImpl = 10091,
  PushMessageData = 10107,
  PushSubscription = 10123,
  PushSubscriptionOptions = 10140,
  RTCCertificate = 10164,
  RTCDTMFSender = 10179,
  RTCDTMFToneChangeEvent = 10193,
  RTCDataChannel = 10216,
  RTCDataChannelEvent = 10231,
  RTCDtlsTransport = 10251,
  RTCIceCandidate = 10268,
  RTCIdentityProviderRegistrar = 10284,
  RTCPeerConnection = 10313,
  RTCPeerConnectionIceEvent = 10331,
  RTCPeerConnectionStatic = 10357,
  RTCRtpReceiver = 10381,
  RTCRtpSender = 10396,
  RTCRtpTransceiver = 10409,
  RTCSessionDescription = 10427,
  RTCStatsReport = 10449,
  RTCTrackEvent = 10464,
  RadioNodeList = 10478,
  Range = 10492,
  ReadableByteStreamController = 10498,
  ReadableStream = 10527,
  ReadableStream_AsyncIterator = 10542,
  ReadableStreamBYOBReader = 10571,
  ReadableStreamBYOBRequest = 10596,
  ReadableStreamDefaultController = 10622,
  ReadableStreamDefaultReader = 10654,
  Report = 10682,
  ReportBody = 10689,
  ReportingObserver = 10700,
  Request = 10718,
  ResizeObserver = 10726,
  ResizeObserverEntry = 10741,
  ResizeObserverSize = 10761,
  Response = 10780,
  SVGAElement = 10789,
  SVGAngle = 10801,
  SVGAnimateElement = 10810,
  SVGAnimateMotionElement = 10828,
  SVGAnimateTransformElement = 10852,
  SVGAnimatedAngle = 10879,
  SVGAnimatedBoolean = 10896,
  SVGAnimatedEnumeration = 10915,
  SVGAnimatedInteger = 10938,
  SVGAnimatedLength = 10957,
  SVGAnimatedLengthList = 10975,
  SVGAnimatedNumber = 10997,
  SVGAnimatedNumberList = 11015,
  SVGAnimatedPreserveAspectRatio = 11037,
  SVGAnimatedRect = 11068,
  SVGAnimatedString = 11084,
  SVGAnimatedTransformList = 11102,
  SVGAnimationElement = 11127,
  SVGCircleElement = 11147,
  SVGClipPathElement = 11164,
  SVGComponentTransferFunctionElement = 11183,
  SVGDefsElement = 11219,
  SVGDescElement = 11234,
  SVGElement = 11249,
  SVGEllipseElement = 11260,
  SVGFEBlendElement = 11278,
  SVGFEColorMatrixElement = 11296,
  SVGFEComponentTransferElement = 11320,
  SVGFECompositeElement = 11350,
  SVGFEConvolveMatrixElement = 11372,
  SVGFEDiffuseLightingElement = 11399,
  SVGFEDisplacementMapElement = 11427,
  SVGFEDistantLightElement = 11455,
  SVGFEDropShadowElement = 11480,
  SVGFEFloodElement = 11503,
  SVGFEFuncAElement = 11521,
  SVGFEFuncBElement = 11539,
  SVGFEFuncGElement = 11557,
  SVGFEFuncRElement = 11575,
  SVGFEGaussianBlurElement = 11593,
  SVGFEImageElement = 11618,
  SVGFEMergeElement = 11636,
  SVGFEMergeNodeElement = 11654,
  SVGFEMorphologyElement = 11676,
  SVGFEOffsetElement = 11699,
  SVGFEPointLightElement = 11718,
  SVGFESpecularLightingElement = 11741,
  SVGFESpotLightElement = 11770,
  SVGFETileElement = 11792,
  SVGFETurbulenceElement = 11809,
  SVGFilterElement = 11832,
  SVGForeignObjectElement = 11849,
  SVGGElement = 11873,
  SVGGeometryElement = 11885,
  SVGGradientElement = 11904,
  SVGGraphicsElement = 11923,
  SVGImageElement = 11942,
  SVGLength = 11958,
  SVGLengthList = 11968,
  SVGLineElement = 11982,
  SVGLinearGradientElement = 11997,
  SVGMPathElement = 12022,
  SVGMarkerElement = 12038,
  SVGMaskElement = 12055,
  SVGMatrix = 12070,
  SVGMetadataElement = 12080,
  SVGNumber = 12099,
  SVGNumberList = 12109,
  SVGPathElement = 12123,
  SVGPathSeg = 12138,
  SVGPathSegArcAbs = 12149,
  SVGPathSegArcRel = 12166,
  SVGPathSegClosePath = 12183,
  SVGPathSegCurvetoCubicAbs = 12203,
  SVGPathSegCurvetoCubicRel = 12229,
  SVGPathSegCurvetoCubicSmoothAbs = 12255,
  SVGPathSegCurvetoCubicSmoothRel = 12287,
  SVGPathSegCurvetoQuadraticAbs = 12319,
  SVGPathSegCurvetoQuadraticRel = 12349,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12379,
  SVGPathSegCurvetoQuadraticSmoothRel = 12415,
  SVGPathSegLinetoAbs = 12451,
  SVGPathSegLinetoHorizontalAbs = 12471,
  SVGPathSegLinetoHorizontalRel = 12501,
  SVGPathSegLinetoRel = 12531,
  SVGPathSegLinetoVerticalAbs = 12551,
  SVGPathSegLinetoVerticalRel = 12579,
  SVGPathSegList = 12607,
  SVGPathSegMovetoAbs = 12622,
  SVGPathSegMovetoRel = 12642,
  SVGPatternElement = 12662,
  SVGPoint = 12680,
  SVGPointList = 12689,
  SVGPolygonElement = 12702,
  SVGPolylineElement = 12720,
  SVGPreserveAspectRatio = 12739,
  SVGRadialGradientElement = 12762,
  SVGRect = 12787,
  SVGRectElement = 12795,
  SVGSVGElement = 12810,
  SVGScriptElement = 12824,
  SVGSetElement = 12841,
  SVGStopElement = 12855,
  SVGStringList = 12870,
  SVGStyleElement = 12884,
  SVGSwitchElement = 12900,
  SVGSymbolElement = 12917,
  SVGTSpanElement = 12934,
  SVGTextContentElement = 12950,
  SVGTextElement = 12972,
  SVGTextPathElement = 12987,
  SVGTextPositioningElement = 13006,
  SVGTitleElement = 13032,
  SVGTransform = 13048,
  SVGTransformList = 13061,
  SVGUnitTypes = 13078,
  SVGUseElement = 13091,
  SVGViewElement = 13105,
  Sanitizer = 13120,
  Scheduler = 13130,
  Screen = 13140,
  ScreenLuminance = 13147,
  ScreenOrientation = 13163,
  ScriptProcessorNode = 13181,
  ScrollAreaEvent = 13201,
  ScrollViewChangeEvent = 13217,
  SecurityPolicyViolationEvent = 13239,
  Selection = 13268,
  ServiceWorker = 13278,
  ServiceWorkerContainer = 13292,
  ServiceWorkerGlobalScope = 13315,
  ServiceWorkerRegistration = 13340,
  SessionStoreFormData = 13366,
  SessionStoreScrollData = 13387,
  SessionStoreUtils = 13410,
  ShadowRealmGlobalScope = 13428,
  ShadowRoot = 13451,
  SharedWorker = 13462,
  SharedWorkerGlobalScope = 13475,
  SimpleGestureEvent = 13499,
  SourceBuffer = 13518,
  SourceBufferList = 13531,
  SpeechGrammar = 13548,
  SpeechGrammarList = 13562,
  SpeechRecognition = 13580,
  SpeechRecognitionAlternative = 13598,
  SpeechRecognitionError = 13627,
  SpeechRecognitionEvent = 13650,
  SpeechRecognitionResult = 13673,
  SpeechRecognitionResultList = 13697,
  SpeechSynthesis = 13725,
  SpeechSynthesisErrorEvent = 13741,
  SpeechSynthesisEvent = 13767,
  SpeechSynthesisUtterance = 13788,
  SpeechSynthesisVoice = 13813,
  StaticRange = 13834,
  StereoPannerNode = 13846,
  Storage = 13863,
  StorageEvent = 13871,
  StorageManager = 13884,
  StreamFilter = 13899,
  StreamFilterDataEvent = 13912,
  StructuredCloneHolder = 13934,
  StructuredCloneTester = 13956,
  StyleSheet = 13978,
  StyleSheetApplicableStateChangeEvent = 13989,
  StyleSheetList = 14026,
  SubmitEvent = 14041,
  SubtleCrypto = 14053,
  SyncMessageSender = 14066,
  SyncReadFile = 14084,
  TCPServerSocket = 14097,
  TCPServerSocketEvent = 14113,
  TCPSocket = 14134,
  TCPSocketErrorEvent = 14144,
  TCPSocketEvent = 14164,
  TaskController = 14179,
  TaskPriorityChangeEvent = 14194,
  TaskSignal = 14218,
  TelemetryStopwatch = 14229,
  TestUtils = 14248,
  TestingDeprecatedInterface = 14258,
  Text = 14285,
  TextClause = 14290,
  TextDecoder = 14301,
  TextDecoderStream = 14313,
  TextEncoder = 14331,
  TextEncoderStream = 14343,
  TextMetrics = 14361,
  TextTrack = 14373,
  TextTrackCue = 14383,
  TextTrackCueList = 14396,
  TextTrackList = 14413,
  TimeEvent = 14427,
  TimeRanges = 14437,
  Touch = 14448,
  TouchEvent = 14454,
  TouchList = 14465,
  TrackEvent = 14475,
  TransformStream = 14486,
  TransformStreamDefaultController = 14502,
  TransitionEvent = 14535,
  TreeColumn = 14551,
  TreeColumns = 14562,
  TreeContentView = 14574,
  TreeWalker = 14590,
  U2F = 14601,
  UDPMessageEvent = 14605,
  UDPSocket = 14621,
  UIEvent = 14631,
  URL = 14639,
  URLSearchParams = 14643,
  URLSearchParams_Iterator = 14659,
  UniFFIPointer = 14684,
  UniFFIScaffolding = 14698,
  UserInteraction = 14716,
  UserProximityEvent = 14732,
  VRDisplay = 14751,
  VRDisplayCapabilities = 14761,
  VRDisplayEvent = 14783,
  VREyeParameters = 14798,
  VRFieldOfView = 14814,
  VRFrameData = 14828,
  VRMockController = 14840,
  VRMockDisplay = 14857,
  VRPose = 14871,
  VRServiceTest = 14878,
  VRStageParameters = 14892,
  VTTCue = 14910,
  VTTRegion = 14917,
  ValidityState = 14927,
  VideoColorSpace = 14941,
  VideoFrame = 14957,
  VideoPlaybackQuality = 14968,
  VideoTrack = 14989,
  VideoTrackList = 15000,
  VisualViewport = 15015,
  WEBGL_color_buffer_float = 15030,
  WEBGL_compressed_texture_astc = 15055,
  WEBGL_compressed_texture_etc = 15085,
  WEBGL_compressed_texture_etc1 = 15114,
  WEBGL_compressed_texture_pvrtc = 15144,
  WEBGL_compressed_texture_s3tc = 15175,
  WEBGL_compressed_texture_s3tc_srgb = 15205,
  WEBGL_debug_renderer_info = 15240,
  WEBGL_debug_shaders = 15266,
  WEBGL_depth_texture = 15286,
  WEBGL_draw_buffers = 15306,
  WEBGL_explicit_present = 15325,
  WEBGL_lose_context = 15348,
  WaveShaperNode = 15367,
  WebExtensionContentScript = 15382,
  WebExtensionPolicy = 15408,
  WebGL2RenderingContext = 15427,
  WebGLActiveInfo = 15450,
  WebGLBuffer = 15466,
  WebGLContextEvent = 15478,
  WebGLFramebuffer = 15496,
  WebGLProgram = 15513,
  WebGLQuery = 15526,
  WebGLRenderbuffer = 15537,
  WebGLRenderingContext = 15555,
  WebGLSampler = 15577,
  WebGLShader = 15590,
  WebGLShaderPrecisionFormat = 15602,
  WebGLSync = 15629,
  WebGLTexture = 15639,
  WebGLTransformFeedback = 15652,
  WebGLUniformLocation = 15675,
  WebGLVertexArrayObject = 15696,
  WebKitCSSMatrix = 15719,
  WebSocket = 15735,
  WebTransport = 15745,
  WebTransportBidirectionalStream = 15758,
  WebTransportDatagramDuplexStream = 15790,
  WebTransportError = 15823,
  WebTransportReceiveStream = 15841,
  WebTransportSendStream = 15867,
  WebrtcGlobalInformation = 15890,
  WheelEvent = 15914,
  Window = 15925,
  WindowClient = 15932,
  WindowContext = 15945,
  WindowGlobalChild = 15959,
  WindowGlobalParent = 15977,
  WindowRoot = 15996,
  Worker = 16007,
  WorkerDebuggerGlobalScope = 16014,
  WorkerGlobalScope = 16040,
  WorkerLocation = 16058,
  WorkerNavigator = 16073,
  WorkerTestUtils = 16089,
  Worklet = 16105,
  WorkletGlobalScope = 16113,
  WritableStream = 16132,
  WritableStreamDefaultController = 16147,
  WritableStreamDefaultWriter = 16179,
  XMLDocument = 16207,
  XMLHttpRequest = 16219,
  XMLHttpRequestEventTarget = 16234,
  XMLHttpRequestUpload = 16260,
  XMLSerializer = 16281,
  XPathEvaluator = 16295,
  XPathExpression = 16310,
  XPathResult = 16326,
  XRBoundedReferenceSpace = 16338,
  XRFrame = 16362,
  XRInputSource = 16370,
  XRInputSourceArray = 16384,
  XRInputSourceEvent = 16403,
  XRInputSourcesChangeEvent = 16422,
  XRPose = 16448,
  XRReferenceSpace = 16455,
  XRReferenceSpaceEvent = 16472,
  XRRenderState = 16494,
  XRRigidTransform = 16508,
  XRSession = 16525,
  XRSessionEvent = 16535,
  XRSpace = 16550,
  XRSystem = 16558,
  XRView = 16567,
  XRViewerPose = 16574,
  XRViewport = 16587,
  XRWebGLLayer = 16598,
  XSLTProcessor = 16611,
  XULCommandEvent = 16625,
  XULElement = 16641,
  XULFrameElement = 16652,
  XULMenuElement = 16668,
  XULPopupElement = 16683,
  XULResizerElement = 16699,
  XULTextElement = 16717,
  XULTreeElement = 16732,
  console = 16747,
  mozRTCIceCandidate = 16755,
  mozRTCPeerConnection = 16774,
  mozRTCSessionDescription = 16795,
  webkitSpeechGrammar = 16820,
  webkitSpeechGrammarList = 16840,
  webkitSpeechRecognition = 16864,
  webkitURL = 16888,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
