// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Metrics_h
#define mozilla_Metrics_h

#include "mozilla/glean/bindings/MetricTypes.h"
#include "mozilla/Tuple.h"
#include "mozilla/Maybe.h"
#include "nsTArray.h"
#include "nsPrintfCString.h"

namespace mozilla::glean {
struct NoExtraKeys;

namespace browser_launched_to_handle {
    /**
     * generated from browser.launched_to_handle.system_notification
     */
    struct SystemNotificationExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> name;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (name) {
          extraKeys.AppendElement()->AssignASCII("name");
          extraValues.EmplaceBack(name.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when Firefox launches to complete a native notification popped by a
     * system (chrome privileged) alert.  Windows-only at the time of writing.
     */
    constexpr impl::EventMetric<SystemNotificationExtra> system_notification(1);

}
namespace background_update {
    /**
     * generated from background_update.reasons_to_not_update
     */
    /**
     * Records which error was causing the background updater to fail. This list
     * supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
     */
    constexpr impl::StringListMetric reasons_to_not_update(2);

    /**
     * generated from background_update.time_last_update_scheduled
     */
    /**
     * Last time the background update was triggered.
     */
    constexpr impl::DatetimeMetric time_last_update_scheduled(3);

    /**
     * generated from background_update.client_id
     */
    /**
     * The legacy Telemetry client ID of this installation's default profile.
     * The default profile is as determined by the Profile Service, namely
     * `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
     * Firefox installation and only one profile, so the default profile is their
     * regular browsing profile.
     * It is possible for a Firefox installation to not have a default profile, but in
     * such cases the background update task will abort before sending any telemetry;
     * therefore, the legacy Telemetry client ID should always be present.
     */
    constexpr impl::UuidMetric client_id(4);

    /**
     * generated from background_update.targeting_exists
     */
    /**
     * True if the default profile had a targeting snapshot serialized to disk, and
     * there was no exception thrown reading it.
     */
    constexpr impl::BooleanMetric targeting_exists(5);

    /**
     * generated from background_update.targeting_exception
     */
    /**
     * True if the default profile had a targeting snapshot serialized to disk, but an
     * exception was thrown reading it.
     */
    constexpr impl::BooleanMetric targeting_exception(6);

    /**
     * generated from background_update.targeting_version
     */
    /**
     * If the default profile had a targeting snapshot serialized to disk, the
     * `version` of the snapshot.
     * This version number does not have a physical unit: it's only useful to compare
     * between versions.
     */
    constexpr impl::QuantityMetric targeting_version(7);

    /**
     * generated from background_update.targeting_env_firefox_version
     */
    /**
     * The `environment.firefoxVersion` of the default profile's serialized targeting
     * snapshot.  At the time of writing, this version is an integer representing the
     * Firefox major version, e.g., `109`.
     */
    constexpr impl::QuantityMetric targeting_env_firefox_version(8);

    /**
     * generated from background_update.targeting_env_current_date
     */
    /**
     * The `environment.currentDate` of the default profile's serialized targeting
     * snapshot.
     */
    constexpr impl::DatetimeMetric targeting_env_current_date(9);

    /**
     * generated from background_update.targeting_env_profile_age
     */
    /**
     * The `environment.profileAgeCreated` of the default profile's serialized
     * targeting snapshot.
     */
    constexpr impl::DatetimeMetric targeting_env_profile_age(10);

    /**
     * generated from background_update.final_state
     */
    /**
     * String description of the final state the update state machine reached.
     */
    constexpr impl::StringMetric final_state(11);

    /**
     * generated from background_update.states
     */
    /**
     * Ordered list of string descriptions of the states that the update state machine
     * reached.
     */
    constexpr impl::StringListMetric states(12);

    /**
     * generated from background_update.reasons
     */
    /**
     * List of reasons that the background update task did not run.
     */
    constexpr impl::StringListMetric reasons(13);

    /**
     * generated from background_update.exit_code_success
     */
    /**
     * True if the exit code/status of the background update task is 0, which means
     * success.
     */
    constexpr impl::BooleanMetric exit_code_success(14);

    /**
     * generated from background_update.exit_code_exception
     */
    /**
     * True if the exit code/status of the background update task is 3, which means an
     * exception was thrown.
     */
    constexpr impl::BooleanMetric exit_code_exception(15);

}
namespace newtab {
    /**
     * generated from newtab.locale
     */
    /**
     * The application's locale as of when newtab's TelemetryFeed was init. Comes from
     * `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
     */
    constexpr impl::StringMetric locale(16);

    /**
     * generated from newtab.newtab_category
     */
    /**
     * The current setting of the newtab page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `newtab_url_category`. Sampled once after newtab init.
     */
    constexpr impl::StringMetric newtab_category(17);

    /**
     * generated from newtab.homepage_category
     */
    /**
     * The current setting of the home page. One of ["enabled", "disabled",
     * "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
     * media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
     * `home_url_category`. Sampled once after newtab init.
     */
    constexpr impl::StringMetric homepage_category(18);

    /**
     * generated from newtab.opened
     */
    struct OpenedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> source;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when newtab UI is opened via `about:newtab` or `about:home` or
     * `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
     * [detect-user-session-start.js](https://searchfox.org/mozilla-
     * central/source/browser/components/newtab/content-src/lib/detect-user-session-
     * start.js)).
     */
    constexpr impl::EventMetric<OpenedExtra> opened(19);

    /**
     * generated from newtab.closed
     */
    struct ClosedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when newtab UI is closed by * navigation * closing the tab
     * Doesn't mean that the newtab was ever visible to a user.
     */
    constexpr impl::EventMetric<ClosedExtra> closed(20);

}
namespace newtab_search {
    /**
     * generated from newtab.search.enabled
     */
    /**
     * Whether the search input is enabled on the newtab. Corresponds to the value of
     * the `browser.newtabpage.activity-stream.showSearch` pref.
     */
    constexpr impl::BooleanMetric enabled(21);

    /**
     * generated from newtab.search.issued
     */
    struct IssuedExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * When Firefox was asked to issue a search from a Search Access Point (SAP) on a
     * newtab page. Doesn't record searches in Private Browsing Mode unless
     * `browser.engagement.search_counts.pbm` is set to `true`.
     */
    constexpr impl::EventMetric<IssuedExtra> issued(22);

}
namespace topsites {
    /**
     * generated from topsites.enabled
     */
    /**
     * Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
     * Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.topsites` pref.
     */
    constexpr impl::BooleanMetric enabled(23);

    /**
     * generated from topsites.sponsored_enabled
     */
    /**
     * Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
     * Shortcuts" section. Corresponds to the value of the
     * `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
     * even if topsites.enabled is `false`.
     */
    constexpr impl::BooleanMetric sponsored_enabled(24);

    /**
     * generated from topsites.impression
     */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when topsite tiles are loaded.
     */
    constexpr impl::EventMetric<ImpressionExtra> impression(25);

    /**
     * generated from topsites.click
     */
    struct ClickExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
     */
    constexpr impl::EventMetric<ClickExtra> click(26);

}
namespace pocket {
    /**
     * generated from pocket.is_signed_in
     */
    /**
     * Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
     * so its value is resampled at newtab's component init and whenever there is a
     * Discovery Stream user event.
     */
    constexpr impl::BooleanMetric is_signed_in(27);

    /**
     * generated from pocket.enabled
     */
    /**
     * Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
     * section. Corresponds to the value of the `browser.newtabpage.activity-
     * stream.feeds.section.topstories` pref.
     */
    constexpr impl::BooleanMetric enabled(28);

    /**
     * generated from pocket.sponsored_stories_enabled
     */
    /**
     * Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
     * value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
     * `true` even if pocket.enabled is `false`.
     */
    constexpr impl::BooleanMetric sponsored_stories_enabled(29);

    /**
     * generated from pocket.impression
     */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a pocket tile is visible to the user.
     */
    constexpr impl::EventMetric<ImpressionExtra> impression(30);

    /**
     * generated from pocket.click
     */
    struct ClickExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
     * click. Not on "Open in new Tab"-like options in the context menu.
     */
    constexpr impl::EventMetric<ClickExtra> click(31);

    /**
     * generated from pocket.save
     */
    struct SaveExtra {
      mozilla::Maybe<bool> isSponsored;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<uint32_t> position;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isSponsored) {
          extraKeys.AppendElement()->AssignASCII("is_sponsored");
          extraValues.AppendElement()->AssignASCII(isSponsored.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (position) {
          extraKeys.AppendElement()->AssignASCII("position");
          extraValues.EmplaceBack(nsPrintfCString("%d", position.value()));
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a user decides to save a pocket tile. Does not mean it ends up
     * successfully saved. Just that the user clicked on "Save to Pocket" in the
     * little pocket tile menu.
     */
    constexpr impl::EventMetric<SaveExtra> save(32);

    /**
     * generated from pocket.topic_click
     */
    struct TopicClickExtra {
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> topic;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (topic) {
          extraKeys.AppendElement()->AssignASCII("topic");
          extraValues.EmplaceBack(topic.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
     * on middle-click. Not on "Open in new Tab"-like options in the context menu.
     */
    constexpr impl::EventMetric<TopicClickExtra> topic_click(33);

}
namespace newtab_search_ad {
    /**
     * generated from newtab.search.ad.impression
     */
    struct ImpressionExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a newtab visit resulted in a search that loaded a Search Engine
     * Result Page (SERP) that contains an ad link. And the SERP is visible.
     */
    constexpr impl::EventMetric<ImpressionExtra> impression(34);

    /**
     * generated from newtab.search.ad.click
     */
    struct ClickExtra {
      mozilla::Maybe<bool> isFollowOn;
      mozilla::Maybe<bool> isTagged;
      mozilla::Maybe<nsCString> newtabVisitId;
      mozilla::Maybe<nsCString> searchAccessPoint;
      mozilla::Maybe<nsCString> telemetryId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (isFollowOn) {
          extraKeys.AppendElement()->AssignASCII("is_follow_on");
          extraValues.AppendElement()->AssignASCII(isFollowOn.value() ? "true" : "false");
        }
        if (isTagged) {
          extraKeys.AppendElement()->AssignASCII("is_tagged");
          extraValues.AppendElement()->AssignASCII(isTagged.value() ? "true" : "false");
        }
        if (newtabVisitId) {
          extraKeys.AppendElement()->AssignASCII("newtab_visit_id");
          extraValues.EmplaceBack(newtabVisitId.value());
        }
        if (searchAccessPoint) {
          extraKeys.AppendElement()->AssignASCII("search_access_point");
          extraValues.EmplaceBack(searchAccessPoint.value());
        }
        if (telemetryId) {
          extraKeys.AppendElement()->AssignASCII("telemetry_id");
          extraValues.EmplaceBack(telemetryId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
     * was loaded by a seach that began on a newtab page.
     */
    constexpr impl::EventMetric<ClickExtra> click(35);

}
namespace serp {
    /**
     * generated from serp.impression
     */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> impressionId;
      mozilla::Maybe<nsCString> partnerCode;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> source;
      mozilla::Maybe<bool> tagged;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        if (partnerCode) {
          extraKeys.AppendElement()->AssignASCII("partner_code");
          extraValues.EmplaceBack(partnerCode.value());
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (source) {
          extraKeys.AppendElement()->AssignASCII("source");
          extraValues.EmplaceBack(source.value());
        }
        if (tagged) {
          extraKeys.AppendElement()->AssignASCII("tagged");
          extraValues.AppendElement()->AssignASCII(tagged.value() ? "true" : "false");
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a search engine results page (SERP) is shown to a user.
     */
    constexpr impl::EventMetric<ImpressionExtra> impression(36);

    /**
     * generated from serp.engagement
     */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> action;
      mozilla::Maybe<nsCString> impressionId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (action) {
          extraKeys.AppendElement()->AssignASCII("action");
          extraValues.EmplaceBack(action.value());
        }
        if (impressionId) {
          extraKeys.AppendElement()->AssignASCII("impression_id");
          extraValues.EmplaceBack(impressionId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded user actions on a SERP.
     */
    constexpr impl::EventMetric<EngagementExtra> engagement(37);

}
namespace urlbar {
    /**
     * generated from urlbar.abandonment
     */
    struct AbandonmentExtra {
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchMode;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when the user abandons a search (blurring the urlbar).
     */
    constexpr impl::EventMetric<AbandonmentExtra> abandonment(38);

    /**
     * generated from urlbar.engagement
     */
    struct EngagementExtra {
      mozilla::Maybe<nsCString> engagementType;
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> provider;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchMode;
      mozilla::Maybe<nsCString> selectedResult;
      mozilla::Maybe<nsCString> selectedResultSubtype;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (engagementType) {
          extraKeys.AppendElement()->AssignASCII("engagement_type");
          extraValues.EmplaceBack(engagementType.value());
        }
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (provider) {
          extraKeys.AppendElement()->AssignASCII("provider");
          extraValues.EmplaceBack(provider.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        if (selectedResult) {
          extraKeys.AppendElement()->AssignASCII("selected_result");
          extraValues.EmplaceBack(selectedResult.value());
        }
        if (selectedResultSubtype) {
          extraKeys.AppendElement()->AssignASCII("selected_result_subtype");
          extraValues.EmplaceBack(selectedResultSubtype.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when the user executes an action on a result.
     */
    constexpr impl::EventMetric<EngagementExtra> engagement(39);

    /**
     * generated from urlbar.impression
     */
    struct ImpressionExtra {
      mozilla::Maybe<nsCString> groups;
      mozilla::Maybe<nsCString> interaction;
      mozilla::Maybe<uint32_t> nChars;
      mozilla::Maybe<uint32_t> nResults;
      mozilla::Maybe<uint32_t> nWords;
      mozilla::Maybe<nsCString> reason;
      mozilla::Maybe<nsCString> results;
      mozilla::Maybe<nsCString> sap;
      mozilla::Maybe<nsCString> searchMode;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (groups) {
          extraKeys.AppendElement()->AssignASCII("groups");
          extraValues.EmplaceBack(groups.value());
        }
        if (interaction) {
          extraKeys.AppendElement()->AssignASCII("interaction");
          extraValues.EmplaceBack(interaction.value());
        }
        if (nChars) {
          extraKeys.AppendElement()->AssignASCII("n_chars");
          extraValues.EmplaceBack(nsPrintfCString("%d", nChars.value()));
        }
        if (nResults) {
          extraKeys.AppendElement()->AssignASCII("n_results");
          extraValues.EmplaceBack(nsPrintfCString("%d", nResults.value()));
        }
        if (nWords) {
          extraKeys.AppendElement()->AssignASCII("n_words");
          extraValues.EmplaceBack(nsPrintfCString("%d", nWords.value()));
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        if (results) {
          extraKeys.AppendElement()->AssignASCII("results");
          extraValues.EmplaceBack(results.value());
        }
        if (sap) {
          extraKeys.AppendElement()->AssignASCII("sap");
          extraValues.EmplaceBack(sap.value());
        }
        if (searchMode) {
          extraKeys.AppendElement()->AssignASCII("search_mode");
          extraValues.EmplaceBack(searchMode.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when urlbar results are shown to the user.
     */
    constexpr impl::EventMetric<ImpressionExtra> impression(40);

    /**
     * generated from urlbar.pref_max_results
     */
    /**
     * Maximum results to show in the Address Bar. Corresponds to the value of the
     * `browser.urlbar.maxRichResults` pref.
     */
    constexpr impl::QuantityMetric pref_max_results(41);

    /**
     * generated from urlbar.pref_suggest_topsites
     */
    /**
     * Whether topsite results are enabled in the urlbar. Corresponds to the value of
     * the `browser.urlbar.suggest.topsites` pref.
     */
    constexpr impl::BooleanMetric pref_suggest_topsites(42);

}
namespace browser_engagement {
    /**
     * generated from browser.engagement.active_ticks
     */
    /**
     * The number of five-second intervals ('ticks') the user was considered
     * 'active'.
     * 
     * 'active' means keyboard or mouse interaction with the application.
     * It doesn't take into account whether or not the window has focus or is in
     * the foreground, only if it is receiving these interaction events.
     * 
     * Migrated from Telemetry's `browser.engagement.active_ticks`.
     */
    constexpr impl::CounterMetric active_ticks(43);

    /**
     * generated from browser.engagement.uri_count
     */
    /**
     * The number of total non-unique http(s) URIs visited, including page
     * reloads, after the session has been restored. URIs on minimized or
     * background tabs may also be counted. Private browsing uris are included.
     * 
     * Migrated from Telemetry's
     * `browser.engagement.total_uri_count_normal_and_private_mode`.
     */
    constexpr impl::CounterMetric uri_count(44);

}
namespace ping_centre {
    /**
     * generated from ping.centre.send_failures
     */
    /**
     * The number of PingCentre send failures.
     */
    constexpr impl::CounterMetric send_failures(45);

    /**
     * generated from ping.centre.send_failures_by_namespace
     */
    /**
     * The number of PingCentre send failures,
     * broken down by structured ingestion namespace.
     */
    constexpr impl::Labeled<impl::CounterMetric> send_failures_by_namespace(46);

    /**
     * generated from ping.centre.send_successes_by_namespace
     */
    /**
     * The number of PingCentre send successes,
     * broken down by structured ingestion namespace.
     */
    constexpr impl::Labeled<impl::CounterMetric> send_successes_by_namespace(47);

}
namespace gmp {
    /**
     * generated from gmp.update_xml_fetch_result
     */
    /**
     * The result of Gecko fetching an update.xml from Balrog. This captures 3
     * different data points: success or failure of the request, if cert pinning or
     * content signatures were used to verify the result, and the reason for failure,
     * if the request failed.
     */
    constexpr impl::Labeled<impl::CounterMetric> update_xml_fetch_result(48);

}
namespace rtcrtpsender {
    /**
     * generated from rtcrtpsender.count
     */
    /**
     * The number of RTCRtpSenders created.
     */
    constexpr impl::DenominatorMetric count(49);

    /**
     * generated from rtcrtpsender.count_setparameters_compat
     */
    /**
     * The number of RTCRtpSenders created that use the compatibility mode for
     * setParameters.
     */
    constexpr impl::DenominatorMetric count_setparameters_compat(50);

    /**
     * generated from rtcrtpsender.used_sendencodings
     */
    /**
     * The proportion of RTCRtpSenders that were created by an addTransceivers call
     * that was passed a sendEncodings.
     */
    constexpr impl::NumeratorMetric used_sendencodings(51);

}
namespace rtcrtpsender_setparameters {
    /**
     * generated from rtcrtpsender.setparameters.warn_no_getparameters
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call because
     * [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
     * call to getParameters)
     */
    constexpr impl::NumeratorMetric warn_no_getparameters(52);

    /**
     * generated from rtcrtpsender.setparameters.warn_length_changed
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that attempted to
     * change the number of encodings.
     */
    constexpr impl::NumeratorMetric warn_length_changed(53);

    /**
     * generated from rtcrtpsender.setparameters.warn_rid_changed
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that attempted to
     * change the rid on an encoding (note that we only check this if the encoding
     * count did not change, see warn_length_changed).
     */
    constexpr impl::NumeratorMetric warn_rid_changed(54);

    /**
     * generated from rtcrtpsender.setparameters.warn_no_transactionid
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that did not set the
     * transactionId field.
     */
    constexpr impl::NumeratorMetric warn_no_transactionid(55);

    /**
     * generated from rtcrtpsender.setparameters.warn_stale_transactionid
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have warned at least once about a setParameters call that used a stale
     * transaction id.
     */
    constexpr impl::NumeratorMetric warn_stale_transactionid(56);

    /**
     * generated from rtcrtpsender.setparameters.fail_length_changed
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the number of encodings.
     */
    constexpr impl::NumeratorMetric fail_length_changed(57);

    /**
     * generated from rtcrtpsender.setparameters.fail_rid_changed
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that attempted to change the rid on an encoding (note that
     * we only check this if the encoding count did not change, see
     * fail_length_changed).
     */
    constexpr impl::NumeratorMetric fail_rid_changed(58);

    /**
     * generated from rtcrtpsender.setparameters.fail_no_getparameters
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call because [[LastReturnedParameters]] was not set. (ie; there
     * was not a recent enough call to getParameters)
     */
    constexpr impl::NumeratorMetric fail_no_getparameters(59);

    /**
     * generated from rtcrtpsender.setparameters.fail_no_transactionid
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that did not set the transactionId field.
     */
    constexpr impl::NumeratorMetric fail_no_transactionid(60);

    /**
     * generated from rtcrtpsender.setparameters.fail_stale_transactionid
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that used a stale transaction id.
     */
    constexpr impl::NumeratorMetric fail_stale_transactionid(61);

    /**
     * generated from rtcrtpsender.setparameters.fail_no_encodings
     */
    /**
     * The proportion of RTCRtpSenders configured with the setParameters compat mode
     * that have thrown an error at least once about a setParameters call that had no
     * encodings (we do not measure this against the general population of
     * RTCRtpSenders, since without the compat mode this failure is never observed,
     * because it fails the length change check).
     */
    constexpr impl::NumeratorMetric fail_no_encodings(62);

    /**
     * generated from rtcrtpsender.setparameters.fail_other
     */
    /**
     * The proportion of RTCRtpSenders that have thrown an error at least once about a
     * setParameters call that had no encodings.
     */
    constexpr impl::NumeratorMetric fail_other(63);

}
namespace perf {
    /**
     * generated from perf.page_load
     */
    struct PageLoadExtra {
      mozilla::Maybe<uint32_t> fcpTime;
      mozilla::Maybe<uint32_t> httpVer;
      mozilla::Maybe<uint32_t> jsExecTime;
      mozilla::Maybe<uint32_t> loadTime;
      mozilla::Maybe<nsCString> loadType;
      mozilla::Maybe<uint32_t> redirectCount;
      mozilla::Maybe<uint32_t> redirectTime;
      mozilla::Maybe<uint32_t> responseTime;
      mozilla::Maybe<bool> sameOriginNav;
      mozilla::Maybe<nsCString> trrDomain;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (fcpTime) {
          extraKeys.AppendElement()->AssignASCII("fcp_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", fcpTime.value()));
        }
        if (httpVer) {
          extraKeys.AppendElement()->AssignASCII("http_ver");
          extraValues.EmplaceBack(nsPrintfCString("%d", httpVer.value()));
        }
        if (jsExecTime) {
          extraKeys.AppendElement()->AssignASCII("js_exec_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", jsExecTime.value()));
        }
        if (loadTime) {
          extraKeys.AppendElement()->AssignASCII("load_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", loadTime.value()));
        }
        if (loadType) {
          extraKeys.AppendElement()->AssignASCII("load_type");
          extraValues.EmplaceBack(loadType.value());
        }
        if (redirectCount) {
          extraKeys.AppendElement()->AssignASCII("redirect_count");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectCount.value()));
        }
        if (redirectTime) {
          extraKeys.AppendElement()->AssignASCII("redirect_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", redirectTime.value()));
        }
        if (responseTime) {
          extraKeys.AppendElement()->AssignASCII("response_time");
          extraValues.EmplaceBack(nsPrintfCString("%d", responseTime.value()));
        }
        if (sameOriginNav) {
          extraKeys.AppendElement()->AssignASCII("same_origin_nav");
          extraValues.AppendElement()->AssignASCII(sameOriginNav.value() ? "true" : "false");
        }
        if (trrDomain) {
          extraKeys.AppendElement()->AssignASCII("trr_domain");
          extraValues.EmplaceBack(trrDomain.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a top level content document has been loaded.
     */
    constexpr impl::EventMetric<PageLoadExtra> page_load(64);

}
namespace paint {
    /**
     * generated from paint.build_displaylist_time
     */
    /**
     * The time to build a Gecko display list.
     */
    constexpr impl::TimingDistributionMetric build_displaylist_time(65);

}
namespace wr {
    /**
     * generated from wr.gpu_wait_time
     */
    /**
     * The time spent waiting for the GPU to complete previously issued drawing
     * commands.
     */
    constexpr impl::TimingDistributionMetric gpu_wait_time(66);

    /**
     * generated from wr.rasterize_glyphs_time
     */
    /**
     * The time to rasterize glyphs for consumption by WebRender.
     */
    constexpr impl::TimingDistributionMetric rasterize_glyphs_time(67);

    /**
     * generated from wr.rasterize_blobs_time
     */
    /**
     * The time to rasterize blobs for consumption by WebRender.
     */
    constexpr impl::TimingDistributionMetric rasterize_blobs_time(68);

    /**
     * generated from wr.renderer_time
     */
    /**
     * WebRender renderer time.
     */
    constexpr impl::TimingDistributionMetric renderer_time(69);

    /**
     * generated from wr.renderer_time_no_sc
     */
    /**
     * WebRender renderer time excluding frames in which shader compilation took
     * place.
     */
    constexpr impl::TimingDistributionMetric renderer_time_no_sc(70);

    /**
     * generated from wr.framebuild_time
     */
    /**
     * The time to rasterize glyphs for consumption by WebRender.
     */
    constexpr impl::TimingDistributionMetric framebuild_time(71);

    /**
     * generated from wr.scenebuild_time
     */
    /**
     * WebRender scene build time.
     */
    constexpr impl::TimingDistributionMetric scenebuild_time(72);

    /**
     * generated from wr.sceneswap_time
     */
    /**
     * WebRender scene swap time.
     */
    constexpr impl::TimingDistributionMetric sceneswap_time(73);

    /**
     * generated from wr.texture_cache_update_time
     */
    /**
     * Time taken by WebRender to update the texture cache.
     */
    constexpr impl::TimingDistributionMetric texture_cache_update_time(74);

    /**
     * generated from wr.time_to_frame_build
     */
    /**
     * Time elapsed between the construction of a transaction and the associated frame
     * build beginning.
     */
    constexpr impl::TimingDistributionMetric time_to_frame_build(75);

    /**
     * generated from wr.time_to_render_start
     */
    /**
     * Time elapsed between the construction of a frame and the start of rendering.
     */
    constexpr impl::TimingDistributionMetric time_to_render_start(76);

}
namespace netwerk {
    /**
     * generated from netwerk.early_hints
     */
    /**
     * Counts the different type of resources that are sent for early hints.
     */
    constexpr impl::Labeled<impl::CounterMetric> early_hints(77);

    /**
     * generated from netwerk.eh_link_type
     */
    /**
     * Counts different type of link headers that are sent in early hint
     */
    constexpr impl::Labeled<impl::CounterMetric> eh_link_type(78);

}
namespace network {
    /**
     * generated from network.data_size_per_type
     */
    /**
     * Number of KB we transferred keyed by "contentType"
     */
    constexpr impl::Labeled<impl::CounterMetric> data_size_per_type(79);

    /**
     * generated from network.data_size_pb_per_type
     */
    /**
     * Number of KB we transferred keyed by "contentType"
     */
    constexpr impl::Labeled<impl::CounterMetric> data_size_pb_per_type(80);

}
namespace background_tasks_rmdir_base {
    /**
     * generated from background_tasks.rmdir.base.metric_base
     */
    /**
     * The base metric template for removeDirectory.
     */
    constexpr impl::EventMetric<NoExtraKeys> metric_base(81);

    /**
     * generated from background_tasks.rmdir.base.elapsed_ms
     */
    /**
     * The amount of time the task took for removing the directories.
     */
    constexpr impl::QuantityMetric elapsed_ms(82);

    /**
     * generated from background_tasks.rmdir.base.was_first
     */
    /**
     * Whether this task is the first one removing the directory.
     */
    constexpr impl::BooleanMetric was_first(83);

    /**
     * generated from background_tasks.rmdir.base.retry_count
     */
    /**
     * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
     */
    constexpr impl::QuantityMetric retry_count(84);

    /**
     * generated from background_tasks.rmdir.base.removal_count
     */
    /**
     * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
     */
    constexpr impl::QuantityMetric removal_count(85);

    /**
     * generated from background_tasks.rmdir.base.succeeded
     */
    /**
     * Whether the target directory removal succeeded.
     */
    constexpr impl::BooleanMetric succeeded(86);

    /**
     * generated from background_tasks.rmdir.base.suffix_removal_count
     */
    /**
     * The number of the removed entries of the suffixed directories.
     */
    constexpr impl::QuantityMetric suffix_removal_count(87);

    /**
     * generated from background_tasks.rmdir.base.suffix_ever_failed
     */
    /**
     * Whether removing the suffixed directories ever failed.
     */
    constexpr impl::BooleanMetric suffix_ever_failed(88);

}
namespace background_tasks_rmdir_quota {
    /**
     * generated from background_tasks.rmdir.quota.metric_base
     */
    /**
     * The base metric template for removeDirectory.
     */
    constexpr impl::EventMetric<NoExtraKeys> metric_base(89);

    /**
     * generated from background_tasks.rmdir.quota.elapsed_ms
     */
    /**
     * The amount of time the task took for removing the directories.
     */
    constexpr impl::QuantityMetric elapsed_ms(90);

    /**
     * generated from background_tasks.rmdir.quota.was_first
     */
    /**
     * Whether this task is the first one removing the directory.
     */
    constexpr impl::BooleanMetric was_first(91);

    /**
     * generated from background_tasks.rmdir.quota.retry_count
     */
    /**
     * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
     */
    constexpr impl::QuantityMetric retry_count(92);

    /**
     * generated from background_tasks.rmdir.quota.removal_count
     */
    /**
     * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
     */
    constexpr impl::QuantityMetric removal_count(93);

    /**
     * generated from background_tasks.rmdir.quota.succeeded
     */
    /**
     * Whether the target directory removal succeeded.
     */
    constexpr impl::BooleanMetric succeeded(94);

    /**
     * generated from background_tasks.rmdir.quota.suffix_removal_count
     */
    /**
     * The number of the removed entries of the suffixed directories.
     */
    constexpr impl::QuantityMetric suffix_removal_count(95);

    /**
     * generated from background_tasks.rmdir.quota.suffix_ever_failed
     */
    /**
     * Whether removing the suffixed directories ever failed.
     */
    constexpr impl::BooleanMetric suffix_ever_failed(96);

}
namespace background_tasks_rmdir_http_cache {
    /**
     * generated from background_tasks.rmdir.http_cache.metric_base
     */
    /**
     * The base metric template for removeDirectory.
     */
    constexpr impl::EventMetric<NoExtraKeys> metric_base(97);

    /**
     * generated from background_tasks.rmdir.http_cache.elapsed_ms
     */
    /**
     * The amount of time the task took for removing the directories.
     */
    constexpr impl::QuantityMetric elapsed_ms(98);

    /**
     * generated from background_tasks.rmdir.http_cache.was_first
     */
    /**
     * Whether this task is the first one removing the directory.
     */
    constexpr impl::BooleanMetric was_first(99);

    /**
     * generated from background_tasks.rmdir.http_cache.retry_count
     */
    /**
     * The number of retries before the task started removing the child directory.
     * This can happen when the target directory doesn't exist.
     */
    constexpr impl::QuantityMetric retry_count(100);

    /**
     * generated from background_tasks.rmdir.http_cache.removal_count
     */
    /**
     * The number of the removed entries at each call, even if the target directory
     * itself couldn't be removed.
     */
    constexpr impl::QuantityMetric removal_count(101);

    /**
     * generated from background_tasks.rmdir.http_cache.succeeded
     */
    /**
     * Whether the target directory removal succeeded.
     */
    constexpr impl::BooleanMetric succeeded(102);

    /**
     * generated from background_tasks.rmdir.http_cache.suffix_removal_count
     */
    /**
     * The number of the removed entries of the suffixed directories.
     */
    constexpr impl::QuantityMetric suffix_removal_count(103);

    /**
     * generated from background_tasks.rmdir.http_cache.suffix_ever_failed
     */
    /**
     * Whether removing the suffixed directories ever failed.
     */
    constexpr impl::BooleanMetric suffix_ever_failed(104);

}
namespace cookie_banners {
    /**
     * generated from cookie.banners.normal_window_service_mode
     */
    /**
     * The pref value of the cookie banner service mode for normal windows.
     */
    constexpr impl::Labeled<impl::BooleanMetric> normal_window_service_mode(105);

    /**
     * generated from cookie.banners.private_window_service_mode
     */
    /**
     * The pref value of the cookie banner service mode for private windows.
     */
    constexpr impl::Labeled<impl::BooleanMetric> private_window_service_mode(106);

    /**
     * generated from cookie.banners.service_detect_only
     */
    /**
     * Tracks the value of the cookiebanners.service.detectOnly pref.
     */
    constexpr impl::BooleanMetric service_detect_only(107);

    /**
     * generated from cookie.banners.rule_lookup_by_load
     */
    /**
     * Counts the number of hit/miss of cookie banner rule lookups for every load. We
     * collect three types of counters, including counters for overall rule lookup,
     * counters for cookie rule lookup and counters for click rule lookup. We also
     * divide the counter by top-level loads and iframe loads.
     */
    constexpr impl::Labeled<impl::CounterMetric> rule_lookup_by_load(108);

    /**
     * generated from cookie.banners.rule_lookup_by_domain
     */
    /**
     * Counts the number of hit/miss of cookie banner rule lookups for domain. We
     * collect three types of counters, including counters for overall rule lookup,
     * counters for cookie rule lookup and counters for click rule lookup. We also
     * divide the counter by top-level loads and iframe loads. For each domain, we
     * will only collect once.
     */
    constexpr impl::Labeled<impl::CounterMetric> rule_lookup_by_domain(109);

    /**
     * generated from cookie.banners.reload
     */
    struct ReloadExtra {
      mozilla::Maybe<bool> hasClickRule;
      mozilla::Maybe<bool> hasCookieRule;
      mozilla::Maybe<bool> noRule;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (hasClickRule) {
          extraKeys.AppendElement()->AssignASCII("has_click_rule");
          extraValues.AppendElement()->AssignASCII(hasClickRule.value() ? "true" : "false");
        }
        if (hasCookieRule) {
          extraKeys.AppendElement()->AssignASCII("has_cookie_rule");
          extraValues.AppendElement()->AssignASCII(hasCookieRule.value() ? "true" : "false");
        }
        if (noRule) {
          extraKeys.AppendElement()->AssignASCII("no_rule");
          extraValues.AppendElement()->AssignASCII(noRule.value() ? "true" : "false");
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when the top-level page is reloaded. We use this event metric to know
     * whether or not the reloading domain has cookie banner rule.
     */
    constexpr impl::EventMetric<ReloadExtra> reload(110);

}
namespace cookie_banners_click {
    /**
     * generated from cookie.banners.click.handle_duration
     */
    /**
     * Counts how long it takes to handle cookie banners successfully from
     * DOMContentLoaded until click.
     */
    constexpr impl::TimingDistributionMetric handle_duration(111);

    /**
     * generated from cookie.banners.click.result
     */
    /**
     * Given a matching cookie banner click rule, how often do we handle or fail to
     * handle cookie banners, labelled by reason. The 'success' and 'fail' counters
     * count the total numbers independently of the reason counters. Counters are
     * incremented after the content window has been destroyed.
     */
    constexpr impl::Labeled<impl::CounterMetric> result(112);

}
namespace crash {
    /**
     * generated from crash.uptime
     */
    /**
     * The application uptime. This is equivalent to the legacy crash ping's
     * `UptimeTS` field.
     */
    constexpr impl::TimespanMetric uptime(113);

    /**
     * generated from crash.process_type
     */
    /**
     * The type of process that experienced a crash. See the full list of options
     * [here](https://firefox-source-
     * docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
     * types).
     */
    constexpr impl::StringMetric process_type(114);

    /**
     * generated from crash.time
     */
    /**
     * The time at which the crash occurred.
     */
    constexpr impl::DatetimeMetric time(115);

    /**
     * generated from crash.startup
     */
    /**
     * If true, the crash occurred during process startup.
     */
    constexpr impl::BooleanMetric startup(116);

}
namespace extensions {
    /**
     * generated from extensions.startup_cache_load_time
     */
    /**
     * Time to load and deserialize the extensions startupCache data.
     */
    constexpr impl::TimespanMetric startup_cache_load_time(117);

}
namespace fog {
    /**
     * generated from fog.initialization
     */
    /**
     * Time the FOG initialization takes.
     */
    constexpr impl::TimespanMetric initialization(118);

    /**
     * generated from fog.failed_idle_registration
     */
    /**
     * True if we failed to register with the idle service. Absent otherwise.
     * Means IPC probably isn't working well.
     * Child-process data will likely be absent, or incomplete.
     */
    constexpr impl::BooleanMetric failed_idle_registration(119);

}
namespace fog_ipc {
    /**
     * generated from fog.ipc.replay_failures
     */
    /**
     * The number of times the ipc buffer failed to be replayed in the
     * parent process.
     */
    constexpr impl::CounterMetric replay_failures(120);

    /**
     * generated from fog.ipc.buffer_sizes
     */
    /**
     * The number and size of the IPC buffers being received over FOG IPC.
     */
    constexpr impl::MemoryDistributionMetric buffer_sizes(121);

    /**
     * generated from fog.ipc.flush_durations
     */
    /**
     * The length of time between asking the child processes for their
     * IPC buffers and all of them being received by the parent.
     */
    constexpr impl::TimingDistributionMetric flush_durations(122);

    /**
     * generated from fog.ipc.flush_failures
     */
    /**
     * The number of times we failed to flush all non-parent-process data,
     * throwing even partial results into the trash.
     * If this number is high, we might consider writing custom `MozPromise`-
     * handling code instead of using `MozPromise::All`.
     */
    constexpr impl::CounterMetric flush_failures(123);

    /**
     * generated from fog.ipc.shutdown_registration_failures
     */
    /**
     * The number of times we tried to register shutdown flush routines for
     * content child processes, and failed (probably because there was no main
     * thread).
     * As a result there may be data loss from content child processes.
     * Large or rising number of clients experiencing this indicates we should
     * perhaps refactor content child shutdown in FOG to try harder to register
     * flush operations.
     * Will likely be obsoleted by bug 1641989.
     */
    constexpr impl::CounterMetric shutdown_registration_failures(124);

}
namespace server_knobs {
    /**
     * generated from server_knobs.validation
     */
    /**
     * This is a temporary event intented to be used to validate the Glean
     * Server Knobs capabilities. See Bug 1811561 for more information.
     */
    constexpr impl::EventMetric<NoExtraKeys> validation(125);

}
namespace test_only {
    /**
     * generated from test_only.bad_code
     */
    /**
     * Number of times we encountered bad code.
     * This is a test-only metric.
     */
    constexpr impl::CounterMetric bad_code(126);

    /**
     * generated from test_only.can_we_time_it
     */
    /**
     * Test metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric can_we_time_it(127);

    /**
     * generated from test_only.cheesy_string
     */
    /**
     * Only the cheesiest of strings.
     * This is a test-only metric.
     */
    constexpr impl::StringMetric cheesy_string(128);

    /**
     * generated from test_only.cheesy_string_list
     */
    /**
     * Only the cheesiest of strings. In list form!
     * This is a test-only metric.
     */
    constexpr impl::StringListMetric cheesy_string_list(129);

    /**
     * generated from test_only.what_a_date
     */
    /**
     * ...To be writing FOG code. This is a test-only metric.
     */
    constexpr impl::DatetimeMetric what_a_date(130);

    /**
     * generated from test_only.what_id_it
     */
    /**
     * Just a UUID.
     * This is a test-only metric.
     */
    constexpr impl::UuidMetric what_id_it(131);

    /**
     * generated from test_only.can_we_flag_it
     */
    /**
     * Test metric for a boolean.
     * This is a test-only metric.
     */
    constexpr impl::BooleanMetric can_we_flag_it(132);

    /**
     * generated from test_only.do_you_remember
     */
    /**
     * They say it's the second thing to go.
     * This is a test-only metric.
     */
    constexpr impl::MemoryDistributionMetric do_you_remember(133);

    /**
     * generated from test_only.what_time_is_it
     */
    /**
     * Adheres to at least two of the top ten fallacies programmers believe
     * about time.
     * This is a test-only metric.
     */
    constexpr impl::TimingDistributionMetric what_time_is_it(134);

    /**
     * generated from test_only.mabels_kitchen_counters
     */
    /**
     * Counts Mabels labeled by their kitchen counters.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::CounterMetric> mabels_kitchen_counters(135);

    /**
     * generated from test_only.mabels_bathroom_counters
     */
    /**
     * Counts Mabels labeled by their bathroom counters.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::CounterMetric> mabels_bathroom_counters(136);

    /**
     * generated from test_only.mabels_like_balloons
     */
    /**
     * Does the labeled Mabel like balloons?
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::BooleanMetric> mabels_like_balloons(137);

    /**
     * generated from test_only.mabels_balloon_strings
     */
    /**
     * What do the labeled Mabel's liked balloons' strings say?
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::StringMetric> mabels_balloon_strings(138);

    /**
     * generated from test_only.mabels_label_maker
     */
    /**
     * Mabel just got a label maker and wants to party like it's
     * 1999.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::StringMetric> mabels_label_maker(139);

    /**
     * generated from test_only.mirror_time
     */
    /**
     * Mirrored metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric mirror_time(140);

    /**
     * generated from test_only.mirror_time_nanos
     */
    /**
     * Mirrored metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric mirror_time_nanos(141);

    /**
     * generated from test_only.mirrors_for_labeled_bools
     */
    /**
     * Mirrored metric.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::BooleanMetric> mirrors_for_labeled_bools(142);

    /**
     * generated from test_only.one_ping_one_bool
     */
    /**
     * One bool for one ping only.
     * This is a test-only metric.
     */
    constexpr impl::BooleanMetric one_ping_one_bool(143);

    /**
     * generated from test_only.meaning_of_life
     */
    /**
     * Measures the one true answer to the Ultimate Question of Life,
     * the Universe, and Everything.
     * Approximately.
     * This is a test-only metric.
     */
    constexpr impl::QuantityMetric meaning_of_life(144);

}
namespace test_only_ipc {
    /**
     * generated from test_only.ipc.a_counter
     */
    /**
     * This is a test-only metric.
     * Just counting things.
     */
    constexpr impl::CounterMetric a_counter(145);

    /**
     * generated from test_only.ipc.a_bool
     */
    /**
     * This is a test-only metric.
     * Just flagging things.
     */
    constexpr impl::BooleanMetric a_bool(146);

    /**
     * generated from test_only.ipc.a_date
     */
    /**
     * This is a test-only metric.
     * Just putting things on the calendar.
     */
    constexpr impl::DatetimeMetric a_date(147);

    /**
     * generated from test_only.ipc.a_string
     */
    /**
     * This is a test-only metric.
     * Just setting some strings.
     */
    constexpr impl::StringMetric a_string(148);

    /**
     * generated from test_only.ipc.a_memory_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring memory.
     */
    constexpr impl::MemoryDistributionMetric a_memory_dist(149);

    /**
     * generated from test_only.ipc.a_timing_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring time.
     */
    constexpr impl::TimingDistributionMetric a_timing_dist(150);

    /**
     * generated from test_only.ipc.a_custom_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring samples.
     */
    constexpr impl::CustomDistributionMetric a_custom_dist(151);

    /**
     * generated from test_only.ipc.a_string_list
     */
    /**
     * This is a test-only metric.
     * Just appending some strings.
     */
    constexpr impl::StringListMetric a_string_list(152);

    /**
     * generated from test_only.ipc.an_event
     */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This is a test-only metric.
     * Just recording some events.
     */
    constexpr impl::EventMetric<AnEventExtra> an_event(153);

    /**
     * generated from test_only.ipc.event_with_extra
     */
    struct EventWithExtraExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<uint32_t> extra2;
      mozilla::Maybe<bool> extra3LongerName;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(nsPrintfCString("%d", extra2.value()));
        }
        if (extra3LongerName) {
          extraKeys.AppendElement()->AssignASCII("extra3_longer_name");
          extraValues.AppendElement()->AssignASCII(extra3LongerName.value() ? "true" : "false");
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This is a test-only metric.
     * Just recording some events.
     */
    constexpr impl::EventMetric<EventWithExtraExtra> event_with_extra(154);

    /**
     * generated from test_only.ipc.no_extra_event
     */
    /**
     * This is a test-only metric.
     * Just recording some events without the extra fuss.
     */
    constexpr impl::EventMetric<NoExtraKeys> no_extra_event(155);

    /**
     * generated from test_only.ipc.a_uuid
     */
    /**
     * This is a test-only metric.
     * Just recording some unique identifiers.
     */
    constexpr impl::UuidMetric a_uuid(156);

    /**
     * generated from test_only.ipc.a_labeled_counter
     */
    /**
     * This is a test-only metric.
     * Just counting labeled things.
     */
    constexpr impl::Labeled<impl::CounterMetric> a_labeled_counter(157);

    /**
     * generated from test_only.ipc.another_labeled_counter
     */
    /**
     * This is a test-only metric.
     * Just another metric counting labeled things.
     */
    constexpr impl::Labeled<impl::CounterMetric> another_labeled_counter(158);

    /**
     * generated from test_only.ipc.a_quantity
     */
    /**
     * This is a test-only metric.
     * Just quantifying things.
     */
    constexpr impl::QuantityMetric a_quantity(159);

    /**
     * generated from test_only.ipc.irate
     */
    /**
     * This is a test-only metric.
     * A rate that isn't happy about it.
     */
    constexpr impl::RateMetric irate(160);

    /**
     * generated from test_only.ipc.rate_with_external_denominator
     */
    /**
     * This is a test-only metric.
     * A rate with a denominator that is Out There.
     */
    constexpr impl::NumeratorMetric rate_with_external_denominator(161);

    /**
     * generated from test_only.ipc.an_external_denominator
     */
    /**
     * This is a test-only metric.
     * A denominator not from around here.
     */
    constexpr impl::DenominatorMetric an_external_denominator(162);

    /**
     * generated from test_only.ipc.a_url
     */
    /**
     * This is a test-only metric.
     * Just setting some Urls.
     */
    constexpr impl::UrlMetric a_url(163);

}
namespace test_only_jog {
    /**
     * generated from test_only.jog.a_counter
     */
    /**
     * This is a test-only metric.
     * Just counting things.
     * Tied closely to test_jog_name_collision.
     */
    constexpr impl::CounterMetric a_counter(164);

    /**
     * generated from test_only.jog.an_event
     */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement()->AssignASCII("extra1");
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement()->AssignASCII("extra2");
          extraValues.EmplaceBack(extra2.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This is a test-only metric.
     * Just recording some events.
     * Tied closely to test_jog_name_collision.
     */
    constexpr impl::EventMetric<AnEventExtra> an_event(165);

}
namespace nimbus_events {
    /**
     * generated from nimbus_events.enrollment
     */
    struct EnrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentId;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> experimentType;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentId) {
          extraKeys.AppendElement()->AssignASCII("enrollment_id");
          extraValues.EmplaceBack(enrollmentId.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (experimentType) {
          extraKeys.AppendElement()->AssignASCII("experiment_type");
          extraValues.EmplaceBack(experimentType.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a user has met the conditions and is first bucketed into an
     * experiment (i.e. targeting matched and they were randomized into a bucket and
     * branch of the experiment). Expected a maximum of once per experiment per user.
     */
    constexpr impl::EventMetric<EnrollmentExtra> enrollment(166);

    /**
     * generated from nimbus_events.enroll_failed
     */
    struct EnrollFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when an enrollment fails, including the reason for the failure.
     */
    constexpr impl::EventMetric<EnrollFailedExtra> enroll_failed(167);

    /**
     * generated from nimbus_events.unenrollment
     */
    struct UnenrollmentExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> enrollmentId;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (enrollmentId) {
          extraKeys.AppendElement()->AssignASCII("enrollment_id");
          extraValues.EmplaceBack(enrollmentId.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when either telemetry is disabled, or the experiment has run for its
     * designed duration (i.e. it is no longer present in the Nimbus Remote Settings
     * collection)
     */
    constexpr impl::EventMetric<UnenrollmentExtra> unenrollment(168);

    /**
     * generated from nimbus_events.unenroll_failed
     */
    struct UnenrollFailedExtra {
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> reason;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when an unenrollment fails, including the reason for the failure.
     */
    constexpr impl::EventMetric<UnenrollFailedExtra> unenroll_failed(169);

    /**
     * generated from nimbus_events.exposure
     */
    struct ExposureExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> featureId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (featureId) {
          extraKeys.AppendElement()->AssignASCII("feature_id");
          extraValues.EmplaceBack(featureId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when a user actually observes an experimental treatment, or would have
     * observed an experimental treatment if they had been in a branch that would have
     * shown one.
     */
    constexpr impl::EventMetric<ExposureExtra> exposure(170);

    /**
     * generated from nimbus_events.validation_failed
     */
    struct ValidationFailedExtra {
      mozilla::Maybe<nsCString> branch;
      mozilla::Maybe<nsCString> experiment;
      mozilla::Maybe<nsCString> feature;
      mozilla::Maybe<nsCString> reason;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (branch) {
          extraKeys.AppendElement()->AssignASCII("branch");
          extraValues.EmplaceBack(branch.value());
        }
        if (experiment) {
          extraKeys.AppendElement()->AssignASCII("experiment");
          extraValues.EmplaceBack(experiment.value());
        }
        if (feature) {
          extraKeys.AppendElement()->AssignASCII("feature");
          extraValues.EmplaceBack(feature.value());
        }
        if (reason) {
          extraKeys.AppendElement()->AssignASCII("reason");
          extraValues.EmplaceBack(reason.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This records when validation of a recipe fails.
     */
    constexpr impl::EventMetric<ValidationFailedExtra> validation_failed(171);

}
namespace pdfjs {
    /**
     * generated from pdfjs.editing
     */
    /**
     * Counts the number of times some PDF editing features are used.
     */
    constexpr impl::Labeled<impl::CounterMetric> editing(172);

    /**
     * generated from pdfjs.buttons
     */
    /**
     * Counts the number of times some actions are executed in the PDF viewer.
     */
    constexpr impl::Labeled<impl::CounterMetric> buttons(173);

    /**
     * generated from pdfjs.used
     */
    /**
     * How many times PDF Viewer was used.
     */
    constexpr impl::CounterMetric used(174);

    /**
     * generated from pdfjs.time_to_view
     */
    /**
     * Time spent to display first page in PDF Viewer (ms).
     */
    constexpr impl::CustomDistributionMetric time_to_view(175);

}
namespace power {
    /**
     * generated from power.cpu_time_bogus_values
     */
    /**
     * Impossibly large CPU time values that were discarded.
     */
    constexpr impl::CounterMetric cpu_time_bogus_values(176);

    /**
     * generated from power.cpu_time_per_process_type_ms
     */
    /**
     * CPU time used by each process type in ms.
     */
    constexpr impl::Labeled<impl::CounterMetric> cpu_time_per_process_type_ms(177);

    /**
     * generated from power.cpu_time_per_tracker_type_ms
     */
    /**
     * CPU time used by content processes used only for tracking resources, labeled by
     * the category of the tracker.
     */
    constexpr impl::Labeled<impl::CounterMetric> cpu_time_per_tracker_type_ms(178);

    /**
     * generated from power.gpu_time_per_process_type_ms
     */
    /**
     * GPU time used by each process type in ms.
     */
    constexpr impl::Labeled<impl::CounterMetric> gpu_time_per_process_type_ms(179);

    /**
     * generated from power.gpu_time_bogus_values
     */
    /**
     * Impossibly large GPU time values that were discarded.
     */
    constexpr impl::CounterMetric gpu_time_bogus_values(180);

    /**
     * generated from power.wakeups_per_process_type
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> wakeups_per_process_type(181);

    /**
     * generated from power.total_cpu_time_ms
     */
    /**
     * Total CPU time used by all processes in ms.
     */
    constexpr impl::CounterMetric total_cpu_time_ms(182);

    /**
     * generated from power.total_gpu_time_ms
     */
    /**
     * Total GPU time used by all processes in ms.
     */
    constexpr impl::CounterMetric total_gpu_time_ms(183);

    /**
     * generated from power.total_thread_wakeups
     */
    /**
     * How many times threads woke up and could have woken up a CPU core.
     */
    constexpr impl::CounterMetric total_thread_wakeups(184);

}
namespace power_wakeups_per_thread {
    /**
     * generated from power.wakeups_per_thread.parent_active
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> parent_active(185);

    /**
     * generated from power.wakeups_per_thread.parent_inactive
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> parent_inactive(186);

    /**
     * generated from power.wakeups_per_thread.content_foreground
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> content_foreground(187);

    /**
     * generated from power.wakeups_per_thread.content_background
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> content_background(188);

    /**
     * generated from power.wakeups_per_thread.gpu_process
     */
    /**
     * How many times threads woke up and could have woken up a CPU core. Broken down
     * by thread name for a given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> gpu_process(189);

}
namespace power_cpu_ms_per_thread {
    /**
     * generated from power.cpu_ms_per_thread.parent_active
     */
    /**
     * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> parent_active(190);

    /**
     * generated from power.cpu_ms_per_thread.parent_inactive
     */
    /**
     * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> parent_inactive(191);

    /**
     * generated from power.cpu_ms_per_thread.content_foreground
     */
    /**
     * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> content_foreground(192);

    /**
     * generated from power.cpu_ms_per_thread.content_background
     */
    /**
     * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> content_background(193);

    /**
     * generated from power.cpu_ms_per_thread.gpu_process
     */
    /**
     * How many miliseconds of CPU time were used. Broken down by thread name for a
     * given process type.
     */
    constexpr impl::Labeled<impl::CounterMetric> gpu_process(194);

}
namespace power_battery {
    /**
     * generated from power.battery.percentage_when_user_active
     */
    /**
     * Records how many percent of battery was available for each period of user
     * activity.
     */
    constexpr impl::CustomDistributionMetric percentage_when_user_active(195);

}
namespace search_engine_default {
    /**
     * generated from search.engine.default.engine_id
     */
    /**
     * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
     */
    constexpr impl::StringMetric engine_id(196);

    /**
     * generated from search.engine.default.display_name
     */
    /**
     * The display name of the user's default engine.
     */
    constexpr impl::StringMetric display_name(197);

    /**
     * generated from search.engine.default.load_path
     */
    /**
     * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
     */
    constexpr impl::StringMetric load_path(198);

    /**
     * generated from search.engine.default.submission_url
     */
    /**
     * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
     */
    constexpr impl::UrlMetric submission_url(199);

    /**
     * generated from search.engine.default.verified
     */
    /**
     * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
     */
    constexpr impl::StringMetric verified(200);

    /**
     * generated from search.engine.default.changed
     */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when the default search engine is changed.
     */
    constexpr impl::EventMetric<ChangedExtra> changed(201);

}
namespace search_engine_private {
    /**
     * generated from search.engine.private.engine_id
     */
    /**
     * The telemetry id of the search engine.
     * For application provided engines, this is either supplied by the
     * configuration or from the first part of the associated WebExtension Id.
     * For other engines, this is `other-<extensionName>`.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
     */
    constexpr impl::StringMetric engine_id(202);

    /**
     * generated from search.engine.private.display_name
     */
    /**
     * The display name of the user's default engine.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
     */
    constexpr impl::StringMetric display_name(203);

    /**
     * generated from search.engine.private.load_path
     */
    /**
     * A path relating to where the search engine was installed/loaded from.
     * For example:
     *   `[addon]<extension id>` for a WebExtension based
     *   engine.
     *   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
     *   engine.
     * Note: this metric is truncated at 100 characters.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
     */
    constexpr impl::StringMetric load_path(204);

    /**
     * generated from search.engine.private.submission_url
     */
    /**
     * The submission URL of the default engine. This is only reported in the
     * cases where:
     *   The engine is an application provided engine.
     *   The engine has the same name as an application provided engine.
     *   The engine matches one of a specific list of well known search engines.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
     */
    constexpr impl::UrlMetric submission_url(205);

    /**
     * generated from search.engine.private.verified
     */
    /**
     * The verified status of the search engine.
     * For application provided engines, this will always be `default`.
     * For other engines this will either be `verified` or `unverified` depending
     * on if the loadPathHash is valid.
     * If this string is an empty string (`""`), this means that one or both of
     * the preferences `browser.search.separatePrivateDefault` and
     * `browser.search.separatePrivateDefault.ui.enabled` are set to false.
     * It is possible that the user selects the same private engine as for the
     * default engine, and hence both versions of these fields will be filled in.
     */
    constexpr impl::StringMetric verified(206);

    /**
     * generated from search.engine.private.changed
     */
    struct ChangedExtra {
      mozilla::Maybe<nsCString> changeSource;
      mozilla::Maybe<nsCString> newDisplayName;
      mozilla::Maybe<nsCString> newEngineId;
      mozilla::Maybe<nsCString> newLoadPath;
      mozilla::Maybe<nsCString> newSubmissionUrl;
      mozilla::Maybe<nsCString> previousEngineId;

      Tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<nsCString> extraKeys;
        nsTArray<nsCString> extraValues;
        if (changeSource) {
          extraKeys.AppendElement()->AssignASCII("change_source");
          extraValues.EmplaceBack(changeSource.value());
        }
        if (newDisplayName) {
          extraKeys.AppendElement()->AssignASCII("new_display_name");
          extraValues.EmplaceBack(newDisplayName.value());
        }
        if (newEngineId) {
          extraKeys.AppendElement()->AssignASCII("new_engine_id");
          extraValues.EmplaceBack(newEngineId.value());
        }
        if (newLoadPath) {
          extraKeys.AppendElement()->AssignASCII("new_load_path");
          extraValues.EmplaceBack(newLoadPath.value());
        }
        if (newSubmissionUrl) {
          extraKeys.AppendElement()->AssignASCII("new_submission_url");
          extraValues.EmplaceBack(newSubmissionUrl.value());
        }
        if (previousEngineId) {
          extraKeys.AppendElement()->AssignASCII("previous_engine_id");
          extraValues.EmplaceBack(previousEngineId.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * Recorded when the default search engine is changed
     */
    constexpr impl::EventMetric<ChangedExtra> changed(207);

}
namespace dap {
    /**
     * generated from dap.upload_status
     */
    /**
     * The result of trying to upload a report to the DAP server.
     */
    constexpr impl::Labeled<impl::CounterMetric> upload_status(208);

    /**
     * generated from dap.report_generation_status
     */
    /**
     * The result of trying to generate a DAP report.
     */
    constexpr impl::Labeled<impl::CounterMetric> report_generation_status(209);

}
namespace legacy_telemetry {
    /**
     * generated from legacy.telemetry.client_id
     */
    /**
     * The client_id according to Telemetry.
     * Might not always have a value due to being too early for it to have
     * loaded.
     * Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
     * in pings near when the data upload pref is disabled (if Telemetry gets
     * to go first), or between when a client_id has been removed and when it
     * has been regenerated.
     * Does not need to be sent in the Glean "deletion-request" ping.
     */
    constexpr impl::UuidMetric client_id(210);

}
namespace first_startup {
    /**
     * generated from first_startup.status_code
     */
    /**
     * Status of the FirstStartup service, which runs
     * post-install/early-startup in Firefox.
     */
    constexpr impl::QuantityMetric status_code(211);

    /**
     * generated from first_startup.elapsed
     */
    /**
     * Number of milliseconds the FirstStartup service took to run.
     */
    constexpr impl::QuantityMetric elapsed(212);

}
namespace update {
    /**
     * generated from update.service_enabled
     */
    /**
     * Preference "app.update.service.enabled": whether the Mozilla Maintenance
     * Service is enabled.
     */
    constexpr impl::BooleanMetric service_enabled(213);

    /**
     * generated from update.auto_download
     */
    /**
     * Per-installation preference "app.update.auto": whether to fetch and install
     * updates without user intervention.
     */
    constexpr impl::BooleanMetric auto_download(214);

    /**
     * generated from update.background_update
     */
    /**
     * Per-installation preference "app.update.background.enabled": whether to fetch
     * and install updates in the background when Firefox is not running.
     */
    constexpr impl::BooleanMetric background_update(215);

    /**
     * generated from update.enabled
     */
    /**
     * True when policies are disabled or when the "DisableAppUpdate" is not in
     * effect.
     */
    constexpr impl::BooleanMetric enabled(216);

    /**
     * generated from update.channel
     */
    /**
     * The update channel.
     */
    constexpr impl::StringMetric channel(217);

    /**
     * generated from update.can_usually_apply_updates
     */
    /**
     * Whether or not the Update Service can usually download and install updates. See
     * `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_apply_updates(218);

    /**
     * generated from update.can_usually_check_for_updates
     */
    /**
     * Whether or not the Update Service can usually check for updates. See
     * `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_check_for_updates(219);

    /**
     * generated from update.can_usually_stage_updates
     */
    /**
     * Whether the Update Service is usually able to stage updates. See
     * `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_stage_updates(220);

    /**
     * generated from update.can_usually_use_bits
     */
    /**
     * On Windows, whether the Update Service can usually use BITS. See
     * `canUsuallyUseBits` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_use_bits(221);

}
namespace timer_thread {
    /**
     * generated from timer_thread.timers_fired_per_wakeup
     */
    /**
     * How many timers were processed in a single wake-up of the Timer Thread.
     */
    constexpr impl::CustomDistributionMetric timers_fired_per_wakeup(222);

}

} // namespace mozilla::glean

#endif // mozilla_Metrics_h
