#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSFontPaletteValuesRule" "\0"
  /*   974 */ "CSSGroupingRule" "\0"
  /*   990 */ "CSSImportRule" "\0"
  /*  1004 */ "CSSKeyframeRule" "\0"
  /*  1020 */ "CSSKeyframesRule" "\0"
  /*  1037 */ "CSSLayerBlockRule" "\0"
  /*  1055 */ "CSSLayerStatementRule" "\0"
  /*  1077 */ "CSSMediaRule" "\0"
  /*  1090 */ "CSSMozDocumentRule" "\0"
  /*  1109 */ "CSSNamespaceRule" "\0"
  /*  1126 */ "CSSPageRule" "\0"
  /*  1138 */ "CSSPseudoElement" "\0"
  /*  1155 */ "CSSRule" "\0"
  /*  1163 */ "CSSRuleList" "\0"
  /*  1175 */ "CSSStyleDeclaration" "\0"
  /*  1195 */ "CSSStyleRule" "\0"
  /*  1208 */ "CSSStyleSheet" "\0"
  /*  1222 */ "CSSSupportsRule" "\0"
  /*  1238 */ "CSSTransition" "\0"
  /*  1252 */ "Cache" "\0"
  /*  1258 */ "CacheStorage" "\0"
  /*  1271 */ "CallbackDebuggerNotification" "\0"
  /*  1300 */ "CanonicalBrowsingContext" "\0"
  /*  1325 */ "CanvasCaptureMediaStream" "\0"
  /*  1350 */ "CanvasGradient" "\0"
  /*  1365 */ "CanvasPattern" "\0"
  /*  1379 */ "CanvasRenderingContext2D" "\0"
  /*  1404 */ "CaretPosition" "\0"
  /*  1418 */ "CaretStateChangedEvent" "\0"
  /*  1441 */ "ChannelMergerNode" "\0"
  /*  1459 */ "ChannelSplitterNode" "\0"
  /*  1479 */ "ChannelWrapper" "\0"
  /*  1494 */ "CharacterData" "\0"
  /*  1508 */ "CheckerboardReportService" "\0"
  /*  1534 */ "ChildProcessMessageManager" "\0"
  /*  1561 */ "ChildSHistory" "\0"
  /*  1575 */ "ChromeMessageBroadcaster" "\0"
  /*  1600 */ "ChromeMessageSender" "\0"
  /*  1620 */ "ChromeNodeList" "\0"
  /*  1635 */ "ChromeUtils" "\0"
  /*  1647 */ "ChromeWorker" "\0"
  /*  1660 */ "Client" "\0"
  /*  1667 */ "Clients" "\0"
  /*  1675 */ "Clipboard" "\0"
  /*  1685 */ "ClipboardEvent" "\0"
  /*  1700 */ "ClipboardItem" "\0"
  /*  1714 */ "ClonedErrorHolder" "\0"
  /*  1732 */ "CloseEvent" "\0"
  /*  1743 */ "CommandEvent" "\0"
  /*  1756 */ "Comment" "\0"
  /*  1764 */ "CompositionEvent" "\0"
  /*  1781 */ "ConsoleInstance" "\0"
  /*  1797 */ "ConstantSourceNode" "\0"
  /*  1816 */ "ContentFrameMessageManager" "\0"
  /*  1843 */ "ContentProcessMessageManager" "\0"
  /*  1872 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  1910 */ "ConvolverNode" "\0"
  /*  1924 */ "CountQueuingStrategy" "\0"
  /*  1945 */ "CreateOfferRequest" "\0"
  /*  1964 */ "Credential" "\0"
  /*  1975 */ "CredentialsContainer" "\0"
  /*  1996 */ "Crypto" "\0"
  /*  2003 */ "CryptoKey" "\0"
  /*  2013 */ "CustomElementRegistry" "\0"
  /*  2035 */ "CustomEvent" "\0"
  /*  2047 */ "DOMException" "\0"
  /*  2060 */ "DOMImplementation" "\0"
  /*  2078 */ "DOMLocalization" "\0"
  /*  2094 */ "DOMMatrix" "\0"
  /*  2104 */ "DOMMatrixReadOnly" "\0"
  /*  2122 */ "DOMParser" "\0"
  /*  2132 */ "DOMPoint" "\0"
  /*  2141 */ "DOMPointReadOnly" "\0"
  /*  2158 */ "DOMQuad" "\0"
  /*  2166 */ "DOMRect" "\0"
  /*  2174 */ "DOMRectList" "\0"
  /*  2186 */ "DOMRectReadOnly" "\0"
  /*  2202 */ "DOMRequest" "\0"
  /*  2213 */ "DOMStringList" "\0"
  /*  2227 */ "DOMStringMap" "\0"
  /*  2240 */ "DOMTokenList" "\0"
  /*  2253 */ "DataTransfer" "\0"
  /*  2266 */ "DataTransferItem" "\0"
  /*  2283 */ "DataTransferItemList" "\0"
  /*  2304 */ "DebuggerNotification" "\0"
  /*  2325 */ "DebuggerNotificationObserver" "\0"
  /*  2354 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2381 */ "DelayNode" "\0"
  /*  2391 */ "DeprecationReportBody" "\0"
  /*  2413 */ "DeviceAcceleration" "\0"
  /*  2432 */ "DeviceLightEvent" "\0"
  /*  2449 */ "DeviceMotionEvent" "\0"
  /*  2467 */ "DeviceOrientationEvent" "\0"
  /*  2490 */ "DeviceRotationRate" "\0"
  /*  2509 */ "Directory" "\0"
  /*  2519 */ "Document" "\0"
  /*  2528 */ "DocumentFragment" "\0"
  /*  2545 */ "DocumentL10n" "\0"
  /*  2558 */ "DocumentTimeline" "\0"
  /*  2575 */ "DocumentType" "\0"
  /*  2588 */ "DominatorTree" "\0"
  /*  2602 */ "DragEvent" "\0"
  /*  2612 */ "DynamicsCompressorNode" "\0"
  /*  2635 */ "EXT_blend_minmax" "\0"
  /*  2652 */ "EXT_color_buffer_float" "\0"
  /*  2675 */ "EXT_color_buffer_half_float" "\0"
  /*  2703 */ "EXT_disjoint_timer_query" "\0"
  /*  2728 */ "EXT_float_blend" "\0"
  /*  2744 */ "EXT_frag_depth" "\0"
  /*  2759 */ "EXT_sRGB" "\0"
  /*  2768 */ "EXT_shader_texture_lod" "\0"
  /*  2791 */ "EXT_texture_compression_bptc" "\0"
  /*  2820 */ "EXT_texture_compression_rgtc" "\0"
  /*  2849 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2880 */ "EXT_texture_norm16" "\0"
  /*  2899 */ "Element" "\0"
  /*  2907 */ "ElementInternals" "\0"
  /*  2924 */ "ErrorEvent" "\0"
  /*  2935 */ "Event" "\0"
  /*  2941 */ "EventCallbackDebuggerNotification" "\0"
  /*  2975 */ "EventCounts" "\0"
  /*  2987 */ "EventSource" "\0"
  /*  2999 */ "EventTarget" "\0"
  /*  3011 */ "Exception" "\0"
  /*  3021 */ "ExtendableEvent" "\0"
  /*  3037 */ "ExtendableMessageEvent" "\0"
  /*  3060 */ "ExtensionAlarms" "\0"
  /*  3076 */ "ExtensionBrowser" "\0"
  /*  3093 */ "ExtensionBrowserSettings" "\0"
  /*  3118 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3158 */ "ExtensionDns" "\0"
  /*  3171 */ "ExtensionEventManager" "\0"
  /*  3193 */ "ExtensionMockAPI" "\0"
  /*  3210 */ "ExtensionPort" "\0"
  /*  3224 */ "ExtensionProxy" "\0"
  /*  3239 */ "ExtensionRuntime" "\0"
  /*  3256 */ "ExtensionScripting" "\0"
  /*  3275 */ "ExtensionSetting" "\0"
  /*  3292 */ "ExtensionTest" "\0"
  /*  3306 */ "External" "\0"
  /*  3315 */ "FeaturePolicy" "\0"
  /*  3329 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3362 */ "FetchEvent" "\0"
  /*  3373 */ "FetchObserver" "\0"
  /*  3387 */ "File" "\0"
  /*  3392 */ "FileList" "\0"
  /*  3401 */ "FileReader" "\0"
  /*  3412 */ "FileReaderSync" "\0"
  /*  3427 */ "FileSystem" "\0"
  /*  3438 */ "FileSystemDirectoryEntry" "\0"
  /*  3463 */ "FileSystemDirectoryHandle" "\0"
  /*  3489 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3529 */ "FileSystemDirectoryIterator" "\0"
  /*  3557 */ "FileSystemDirectoryReader" "\0"
  /*  3583 */ "FileSystemEntry" "\0"
  /*  3599 */ "FileSystemFileEntry" "\0"
  /*  3619 */ "FileSystemFileHandle" "\0"
  /*  3640 */ "FileSystemHandle" "\0"
  /*  3657 */ "FileSystemSyncAccessHandle" "\0"
  /*  3684 */ "FileSystemWritableFileStream" "\0"
  /*  3713 */ "Flex" "\0"
  /*  3718 */ "FlexItemValues" "\0"
  /*  3733 */ "FlexLineValues" "\0"
  /*  3748 */ "FluentBundle" "\0"
  /*  3761 */ "FluentBundleAsyncIterator" "\0"
  /*  3787 */ "FluentBundleIterator" "\0"
  /*  3808 */ "FluentPattern" "\0"
  /*  3822 */ "FluentResource" "\0"
  /*  3837 */ "FocusEvent" "\0"
  /*  3848 */ "FontFace" "\0"
  /*  3857 */ "FontFaceSet" "\0"
  /*  3869 */ "FontFaceSetIterator" "\0"
  /*  3889 */ "FontFaceSetLoadEvent" "\0"
  /*  3910 */ "FormData" "\0"
  /*  3919 */ "FormData Iterator" "\0"
  /*  3937 */ "FormDataEvent" "\0"
  /*  3951 */ "FrameCrashedEvent" "\0"
  /*  3969 */ "FrameLoader" "\0"
  /*  3981 */ "GPU" "\0"
  /*  3985 */ "GPUAdapter" "\0"
  /*  3996 */ "GPUBindGroup" "\0"
  /*  4009 */ "GPUBindGroupLayout" "\0"
  /*  4028 */ "GPUBuffer" "\0"
  /*  4038 */ "GPUBufferUsage" "\0"
  /*  4053 */ "GPUCanvasContext" "\0"
  /*  4070 */ "GPUColorWrite" "\0"
  /*  4084 */ "GPUCommandBuffer" "\0"
  /*  4101 */ "GPUCommandEncoder" "\0"
  /*  4119 */ "GPUCompilationInfo" "\0"
  /*  4138 */ "GPUCompilationMessage" "\0"
  /*  4160 */ "GPUComputePassEncoder" "\0"
  /*  4182 */ "GPUComputePipeline" "\0"
  /*  4201 */ "GPUDevice" "\0"
  /*  4211 */ "GPUDeviceLostInfo" "\0"
  /*  4229 */ "GPUMapMode" "\0"
  /*  4240 */ "GPUOutOfMemoryError" "\0"
  /*  4260 */ "GPUPipelineLayout" "\0"
  /*  4278 */ "GPUQuerySet" "\0"
  /*  4290 */ "GPUQueue" "\0"
  /*  4299 */ "GPURenderBundle" "\0"
  /*  4315 */ "GPURenderBundleEncoder" "\0"
  /*  4338 */ "GPURenderPassEncoder" "\0"
  /*  4359 */ "GPURenderPipeline" "\0"
  /*  4377 */ "GPUSampler" "\0"
  /*  4388 */ "GPUShaderModule" "\0"
  /*  4404 */ "GPUShaderStage" "\0"
  /*  4419 */ "GPUSupportedFeatures" "\0"
  /*  4440 */ "GPUSupportedLimits" "\0"
  /*  4459 */ "GPUTexture" "\0"
  /*  4470 */ "GPUTextureUsage" "\0"
  /*  4486 */ "GPUTextureView" "\0"
  /*  4501 */ "GPUUncapturedErrorEvent" "\0"
  /*  4525 */ "GPUValidationError" "\0"
  /*  4544 */ "GainNode" "\0"
  /*  4553 */ "Gamepad" "\0"
  /*  4561 */ "GamepadAxisMoveEvent" "\0"
  /*  4582 */ "GamepadButton" "\0"
  /*  4596 */ "GamepadButtonEvent" "\0"
  /*  4615 */ "GamepadEvent" "\0"
  /*  4628 */ "GamepadHapticActuator" "\0"
  /*  4650 */ "GamepadLightIndicator" "\0"
  /*  4672 */ "GamepadPose" "\0"
  /*  4684 */ "GamepadServiceTest" "\0"
  /*  4703 */ "GamepadTouch" "\0"
  /*  4716 */ "Geolocation" "\0"
  /*  4728 */ "GeolocationCoordinates" "\0"
  /*  4751 */ "GeolocationPosition" "\0"
  /*  4771 */ "GeolocationPositionError" "\0"
  /*  4796 */ "GetUserMediaRequest" "\0"
  /*  4816 */ "GleanCategory" "\0"
  /*  4830 */ "GleanImpl" "\0"
  /*  4840 */ "GleanLabeled" "\0"
  /*  4853 */ "GleanPingsImpl" "\0"
  /*  4868 */ "Grid" "\0"
  /*  4873 */ "GridArea" "\0"
  /*  4882 */ "GridDimension" "\0"
  /*  4896 */ "GridLine" "\0"
  /*  4905 */ "GridLines" "\0"
  /*  4915 */ "GridTrack" "\0"
  /*  4925 */ "GridTracks" "\0"
  /*  4936 */ "HTMLAllCollection" "\0"
  /*  4954 */ "HTMLAnchorElement" "\0"
  /*  4972 */ "HTMLAreaElement" "\0"
  /*  4988 */ "HTMLAudioElement" "\0"
  /*  5005 */ "HTMLBRElement" "\0"
  /*  5019 */ "HTMLBaseElement" "\0"
  /*  5035 */ "HTMLBodyElement" "\0"
  /*  5051 */ "HTMLButtonElement" "\0"
  /*  5069 */ "HTMLCanvasElement" "\0"
  /*  5087 */ "HTMLCollection" "\0"
  /*  5102 */ "HTMLDListElement" "\0"
  /*  5119 */ "HTMLDataElement" "\0"
  /*  5135 */ "HTMLDataListElement" "\0"
  /*  5155 */ "HTMLDetailsElement" "\0"
  /*  5174 */ "HTMLDialogElement" "\0"
  /*  5192 */ "HTMLDirectoryElement" "\0"
  /*  5213 */ "HTMLDivElement" "\0"
  /*  5228 */ "HTMLDocument" "\0"
  /*  5241 */ "HTMLElement" "\0"
  /*  5253 */ "HTMLEmbedElement" "\0"
  /*  5270 */ "HTMLFieldSetElement" "\0"
  /*  5290 */ "HTMLFontElement" "\0"
  /*  5306 */ "HTMLFormControlsCollection" "\0"
  /*  5333 */ "HTMLFormElement" "\0"
  /*  5349 */ "HTMLFrameElement" "\0"
  /*  5366 */ "HTMLFrameSetElement" "\0"
  /*  5386 */ "HTMLHRElement" "\0"
  /*  5400 */ "HTMLHeadElement" "\0"
  /*  5416 */ "HTMLHeadingElement" "\0"
  /*  5435 */ "HTMLHtmlElement" "\0"
  /*  5451 */ "HTMLIFrameElement" "\0"
  /*  5469 */ "HTMLImageElement" "\0"
  /*  5486 */ "HTMLInputElement" "\0"
  /*  5503 */ "HTMLLIElement" "\0"
  /*  5517 */ "HTMLLabelElement" "\0"
  /*  5534 */ "HTMLLegendElement" "\0"
  /*  5552 */ "HTMLLinkElement" "\0"
  /*  5568 */ "HTMLMapElement" "\0"
  /*  5583 */ "HTMLMarqueeElement" "\0"
  /*  5602 */ "HTMLMediaElement" "\0"
  /*  5619 */ "HTMLMenuElement" "\0"
  /*  5635 */ "HTMLMetaElement" "\0"
  /*  5651 */ "HTMLMeterElement" "\0"
  /*  5668 */ "HTMLModElement" "\0"
  /*  5683 */ "HTMLOListElement" "\0"
  /*  5700 */ "HTMLObjectElement" "\0"
  /*  5718 */ "HTMLOptGroupElement" "\0"
  /*  5738 */ "HTMLOptionElement" "\0"
  /*  5756 */ "HTMLOptionsCollection" "\0"
  /*  5778 */ "HTMLOutputElement" "\0"
  /*  5796 */ "HTMLParagraphElement" "\0"
  /*  5817 */ "HTMLParamElement" "\0"
  /*  5834 */ "HTMLPictureElement" "\0"
  /*  5853 */ "HTMLPreElement" "\0"
  /*  5868 */ "HTMLProgressElement" "\0"
  /*  5888 */ "HTMLQuoteElement" "\0"
  /*  5905 */ "HTMLScriptElement" "\0"
  /*  5923 */ "HTMLSelectElement" "\0"
  /*  5941 */ "HTMLSlotElement" "\0"
  /*  5957 */ "HTMLSourceElement" "\0"
  /*  5975 */ "HTMLSpanElement" "\0"
  /*  5991 */ "HTMLStyleElement" "\0"
  /*  6008 */ "HTMLTableCaptionElement" "\0"
  /*  6032 */ "HTMLTableCellElement" "\0"
  /*  6053 */ "HTMLTableColElement" "\0"
  /*  6073 */ "HTMLTableElement" "\0"
  /*  6090 */ "HTMLTableRowElement" "\0"
  /*  6110 */ "HTMLTableSectionElement" "\0"
  /*  6134 */ "HTMLTemplateElement" "\0"
  /*  6154 */ "HTMLTextAreaElement" "\0"
  /*  6174 */ "HTMLTimeElement" "\0"
  /*  6190 */ "HTMLTitleElement" "\0"
  /*  6207 */ "HTMLTrackElement" "\0"
  /*  6224 */ "HTMLUListElement" "\0"
  /*  6241 */ "HTMLUnknownElement" "\0"
  /*  6260 */ "HTMLVideoElement" "\0"
  /*  6277 */ "HashChangeEvent" "\0"
  /*  6293 */ "Headers" "\0"
  /*  6301 */ "Headers Iterator" "\0"
  /*  6318 */ "HeapSnapshot" "\0"
  /*  6331 */ "Highlight" "\0"
  /*  6341 */ "HighlightRegistry" "\0"
  /*  6359 */ "History" "\0"
  /*  6367 */ "IDBCursor" "\0"
  /*  6377 */ "IDBCursorWithValue" "\0"
  /*  6396 */ "IDBDatabase" "\0"
  /*  6408 */ "IDBFactory" "\0"
  /*  6419 */ "IDBIndex" "\0"
  /*  6428 */ "IDBKeyRange" "\0"
  /*  6440 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6463 */ "IDBObjectStore" "\0"
  /*  6478 */ "IDBOpenDBRequest" "\0"
  /*  6495 */ "IDBRequest" "\0"
  /*  6506 */ "IDBTransaction" "\0"
  /*  6521 */ "IDBVersionChangeEvent" "\0"
  /*  6543 */ "IIRFilterNode" "\0"
  /*  6557 */ "IOUtils" "\0"
  /*  6565 */ "IdentityCredential" "\0"
  /*  6584 */ "IdleDeadline" "\0"
  /*  6597 */ "Image" "\0"
  /*  6603 */ "ImageBitmap" "\0"
  /*  6615 */ "ImageBitmapRenderingContext" "\0"
  /*  6643 */ "ImageCapture" "\0"
  /*  6656 */ "ImageCaptureError" "\0"
  /*  6674 */ "ImageCaptureErrorEvent" "\0"
  /*  6697 */ "ImageData" "\0"
  /*  6707 */ "ImageDocument" "\0"
  /*  6721 */ "InputEvent" "\0"
  /*  6732 */ "InspectorFontFace" "\0"
  /*  6750 */ "InspectorUtils" "\0"
  /*  6765 */ "InstallTriggerImpl" "\0"
  /*  6784 */ "IntersectionObserver" "\0"
  /*  6805 */ "IntersectionObserverEntry" "\0"
  /*  6831 */ "IntlUtils" "\0"
  /*  6841 */ "JSProcessActorChild" "\0"
  /*  6861 */ "JSProcessActorParent" "\0"
  /*  6882 */ "JSWindowActorChild" "\0"
  /*  6901 */ "JSWindowActorParent" "\0"
  /*  6921 */ "KeyEvent" "\0"
  /*  6930 */ "KeyboardEvent" "\0"
  /*  6944 */ "KeyframeEffect" "\0"
  /*  6959 */ "L10nFileSource" "\0"
  /*  6974 */ "L10nOverlays" "\0"
  /*  6987 */ "L10nRegistry" "\0"
  /*  7000 */ "LegacyMozTCPSocket" "\0"
  /*  7019 */ "Localization" "\0"
  /*  7032 */ "Location" "\0"
  /*  7041 */ "Lock" "\0"
  /*  7046 */ "LockManager" "\0"
  /*  7058 */ "MIDIAccess" "\0"
  /*  7069 */ "MIDIConnectionEvent" "\0"
  /*  7089 */ "MIDIInput" "\0"
  /*  7099 */ "MIDIInputMap" "\0"
  /*  7112 */ "MIDIMessageEvent" "\0"
  /*  7129 */ "MIDIOutput" "\0"
  /*  7140 */ "MIDIOutputMap" "\0"
  /*  7154 */ "MIDIPort" "\0"
  /*  7163 */ "MOZ_debug" "\0"
  /*  7173 */ "MatchGlob" "\0"
  /*  7183 */ "MatchPattern" "\0"
  /*  7196 */ "MatchPatternSet" "\0"
  /*  7212 */ "MathMLElement" "\0"
  /*  7226 */ "MediaCapabilities" "\0"
  /*  7244 */ "MediaCapabilitiesInfo" "\0"
  /*  7266 */ "MediaControlService" "\0"
  /*  7286 */ "MediaController" "\0"
  /*  7302 */ "MediaDeviceInfo" "\0"
  /*  7318 */ "MediaDevices" "\0"
  /*  7331 */ "MediaElementAudioSourceNode" "\0"
  /*  7359 */ "MediaEncryptedEvent" "\0"
  /*  7379 */ "MediaError" "\0"
  /*  7390 */ "MediaKeyError" "\0"
  /*  7404 */ "MediaKeyMessageEvent" "\0"
  /*  7425 */ "MediaKeySession" "\0"
  /*  7441 */ "MediaKeyStatusMap" "\0"
  /*  7459 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7486 */ "MediaKeySystemAccess" "\0"
  /*  7507 */ "MediaKeys" "\0"
  /*  7517 */ "MediaList" "\0"
  /*  7527 */ "MediaMetadata" "\0"
  /*  7541 */ "MediaQueryList" "\0"
  /*  7556 */ "MediaQueryListEvent" "\0"
  /*  7576 */ "MediaRecorder" "\0"
  /*  7590 */ "MediaRecorderErrorEvent" "\0"
  /*  7614 */ "MediaSession" "\0"
  /*  7627 */ "MediaSource" "\0"
  /*  7639 */ "MediaStream" "\0"
  /*  7651 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7683 */ "MediaStreamAudioSourceNode" "\0"
  /*  7710 */ "MediaStreamError" "\0"
  /*  7727 */ "MediaStreamEvent" "\0"
  /*  7744 */ "MediaStreamTrack" "\0"
  /*  7761 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7793 */ "MediaStreamTrackEvent" "\0"
  /*  7815 */ "MerchantValidationEvent" "\0"
  /*  7839 */ "MessageBroadcaster" "\0"
  /*  7858 */ "MessageChannel" "\0"
  /*  7873 */ "MessageEvent" "\0"
  /*  7886 */ "MessageListenerManager" "\0"
  /*  7909 */ "MessagePort" "\0"
  /*  7921 */ "MessageSender" "\0"
  /*  7935 */ "MimeType" "\0"
  /*  7944 */ "MimeTypeArray" "\0"
  /*  7958 */ "MouseEvent" "\0"
  /*  7969 */ "MouseScrollEvent" "\0"
  /*  7986 */ "MozCanvasPrintState" "\0"
  /*  8006 */ "MozDocumentMatcher" "\0"
  /*  8025 */ "MozDocumentObserver" "\0"
  /*  8045 */ "MozQueryInterface" "\0"
  /*  8063 */ "MozSharedMap" "\0"
  /*  8076 */ "MozSharedMap Iterator" "\0"
  /*  8098 */ "MozSharedMapChangeEvent" "\0"
  /*  8122 */ "MozStorageAsyncStatementParams" "\0"
  /*  8153 */ "MozStorageStatementParams" "\0"
  /*  8179 */ "MozStorageStatementRow" "\0"
  /*  8202 */ "MozWritableSharedMap" "\0"
  /*  8223 */ "MutationEvent" "\0"
  /*  8237 */ "MutationObserver" "\0"
  /*  8254 */ "MutationRecord" "\0"
  /*  8269 */ "NamedNodeMap" "\0"
  /*  8282 */ "NavigationPreloadManager" "\0"
  /*  8307 */ "Navigator" "\0"
  /*  8317 */ "NetworkInformation" "\0"
  /*  8336 */ "Node" "\0"
  /*  8341 */ "NodeFilter" "\0"
  /*  8352 */ "NodeIterator" "\0"
  /*  8365 */ "NodeList" "\0"
  /*  8374 */ "Notification" "\0"
  /*  8387 */ "NotificationEvent" "\0"
  /*  8405 */ "NotifyPaintEvent" "\0"
  /*  8422 */ "OES_draw_buffers_indexed" "\0"
  /*  8447 */ "OES_element_index_uint" "\0"
  /*  8470 */ "OES_fbo_render_mipmap" "\0"
  /*  8492 */ "OES_standard_derivatives" "\0"
  /*  8517 */ "OES_texture_float" "\0"
  /*  8535 */ "OES_texture_float_linear" "\0"
  /*  8560 */ "OES_texture_half_float" "\0"
  /*  8583 */ "OES_texture_half_float_linear" "\0"
  /*  8613 */ "OES_vertex_array_object" "\0"
  /*  8637 */ "OVR_multiview2" "\0"
  /*  8652 */ "OfflineAudioCompletionEvent" "\0"
  /*  8680 */ "OfflineAudioContext" "\0"
  /*  8700 */ "OfflineResourceList" "\0"
  /*  8720 */ "OffscreenCanvas" "\0"
  /*  8736 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8770 */ "Option" "\0"
  /*  8777 */ "OscillatorNode" "\0"
  /*  8792 */ "PageTransitionEvent" "\0"
  /*  8812 */ "PaintRequest" "\0"
  /*  8825 */ "PaintRequestList" "\0"
  /*  8842 */ "PaintWorkletGlobalScope" "\0"
  /*  8866 */ "PannerNode" "\0"
  /*  8877 */ "ParentProcessMessageManager" "\0"
  /*  8905 */ "Path2D" "\0"
  /*  8912 */ "PathUtils" "\0"
  /*  8922 */ "PaymentAddress" "\0"
  /*  8937 */ "PaymentMethodChangeEvent" "\0"
  /*  8962 */ "PaymentRequest" "\0"
  /*  8977 */ "PaymentRequestUpdateEvent" "\0"
  /*  9003 */ "PaymentResponse" "\0"
  /*  9019 */ "PeerConnectionImpl" "\0"
  /*  9038 */ "PeerConnectionObserver" "\0"
  /*  9061 */ "Performance" "\0"
  /*  9073 */ "PerformanceEntry" "\0"
  /*  9090 */ "PerformanceEntryEvent" "\0"
  /*  9112 */ "PerformanceEventTiming" "\0"
  /*  9135 */ "PerformanceMark" "\0"
  /*  9151 */ "PerformanceMeasure" "\0"
  /*  9170 */ "PerformanceNavigation" "\0"
  /*  9192 */ "PerformanceNavigationTiming" "\0"
  /*  9220 */ "PerformanceObserver" "\0"
  /*  9240 */ "PerformanceObserverEntryList" "\0"
  /*  9269 */ "PerformancePaintTiming" "\0"
  /*  9292 */ "PerformanceResourceTiming" "\0"
  /*  9318 */ "PerformanceServerTiming" "\0"
  /*  9342 */ "PerformanceTiming" "\0"
  /*  9360 */ "PeriodicWave" "\0"
  /*  9373 */ "PermissionStatus" "\0"
  /*  9390 */ "Permissions" "\0"
  /*  9402 */ "PlacesBookmark" "\0"
  /*  9417 */ "PlacesBookmarkAddition" "\0"
  /*  9440 */ "PlacesBookmarkChanged" "\0"
  /*  9462 */ "PlacesBookmarkGuid" "\0"
  /*  9481 */ "PlacesBookmarkKeyword" "\0"
  /*  9503 */ "PlacesBookmarkMoved" "\0"
  /*  9523 */ "PlacesBookmarkRemoved" "\0"
  /*  9545 */ "PlacesBookmarkTags" "\0"
  /*  9564 */ "PlacesBookmarkTime" "\0"
  /*  9583 */ "PlacesBookmarkTitle" "\0"
  /*  9603 */ "PlacesBookmarkUrl" "\0"
  /*  9621 */ "PlacesEvent" "\0"
  /*  9633 */ "PlacesFavicon" "\0"
  /*  9647 */ "PlacesHistoryCleared" "\0"
  /*  9668 */ "PlacesObservers" "\0"
  /*  9684 */ "PlacesPurgeCaches" "\0"
  /*  9702 */ "PlacesRanking" "\0"
  /*  9716 */ "PlacesVisit" "\0"
  /*  9728 */ "PlacesVisitRemoved" "\0"
  /*  9747 */ "PlacesVisitTitle" "\0"
  /*  9764 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9790 */ "Plugin" "\0"
  /*  9797 */ "PluginArray" "\0"
  /*  9809 */ "PluginCrashedEvent" "\0"
  /*  9828 */ "PointerEvent" "\0"
  /*  9841 */ "PopStateEvent" "\0"
  /*  9855 */ "PopupBlockedEvent" "\0"
  /*  9873 */ "PopupPositionedEvent" "\0"
  /*  9894 */ "PositionStateEvent" "\0"
  /*  9913 */ "PrecompiledScript" "\0"
  /*  9931 */ "ProcessMessageManager" "\0"
  /*  9953 */ "ProcessingInstruction" "\0"
  /*  9975 */ "ProgressEvent" "\0"
  /*  9989 */ "PromiseDebugging" "\0"
  /* 10006 */ "PromiseNativeHandler" "\0"
  /* 10027 */ "PromiseRejectionEvent" "\0"
  /* 10049 */ "PublicKeyCredential" "\0"
  /* 10069 */ "PushEvent" "\0"
  /* 10079 */ "PushManager" "\0"
  /* 10091 */ "PushManagerImpl" "\0"
  /* 10107 */ "PushMessageData" "\0"
  /* 10123 */ "PushSubscription" "\0"
  /* 10140 */ "PushSubscriptionOptions" "\0"
  /* 10164 */ "RTCCertificate" "\0"
  /* 10179 */ "RTCDTMFSender" "\0"
  /* 10193 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10216 */ "RTCDataChannel" "\0"
  /* 10231 */ "RTCDataChannelEvent" "\0"
  /* 10251 */ "RTCDtlsTransport" "\0"
  /* 10268 */ "RTCIceCandidate" "\0"
  /* 10284 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10313 */ "RTCPeerConnection" "\0"
  /* 10331 */ "RTCPeerConnectionIceEvent" "\0"
  /* 10357 */ "RTCPeerConnectionStatic" "\0"
  /* 10381 */ "RTCRtpReceiver" "\0"
  /* 10396 */ "RTCRtpSender" "\0"
  /* 10409 */ "RTCRtpTransceiver" "\0"
  /* 10427 */ "RTCSessionDescription" "\0"
  /* 10449 */ "RTCStatsReport" "\0"
  /* 10464 */ "RTCTrackEvent" "\0"
  /* 10478 */ "RadioNodeList" "\0"
  /* 10492 */ "Range" "\0"
  /* 10498 */ "ReadableByteStreamController" "\0"
  /* 10527 */ "ReadableStream" "\0"
  /* 10542 */ "ReadableStream AsyncIterator" "\0"
  /* 10571 */ "ReadableStreamBYOBReader" "\0"
  /* 10596 */ "ReadableStreamBYOBRequest" "\0"
  /* 10622 */ "ReadableStreamDefaultController" "\0"
  /* 10654 */ "ReadableStreamDefaultReader" "\0"
  /* 10682 */ "Report" "\0"
  /* 10689 */ "ReportBody" "\0"
  /* 10700 */ "ReportingObserver" "\0"
  /* 10718 */ "Request" "\0"
  /* 10726 */ "ResizeObserver" "\0"
  /* 10741 */ "ResizeObserverEntry" "\0"
  /* 10761 */ "ResizeObserverSize" "\0"
  /* 10780 */ "Response" "\0"
  /* 10789 */ "SVGAElement" "\0"
  /* 10801 */ "SVGAngle" "\0"
  /* 10810 */ "SVGAnimateElement" "\0"
  /* 10828 */ "SVGAnimateMotionElement" "\0"
  /* 10852 */ "SVGAnimateTransformElement" "\0"
  /* 10879 */ "SVGAnimatedAngle" "\0"
  /* 10896 */ "SVGAnimatedBoolean" "\0"
  /* 10915 */ "SVGAnimatedEnumeration" "\0"
  /* 10938 */ "SVGAnimatedInteger" "\0"
  /* 10957 */ "SVGAnimatedLength" "\0"
  /* 10975 */ "SVGAnimatedLengthList" "\0"
  /* 10997 */ "SVGAnimatedNumber" "\0"
  /* 11015 */ "SVGAnimatedNumberList" "\0"
  /* 11037 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 11068 */ "SVGAnimatedRect" "\0"
  /* 11084 */ "SVGAnimatedString" "\0"
  /* 11102 */ "SVGAnimatedTransformList" "\0"
  /* 11127 */ "SVGAnimationElement" "\0"
  /* 11147 */ "SVGCircleElement" "\0"
  /* 11164 */ "SVGClipPathElement" "\0"
  /* 11183 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11219 */ "SVGDefsElement" "\0"
  /* 11234 */ "SVGDescElement" "\0"
  /* 11249 */ "SVGElement" "\0"
  /* 11260 */ "SVGEllipseElement" "\0"
  /* 11278 */ "SVGFEBlendElement" "\0"
  /* 11296 */ "SVGFEColorMatrixElement" "\0"
  /* 11320 */ "SVGFEComponentTransferElement" "\0"
  /* 11350 */ "SVGFECompositeElement" "\0"
  /* 11372 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11399 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11427 */ "SVGFEDisplacementMapElement" "\0"
  /* 11455 */ "SVGFEDistantLightElement" "\0"
  /* 11480 */ "SVGFEDropShadowElement" "\0"
  /* 11503 */ "SVGFEFloodElement" "\0"
  /* 11521 */ "SVGFEFuncAElement" "\0"
  /* 11539 */ "SVGFEFuncBElement" "\0"
  /* 11557 */ "SVGFEFuncGElement" "\0"
  /* 11575 */ "SVGFEFuncRElement" "\0"
  /* 11593 */ "SVGFEGaussianBlurElement" "\0"
  /* 11618 */ "SVGFEImageElement" "\0"
  /* 11636 */ "SVGFEMergeElement" "\0"
  /* 11654 */ "SVGFEMergeNodeElement" "\0"
  /* 11676 */ "SVGFEMorphologyElement" "\0"
  /* 11699 */ "SVGFEOffsetElement" "\0"
  /* 11718 */ "SVGFEPointLightElement" "\0"
  /* 11741 */ "SVGFESpecularLightingElement" "\0"
  /* 11770 */ "SVGFESpotLightElement" "\0"
  /* 11792 */ "SVGFETileElement" "\0"
  /* 11809 */ "SVGFETurbulenceElement" "\0"
  /* 11832 */ "SVGFilterElement" "\0"
  /* 11849 */ "SVGForeignObjectElement" "\0"
  /* 11873 */ "SVGGElement" "\0"
  /* 11885 */ "SVGGeometryElement" "\0"
  /* 11904 */ "SVGGradientElement" "\0"
  /* 11923 */ "SVGGraphicsElement" "\0"
  /* 11942 */ "SVGImageElement" "\0"
  /* 11958 */ "SVGLength" "\0"
  /* 11968 */ "SVGLengthList" "\0"
  /* 11982 */ "SVGLineElement" "\0"
  /* 11997 */ "SVGLinearGradientElement" "\0"
  /* 12022 */ "SVGMPathElement" "\0"
  /* 12038 */ "SVGMarkerElement" "\0"
  /* 12055 */ "SVGMaskElement" "\0"
  /* 12070 */ "SVGMatrix" "\0"
  /* 12080 */ "SVGMetadataElement" "\0"
  /* 12099 */ "SVGNumber" "\0"
  /* 12109 */ "SVGNumberList" "\0"
  /* 12123 */ "SVGPathElement" "\0"
  /* 12138 */ "SVGPathSeg" "\0"
  /* 12149 */ "SVGPathSegArcAbs" "\0"
  /* 12166 */ "SVGPathSegArcRel" "\0"
  /* 12183 */ "SVGPathSegClosePath" "\0"
  /* 12203 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12229 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12255 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12287 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12319 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12349 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12379 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12415 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12451 */ "SVGPathSegLinetoAbs" "\0"
  /* 12471 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12501 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12531 */ "SVGPathSegLinetoRel" "\0"
  /* 12551 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12579 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12607 */ "SVGPathSegList" "\0"
  /* 12622 */ "SVGPathSegMovetoAbs" "\0"
  /* 12642 */ "SVGPathSegMovetoRel" "\0"
  /* 12662 */ "SVGPatternElement" "\0"
  /* 12680 */ "SVGPoint" "\0"
  /* 12689 */ "SVGPointList" "\0"
  /* 12702 */ "SVGPolygonElement" "\0"
  /* 12720 */ "SVGPolylineElement" "\0"
  /* 12739 */ "SVGPreserveAspectRatio" "\0"
  /* 12762 */ "SVGRadialGradientElement" "\0"
  /* 12787 */ "SVGRect" "\0"
  /* 12795 */ "SVGRectElement" "\0"
  /* 12810 */ "SVGSVGElement" "\0"
  /* 12824 */ "SVGScriptElement" "\0"
  /* 12841 */ "SVGSetElement" "\0"
  /* 12855 */ "SVGStopElement" "\0"
  /* 12870 */ "SVGStringList" "\0"
  /* 12884 */ "SVGStyleElement" "\0"
  /* 12900 */ "SVGSwitchElement" "\0"
  /* 12917 */ "SVGSymbolElement" "\0"
  /* 12934 */ "SVGTSpanElement" "\0"
  /* 12950 */ "SVGTextContentElement" "\0"
  /* 12972 */ "SVGTextElement" "\0"
  /* 12987 */ "SVGTextPathElement" "\0"
  /* 13006 */ "SVGTextPositioningElement" "\0"
  /* 13032 */ "SVGTitleElement" "\0"
  /* 13048 */ "SVGTransform" "\0"
  /* 13061 */ "SVGTransformList" "\0"
  /* 13078 */ "SVGUnitTypes" "\0"
  /* 13091 */ "SVGUseElement" "\0"
  /* 13105 */ "SVGViewElement" "\0"
  /* 13120 */ "Sanitizer" "\0"
  /* 13130 */ "Scheduler" "\0"
  /* 13140 */ "Screen" "\0"
  /* 13147 */ "ScreenLuminance" "\0"
  /* 13163 */ "ScreenOrientation" "\0"
  /* 13181 */ "ScriptProcessorNode" "\0"
  /* 13201 */ "ScrollAreaEvent" "\0"
  /* 13217 */ "ScrollViewChangeEvent" "\0"
  /* 13239 */ "SecurityPolicyViolationEvent" "\0"
  /* 13268 */ "Selection" "\0"
  /* 13278 */ "ServiceWorker" "\0"
  /* 13292 */ "ServiceWorkerContainer" "\0"
  /* 13315 */ "ServiceWorkerGlobalScope" "\0"
  /* 13340 */ "ServiceWorkerRegistration" "\0"
  /* 13366 */ "SessionStoreFormData" "\0"
  /* 13387 */ "SessionStoreScrollData" "\0"
  /* 13410 */ "SessionStoreUtils" "\0"
  /* 13428 */ "ShadowRealmGlobalScope" "\0"
  /* 13451 */ "ShadowRoot" "\0"
  /* 13462 */ "SharedWorker" "\0"
  /* 13475 */ "SharedWorkerGlobalScope" "\0"
  /* 13499 */ "SimpleGestureEvent" "\0"
  /* 13518 */ "SourceBuffer" "\0"
  /* 13531 */ "SourceBufferList" "\0"
  /* 13548 */ "SpeechGrammar" "\0"
  /* 13562 */ "SpeechGrammarList" "\0"
  /* 13580 */ "SpeechRecognition" "\0"
  /* 13598 */ "SpeechRecognitionAlternative" "\0"
  /* 13627 */ "SpeechRecognitionError" "\0"
  /* 13650 */ "SpeechRecognitionEvent" "\0"
  /* 13673 */ "SpeechRecognitionResult" "\0"
  /* 13697 */ "SpeechRecognitionResultList" "\0"
  /* 13725 */ "SpeechSynthesis" "\0"
  /* 13741 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13767 */ "SpeechSynthesisEvent" "\0"
  /* 13788 */ "SpeechSynthesisUtterance" "\0"
  /* 13813 */ "SpeechSynthesisVoice" "\0"
  /* 13834 */ "StaticRange" "\0"
  /* 13846 */ "StereoPannerNode" "\0"
  /* 13863 */ "Storage" "\0"
  /* 13871 */ "StorageEvent" "\0"
  /* 13884 */ "StorageManager" "\0"
  /* 13899 */ "StreamFilter" "\0"
  /* 13912 */ "StreamFilterDataEvent" "\0"
  /* 13934 */ "StructuredCloneHolder" "\0"
  /* 13956 */ "StructuredCloneTester" "\0"
  /* 13978 */ "StyleSheet" "\0"
  /* 13989 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14026 */ "StyleSheetList" "\0"
  /* 14041 */ "SubmitEvent" "\0"
  /* 14053 */ "SubtleCrypto" "\0"
  /* 14066 */ "SyncMessageSender" "\0"
  /* 14084 */ "SyncReadFile" "\0"
  /* 14097 */ "TCPServerSocket" "\0"
  /* 14113 */ "TCPServerSocketEvent" "\0"
  /* 14134 */ "TCPSocket" "\0"
  /* 14144 */ "TCPSocketErrorEvent" "\0"
  /* 14164 */ "TCPSocketEvent" "\0"
  /* 14179 */ "TaskController" "\0"
  /* 14194 */ "TaskPriorityChangeEvent" "\0"
  /* 14218 */ "TaskSignal" "\0"
  /* 14229 */ "TelemetryStopwatch" "\0"
  /* 14248 */ "TestUtils" "\0"
  /* 14258 */ "TestingDeprecatedInterface" "\0"
  /* 14285 */ "Text" "\0"
  /* 14290 */ "TextClause" "\0"
  /* 14301 */ "TextDecoder" "\0"
  /* 14313 */ "TextDecoderStream" "\0"
  /* 14331 */ "TextEncoder" "\0"
  /* 14343 */ "TextEncoderStream" "\0"
  /* 14361 */ "TextMetrics" "\0"
  /* 14373 */ "TextTrack" "\0"
  /* 14383 */ "TextTrackCue" "\0"
  /* 14396 */ "TextTrackCueList" "\0"
  /* 14413 */ "TextTrackList" "\0"
  /* 14427 */ "TimeEvent" "\0"
  /* 14437 */ "TimeRanges" "\0"
  /* 14448 */ "Touch" "\0"
  /* 14454 */ "TouchEvent" "\0"
  /* 14465 */ "TouchList" "\0"
  /* 14475 */ "TrackEvent" "\0"
  /* 14486 */ "TransformStream" "\0"
  /* 14502 */ "TransformStreamDefaultController" "\0"
  /* 14535 */ "TransitionEvent" "\0"
  /* 14551 */ "TreeColumn" "\0"
  /* 14562 */ "TreeColumns" "\0"
  /* 14574 */ "TreeContentView" "\0"
  /* 14590 */ "TreeWalker" "\0"
  /* 14601 */ "U2F" "\0"
  /* 14605 */ "UDPMessageEvent" "\0"
  /* 14621 */ "UDPSocket" "\0"
  /* 14631 */ "UIEvent" "\0"
  /* 14639 */ "URL" "\0"
  /* 14643 */ "URLSearchParams" "\0"
  /* 14659 */ "URLSearchParams Iterator" "\0"
  /* 14684 */ "UniFFIPointer" "\0"
  /* 14698 */ "UniFFIScaffolding" "\0"
  /* 14716 */ "UserInteraction" "\0"
  /* 14732 */ "UserProximityEvent" "\0"
  /* 14751 */ "VRDisplay" "\0"
  /* 14761 */ "VRDisplayCapabilities" "\0"
  /* 14783 */ "VRDisplayEvent" "\0"
  /* 14798 */ "VREyeParameters" "\0"
  /* 14814 */ "VRFieldOfView" "\0"
  /* 14828 */ "VRFrameData" "\0"
  /* 14840 */ "VRMockController" "\0"
  /* 14857 */ "VRMockDisplay" "\0"
  /* 14871 */ "VRPose" "\0"
  /* 14878 */ "VRServiceTest" "\0"
  /* 14892 */ "VRStageParameters" "\0"
  /* 14910 */ "VTTCue" "\0"
  /* 14917 */ "VTTRegion" "\0"
  /* 14927 */ "ValidityState" "\0"
  /* 14941 */ "VideoColorSpace" "\0"
  /* 14957 */ "VideoFrame" "\0"
  /* 14968 */ "VideoPlaybackQuality" "\0"
  /* 14989 */ "VideoTrack" "\0"
  /* 15000 */ "VideoTrackList" "\0"
  /* 15015 */ "VisualViewport" "\0"
  /* 15030 */ "WEBGL_color_buffer_float" "\0"
  /* 15055 */ "WEBGL_compressed_texture_astc" "\0"
  /* 15085 */ "WEBGL_compressed_texture_etc" "\0"
  /* 15114 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 15144 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 15175 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 15205 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 15240 */ "WEBGL_debug_renderer_info" "\0"
  /* 15266 */ "WEBGL_debug_shaders" "\0"
  /* 15286 */ "WEBGL_depth_texture" "\0"
  /* 15306 */ "WEBGL_draw_buffers" "\0"
  /* 15325 */ "WEBGL_explicit_present" "\0"
  /* 15348 */ "WEBGL_lose_context" "\0"
  /* 15367 */ "WaveShaperNode" "\0"
  /* 15382 */ "WebExtensionContentScript" "\0"
  /* 15408 */ "WebExtensionPolicy" "\0"
  /* 15427 */ "WebGL2RenderingContext" "\0"
  /* 15450 */ "WebGLActiveInfo" "\0"
  /* 15466 */ "WebGLBuffer" "\0"
  /* 15478 */ "WebGLContextEvent" "\0"
  /* 15496 */ "WebGLFramebuffer" "\0"
  /* 15513 */ "WebGLProgram" "\0"
  /* 15526 */ "WebGLQuery" "\0"
  /* 15537 */ "WebGLRenderbuffer" "\0"
  /* 15555 */ "WebGLRenderingContext" "\0"
  /* 15577 */ "WebGLSampler" "\0"
  /* 15590 */ "WebGLShader" "\0"
  /* 15602 */ "WebGLShaderPrecisionFormat" "\0"
  /* 15629 */ "WebGLSync" "\0"
  /* 15639 */ "WebGLTexture" "\0"
  /* 15652 */ "WebGLTransformFeedback" "\0"
  /* 15675 */ "WebGLUniformLocation" "\0"
  /* 15696 */ "WebGLVertexArrayObject" "\0"
  /* 15719 */ "WebKitCSSMatrix" "\0"
  /* 15735 */ "WebSocket" "\0"
  /* 15745 */ "WebTransport" "\0"
  /* 15758 */ "WebTransportBidirectionalStream" "\0"
  /* 15790 */ "WebTransportDatagramDuplexStream" "\0"
  /* 15823 */ "WebTransportError" "\0"
  /* 15841 */ "WebTransportReceiveStream" "\0"
  /* 15867 */ "WebTransportSendStream" "\0"
  /* 15890 */ "WebrtcGlobalInformation" "\0"
  /* 15914 */ "WheelEvent" "\0"
  /* 15925 */ "Window" "\0"
  /* 15932 */ "WindowClient" "\0"
  /* 15945 */ "WindowContext" "\0"
  /* 15959 */ "WindowGlobalChild" "\0"
  /* 15977 */ "WindowGlobalParent" "\0"
  /* 15996 */ "WindowRoot" "\0"
  /* 16007 */ "Worker" "\0"
  /* 16014 */ "WorkerDebuggerGlobalScope" "\0"
  /* 16040 */ "WorkerGlobalScope" "\0"
  /* 16058 */ "WorkerLocation" "\0"
  /* 16073 */ "WorkerNavigator" "\0"
  /* 16089 */ "WorkerTestUtils" "\0"
  /* 16105 */ "Worklet" "\0"
  /* 16113 */ "WorkletGlobalScope" "\0"
  /* 16132 */ "WritableStream" "\0"
  /* 16147 */ "WritableStreamDefaultController" "\0"
  /* 16179 */ "WritableStreamDefaultWriter" "\0"
  /* 16207 */ "XMLDocument" "\0"
  /* 16219 */ "XMLHttpRequest" "\0"
  /* 16234 */ "XMLHttpRequestEventTarget" "\0"
  /* 16260 */ "XMLHttpRequestUpload" "\0"
  /* 16281 */ "XMLSerializer" "\0"
  /* 16295 */ "XPathEvaluator" "\0"
  /* 16310 */ "XPathExpression" "\0"
  /* 16326 */ "XPathResult" "\0"
  /* 16338 */ "XRBoundedReferenceSpace" "\0"
  /* 16362 */ "XRFrame" "\0"
  /* 16370 */ "XRInputSource" "\0"
  /* 16384 */ "XRInputSourceArray" "\0"
  /* 16403 */ "XRInputSourceEvent" "\0"
  /* 16422 */ "XRInputSourcesChangeEvent" "\0"
  /* 16448 */ "XRPose" "\0"
  /* 16455 */ "XRReferenceSpace" "\0"
  /* 16472 */ "XRReferenceSpaceEvent" "\0"
  /* 16494 */ "XRRenderState" "\0"
  /* 16508 */ "XRRigidTransform" "\0"
  /* 16525 */ "XRSession" "\0"
  /* 16535 */ "XRSessionEvent" "\0"
  /* 16550 */ "XRSpace" "\0"
  /* 16558 */ "XRSystem" "\0"
  /* 16567 */ "XRView" "\0"
  /* 16574 */ "XRViewerPose" "\0"
  /* 16587 */ "XRViewport" "\0"
  /* 16598 */ "XRWebGLLayer" "\0"
  /* 16611 */ "XSLTProcessor" "\0"
  /* 16625 */ "XULCommandEvent" "\0"
  /* 16641 */ "XULElement" "\0"
  /* 16652 */ "XULFrameElement" "\0"
  /* 16668 */ "XULMenuElement" "\0"
  /* 16683 */ "XULPopupElement" "\0"
  /* 16699 */ "XULResizerElement" "\0"
  /* 16717 */ "XULTextElement" "\0"
  /* 16732 */ "XULTreeElement" "\0"
  /* 16747 */ "console" "\0"
  /* 16755 */ "mozRTCIceCandidate" "\0"
  /* 16774 */ "mozRTCPeerConnection" "\0"
  /* 16795 */ "mozRTCSessionDescription" "\0"
  /* 16820 */ "webkitSpeechGrammar" "\0"
  /* 16840 */ "webkitSpeechGrammarList" "\0"
  /* 16864 */ "webkitSpeechRecognition" "\0"
  /* 16888 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

