//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFetch_h
#define PFetch_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/IPCForwards.h"
#include "mozilla/ipc/Shmem.h"
#include "mozilla/dom/ClientIPCTypes.h"
#include "mozilla/dom/FetchTypes.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/net/NeckoChannelParams.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/PerformanceTimingTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FetchOpArgs|
//
namespace mozilla {
namespace dom {
class FetchOpArgs final
{
private:
    typedef ::mozilla::dom::IPCInternalRequest IPCInternalRequest;
    typedef ::mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef ::nsCString nsCString;
    typedef ::mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef ::mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef ::mozilla::net::CookieJarSettingsArgs CookieJarSettingsArgs;

public:
    MOZ_IMPLICIT FetchOpArgs() :
        request_(),
        principalInfo_(),
        workerScript_(),
        clientInfo_(),
        controller_(),
        cookieJarSettings_(),
        needOnDataAvailable_(),
        hasCSPEventListener_()
    {
    }

    MOZ_IMPLICIT FetchOpArgs(
            const IPCInternalRequest& _request,
            const PrincipalInfo& _principalInfo,
            const nsCString& _workerScript,
            const IPCClientInfo& _clientInfo,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const mozilla::Maybe<CookieJarSettingsArgs>& _cookieJarSettings,
            const bool& _needOnDataAvailable,
            const bool& _hasCSPEventListener) :
        request_(_request),
        principalInfo_(_principalInfo),
        workerScript_(_workerScript),
        clientInfo_(_clientInfo),
        controller_(_controller),
        cookieJarSettings_(_cookieJarSettings),
        needOnDataAvailable_(_needOnDataAvailable),
        hasCSPEventListener_(_hasCSPEventListener)
    {
    }

    IPCInternalRequest&
    request()
    {
        return request_;
    }
    const IPCInternalRequest&
    request() const
    {
        return request_;
    }

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    nsCString&
    workerScript()
    {
        return workerScript_;
    }
    const nsCString&
    workerScript() const
    {
        return workerScript_;
    }

    IPCClientInfo&
    clientInfo()
    {
        return clientInfo_;
    }
    const IPCClientInfo&
    clientInfo() const
    {
        return clientInfo_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    mozilla::Maybe<CookieJarSettingsArgs>&
    cookieJarSettings()
    {
        return cookieJarSettings_;
    }
    const mozilla::Maybe<CookieJarSettingsArgs>&
    cookieJarSettings() const
    {
        return cookieJarSettings_;
    }

    bool&
    needOnDataAvailable()
    {
        return needOnDataAvailable_;
    }
    const bool&
    needOnDataAvailable() const
    {
        return needOnDataAvailable_;
    }

    bool&
    hasCSPEventListener()
    {
        return hasCSPEventListener_;
    }
    const bool&
    hasCSPEventListener() const
    {
        return hasCSPEventListener_;
    }

private:
    IPCInternalRequest request_;
    PrincipalInfo principalInfo_;
    nsCString workerScript_;
    IPCClientInfo clientInfo_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    mozilla::Maybe<CookieJarSettingsArgs> cookieJarSettings_;
    bool needOnDataAvailable_;
    bool hasCSPEventListener_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::FetchOpArgs>
{
    typedef ::mozilla::dom::FetchOpArgs paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static mozilla::Maybe<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

namespace mozilla {
namespace dom {
class PFetchParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PFetchChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFetchChild and PFetchParent
//
namespace mozilla {
namespace dom {
namespace PFetch {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<::mozilla::dom::PFetchParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::dom::PFetchChild>* aChild);

enum MessageType {
    PFetchStart = PFetchMsgStart << 16,
    Msg_FetchOp__ID,
    Msg_AbortFetchOp__ID,
    Msg_OnResponseAvailableInternal__ID,
    Msg_OnResponseEnd__ID,
    Msg_OnDataAvailable__ID,
    Msg_OnFlushConsoleReport__ID,
    Msg_OnCSPViolationEvent__ID,
    Msg_OnReportPerformanceTiming__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PFetchEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_FetchOp(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_AbortFetchOp(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnResponseAvailableInternal(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnResponseEnd(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnDataAvailable(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnFlushConsoleReport(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnCSPViolationEvent(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OnReportPerformanceTiming(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId);



} // namespace PFetch
} // namespace dom
} // namespace mozilla

#endif // ifndef PFetch_h
