//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebTransport_h
#define PWebTransport_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/IPCForwards.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/ipc/DataPipe.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BidirectionalStream|
//
namespace mozilla {
namespace dom {
class BidirectionalStream final
{
private:
    typedef ::mozilla::ipc::DataPipeReceiver DataPipeReceiver;
    typedef ::mozilla::ipc::DataPipeSender DataPipeSender;

public:
    MOZ_IMPLICIT BidirectionalStream() :
        inStream_(),
        outStream_()
    {
    }

    MOZ_IMPLICIT BidirectionalStream(
            DataPipeReceiver* _inStream,
            DataPipeSender* _outStream) :
        inStream_(_inStream),
        outStream_(_outStream)
    {
    }

    RefPtr<DataPipeReceiver>&
    inStream()
    {
        return inStream_;
    }
    DataPipeReceiver*
    inStream() const
    {
        return inStream_;
    }

    RefPtr<DataPipeSender>&
    outStream()
    {
        return outStream_;
    }
    DataPipeSender*
    outStream() const
    {
        return outStream_;
    }

private:
    RefPtr<DataPipeReceiver> inStream_;
    RefPtr<DataPipeSender> outStream_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::BidirectionalStream>
{
    typedef ::mozilla::dom::BidirectionalStream paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static mozilla::Maybe<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BidirectionalStreamResponse|
//
namespace mozilla {
namespace dom {
class BidirectionalStreamResponse final
{
public:
    enum Type {
        T__None,
        Tnsresult = 1,
        TBidirectionalStream,
        T__Last = TBidirectionalStream
    };

private:
    typedef ::nsresult nsresult;
    typedef ::mozilla::dom::BidirectionalStream BidirectionalStream;
    typedef nsresult nsresult__tdef;
    typedef BidirectionalStream BidirectionalStream__tdef;

    union Value {
        mozilla::AlignedStorage2<nsresult> Vnsresult;
        mozilla::AlignedStorage2<BidirectionalStream> VBidirectionalStream;
    };

    nsresult*
    ptr_nsresult()
    {
        return ((mValue).Vnsresult).addr();
    }
    const nsresult*
    constptr_nsresult() const
    {
        return ((mValue).Vnsresult).addr();
    }
    BidirectionalStream*
    ptr_BidirectionalStream()
    {
        return ((mValue).VBidirectionalStream).addr();
    }
    const BidirectionalStream*
    constptr_BidirectionalStream() const
    {
        return ((mValue).VBidirectionalStream).addr();
    }

    void
    MaybeDestroy();

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BidirectionalStreamResponse() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BidirectionalStreamResponse(const nsresult& aOther);

    MOZ_IMPLICIT BidirectionalStreamResponse(nsresult&& aOther);

    MOZ_IMPLICIT BidirectionalStreamResponse(const BidirectionalStream& aOther);

    MOZ_IMPLICIT BidirectionalStreamResponse(BidirectionalStream&& aOther);

    MOZ_IMPLICIT BidirectionalStreamResponse(const BidirectionalStreamResponse& aOther);

    MOZ_IMPLICIT BidirectionalStreamResponse(BidirectionalStreamResponse&& aOther);

    ~BidirectionalStreamResponse();

    Type
    type() const
    {
        return mType;
    }

    BidirectionalStreamResponse&
    operator=(const nsresult& aRhs);

    BidirectionalStreamResponse&
    operator=(nsresult&& aRhs);

    BidirectionalStreamResponse&
    operator=(const BidirectionalStream& aRhs);

    BidirectionalStreamResponse&
    operator=(BidirectionalStream&& aRhs);

    BidirectionalStreamResponse&
    operator=(const BidirectionalStreamResponse& aRhs);

    BidirectionalStreamResponse&
    operator=(BidirectionalStreamResponse&& aRhs);

    nsresult&
    get_nsresult()
    {
        AssertSanity(Tnsresult);
        return (*(ptr_nsresult()));
    }
    const nsresult&
    get_nsresult() const
    {
        AssertSanity(Tnsresult);
        return (*(constptr_nsresult()));
    }
    operator nsresult&()
    {
        return get_nsresult();
    }
    operator const nsresult&() const
    {
        return get_nsresult();
    }

    BidirectionalStream&
    get_BidirectionalStream()
    {
        AssertSanity(TBidirectionalStream);
        return (*(ptr_BidirectionalStream()));
    }
    const BidirectionalStream&
    get_BidirectionalStream() const
    {
        AssertSanity(TBidirectionalStream);
        return (*(constptr_BidirectionalStream()));
    }
    operator BidirectionalStream&()
    {
        return get_BidirectionalStream();
    }
    operator const BidirectionalStream&() const
    {
        return get_BidirectionalStream();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::dom::BidirectionalStreamResponse>
{
    typedef ::mozilla::dom::BidirectionalStreamResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static mozilla::Maybe<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

namespace mozilla {
namespace dom {
class PWebTransportParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PWebTransportChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PWebTransportChild and PWebTransportParent
//
namespace mozilla {
namespace dom {
namespace PWebTransport {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<::mozilla::dom::PWebTransportParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::dom::PWebTransportChild>* aChild);

nsresult
CreateEndpoints(
        mozilla::ipc::Endpoint<::mozilla::dom::PWebTransportParent>* aParent,
        mozilla::ipc::Endpoint<::mozilla::dom::PWebTransportChild>* aChild);

enum MessageType {
    PWebTransportStart = PWebTransportMsgStart << 16,
    Msg_Close__ID,
    Msg_CreateUnidirectionalStream__ID,
    Reply_CreateUnidirectionalStream__ID,
    Msg_CreateBidirectionalStream__ID,
    Reply_CreateBidirectionalStream__ID,
    Msg_OutgoingDatagram__ID,
    Reply_OutgoingDatagram__ID,
    Msg_IncomingUnidirectionalStream__ID,
    Msg_IncomingBidirectionalStream__ID,
    Msg_IncomingDatagram__ID,
    Msg_RemoteClosed__ID,
    Msg_CloseAll__ID,
    Reply_CloseAll__ID,
    PWebTransportEnd
};

mozilla::UniquePtr<IPC::Message>
Msg_Close(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CreateUnidirectionalStream(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_CreateUnidirectionalStream(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CreateBidirectionalStream(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_CreateBidirectionalStream(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_OutgoingDatagram(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_OutgoingDatagram(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_IncomingUnidirectionalStream(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_IncomingBidirectionalStream(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_IncomingDatagram(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_RemoteClosed(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CloseAll(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply_CloseAll(int32_t routingId);



} // namespace PWebTransport
} // namespace dom
} // namespace mozilla

#endif // ifndef PWebTransport_h
