//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef HttpChannelParams_h
#define HttpChannelParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/IPCForwards.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/net/DNS.h"
#include "nsILoadInfo.h"
#include "nsIReferrerInfo.h"
#include "nsIRequest.h"
#include "nsITRRSkipReason.h"
#include "nsITransportSecurityInfo.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/net/NeckoChannelParams.h"
#include "mozilla/ipc/IPCStream.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOnStartRequestArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOnStartRequestArgs final
{
private:
    typedef ::nsITransportSecurityInfo nsITransportSecurityInfo;
    typedef ::nsIReferrerInfo nsIReferrerInfo;
    typedef ::uint64_t uint64_t;
    typedef ::int64_t int64_t;
    typedef ::nsCString nsCString;
    typedef ::mozilla::net::NetAddr NetAddr;
    typedef ::mozilla::net::ResourceTimingStructArgs ResourceTimingStructArgs;
    typedef ::mozilla::net::ParentLoadInfoForwarderArgs ParentLoadInfoForwarderArgs;
    typedef ::nsresult nsresult;
    typedef ::nsIRequest::TRRMode TRRMode;
    typedef ::mozilla::net::TRRSkippedReason TRRSkippedReason;
    typedef ::uint32_t uint32_t;
    typedef ::nsILoadInfo::CrossOriginOpenerPolicy CrossOriginOpenerPolicy;
    typedef ::uint8_t uint8_t;

public:
    MOZ_IMPLICIT HttpChannelOnStartRequestArgs() :
        securityInfo_(),
        overrideReferrerInfo_(),
        altDataType_(),
        cookie_(),
        selfAddr_(),
        peerAddr_(),
        timing_(),
        loadInfoForwarder_(),
        channelStatus_(),
        effectiveTRRMode_(),
        trrSkipReason_(),
        multiPartID_(),
        isFromCache_(),
        isRacing_(),
        cacheEntryAvailable_(),
        deliveringAltData_(),
        applyConversion_(),
        isResolvedByTRR_(),
        allRedirectsSameOrigin_(),
        isFirstPartOfMultiPart_(),
        isLastPartOfMultiPart_(),
        openerPolicy_(),
        shouldWaitForOnStartRequestSent_(),
        dataFromSocketProcess_(),
        hasHTTPSRR_(),
        isProxyUsed_(),
        cacheEntryId_(),
        altDataLength_(),
        cacheFetchCount_(),
        cacheExpirationTime_(),
        cacheKey_(),
        redirectCount_()
    {
    }

    MOZ_IMPLICIT HttpChannelOnStartRequestArgs(
            nsITransportSecurityInfo* _securityInfo,
            nsIReferrerInfo* _overrideReferrerInfo,
            const uint64_t& _cacheEntryId,
            const int64_t& _altDataLength,
            const nsCString& _altDataType,
            const nsCString& _cookie,
            const NetAddr& _selfAddr,
            const NetAddr& _peerAddr,
            const ResourceTimingStructArgs& _timing,
            const ParentLoadInfoForwarderArgs& _loadInfoForwarder,
            const nsresult& _channelStatus,
            const TRRMode& _effectiveTRRMode,
            const TRRSkippedReason& _trrSkipReason,
            const uint32_t& _cacheFetchCount,
            const uint32_t& _cacheExpirationTime,
            const uint32_t& _cacheKey,
            const mozilla::Maybe<uint32_t>& _multiPartID,
            const bool& _isFromCache,
            const bool& _isRacing,
            const bool& _cacheEntryAvailable,
            const bool& _deliveringAltData,
            const bool& _applyConversion,
            const bool& _isResolvedByTRR,
            const bool& _allRedirectsSameOrigin,
            const bool& _isFirstPartOfMultiPart,
            const bool& _isLastPartOfMultiPart,
            const CrossOriginOpenerPolicy& _openerPolicy,
            const bool& _shouldWaitForOnStartRequestSent,
            const bool& _dataFromSocketProcess,
            const bool& _hasHTTPSRR,
            const bool& _isProxyUsed,
            const uint8_t& _redirectCount) :
        securityInfo_(_securityInfo),
        overrideReferrerInfo_(_overrideReferrerInfo),
        altDataType_(_altDataType),
        cookie_(_cookie),
        selfAddr_(_selfAddr),
        peerAddr_(_peerAddr),
        timing_(_timing),
        loadInfoForwarder_(_loadInfoForwarder),
        channelStatus_(_channelStatus),
        effectiveTRRMode_(_effectiveTRRMode),
        trrSkipReason_(_trrSkipReason),
        multiPartID_(_multiPartID),
        isFromCache_(_isFromCache),
        isRacing_(_isRacing),
        cacheEntryAvailable_(_cacheEntryAvailable),
        deliveringAltData_(_deliveringAltData),
        applyConversion_(_applyConversion),
        isResolvedByTRR_(_isResolvedByTRR),
        allRedirectsSameOrigin_(_allRedirectsSameOrigin),
        isFirstPartOfMultiPart_(_isFirstPartOfMultiPart),
        isLastPartOfMultiPart_(_isLastPartOfMultiPart),
        openerPolicy_(_openerPolicy),
        shouldWaitForOnStartRequestSent_(_shouldWaitForOnStartRequestSent),
        dataFromSocketProcess_(_dataFromSocketProcess),
        hasHTTPSRR_(_hasHTTPSRR),
        isProxyUsed_(_isProxyUsed),
        cacheEntryId_(_cacheEntryId),
        altDataLength_(_altDataLength),
        cacheFetchCount_(_cacheFetchCount),
        cacheExpirationTime_(_cacheExpirationTime),
        cacheKey_(_cacheKey),
        redirectCount_(_redirectCount)
    {
    }

    RefPtr<nsITransportSecurityInfo>&
    securityInfo()
    {
        return securityInfo_;
    }
    nsITransportSecurityInfo*
    securityInfo() const
    {
        return securityInfo_;
    }

    RefPtr<nsIReferrerInfo>&
    overrideReferrerInfo()
    {
        return overrideReferrerInfo_;
    }
    nsIReferrerInfo*
    overrideReferrerInfo() const
    {
        return overrideReferrerInfo_;
    }

    uint64_t&
    cacheEntryId()
    {
        return cacheEntryId_;
    }
    const uint64_t&
    cacheEntryId() const
    {
        return cacheEntryId_;
    }

    int64_t&
    altDataLength()
    {
        return altDataLength_;
    }
    const int64_t&
    altDataLength() const
    {
        return altDataLength_;
    }

    nsCString&
    altDataType()
    {
        return altDataType_;
    }
    const nsCString&
    altDataType() const
    {
        return altDataType_;
    }

    nsCString&
    cookie()
    {
        return cookie_;
    }
    const nsCString&
    cookie() const
    {
        return cookie_;
    }

    NetAddr&
    selfAddr()
    {
        return selfAddr_;
    }
    const NetAddr&
    selfAddr() const
    {
        return selfAddr_;
    }

    NetAddr&
    peerAddr()
    {
        return peerAddr_;
    }
    const NetAddr&
    peerAddr() const
    {
        return peerAddr_;
    }

    ResourceTimingStructArgs&
    timing()
    {
        return timing_;
    }
    const ResourceTimingStructArgs&
    timing() const
    {
        return timing_;
    }

    ParentLoadInfoForwarderArgs&
    loadInfoForwarder()
    {
        return loadInfoForwarder_;
    }
    const ParentLoadInfoForwarderArgs&
    loadInfoForwarder() const
    {
        return loadInfoForwarder_;
    }

    nsresult&
    channelStatus()
    {
        return channelStatus_;
    }
    const nsresult&
    channelStatus() const
    {
        return channelStatus_;
    }

    TRRMode&
    effectiveTRRMode()
    {
        return effectiveTRRMode_;
    }
    const TRRMode&
    effectiveTRRMode() const
    {
        return effectiveTRRMode_;
    }

    TRRSkippedReason&
    trrSkipReason()
    {
        return trrSkipReason_;
    }
    const TRRSkippedReason&
    trrSkipReason() const
    {
        return trrSkipReason_;
    }

    uint32_t&
    cacheFetchCount()
    {
        return cacheFetchCount_;
    }
    const uint32_t&
    cacheFetchCount() const
    {
        return cacheFetchCount_;
    }

    uint32_t&
    cacheExpirationTime()
    {
        return cacheExpirationTime_;
    }
    const uint32_t&
    cacheExpirationTime() const
    {
        return cacheExpirationTime_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    mozilla::Maybe<uint32_t>&
    multiPartID()
    {
        return multiPartID_;
    }
    const mozilla::Maybe<uint32_t>&
    multiPartID() const
    {
        return multiPartID_;
    }

    bool&
    isFromCache()
    {
        return isFromCache_;
    }
    const bool&
    isFromCache() const
    {
        return isFromCache_;
    }

    bool&
    isRacing()
    {
        return isRacing_;
    }
    const bool&
    isRacing() const
    {
        return isRacing_;
    }

    bool&
    cacheEntryAvailable()
    {
        return cacheEntryAvailable_;
    }
    const bool&
    cacheEntryAvailable() const
    {
        return cacheEntryAvailable_;
    }

    bool&
    deliveringAltData()
    {
        return deliveringAltData_;
    }
    const bool&
    deliveringAltData() const
    {
        return deliveringAltData_;
    }

    bool&
    applyConversion()
    {
        return applyConversion_;
    }
    const bool&
    applyConversion() const
    {
        return applyConversion_;
    }

    bool&
    isResolvedByTRR()
    {
        return isResolvedByTRR_;
    }
    const bool&
    isResolvedByTRR() const
    {
        return isResolvedByTRR_;
    }

    bool&
    allRedirectsSameOrigin()
    {
        return allRedirectsSameOrigin_;
    }
    const bool&
    allRedirectsSameOrigin() const
    {
        return allRedirectsSameOrigin_;
    }

    bool&
    isFirstPartOfMultiPart()
    {
        return isFirstPartOfMultiPart_;
    }
    const bool&
    isFirstPartOfMultiPart() const
    {
        return isFirstPartOfMultiPart_;
    }

    bool&
    isLastPartOfMultiPart()
    {
        return isLastPartOfMultiPart_;
    }
    const bool&
    isLastPartOfMultiPart() const
    {
        return isLastPartOfMultiPart_;
    }

    CrossOriginOpenerPolicy&
    openerPolicy()
    {
        return openerPolicy_;
    }
    const CrossOriginOpenerPolicy&
    openerPolicy() const
    {
        return openerPolicy_;
    }

    bool&
    shouldWaitForOnStartRequestSent()
    {
        return shouldWaitForOnStartRequestSent_;
    }
    const bool&
    shouldWaitForOnStartRequestSent() const
    {
        return shouldWaitForOnStartRequestSent_;
    }

    bool&
    dataFromSocketProcess()
    {
        return dataFromSocketProcess_;
    }
    const bool&
    dataFromSocketProcess() const
    {
        return dataFromSocketProcess_;
    }

    bool&
    hasHTTPSRR()
    {
        return hasHTTPSRR_;
    }
    const bool&
    hasHTTPSRR() const
    {
        return hasHTTPSRR_;
    }

    bool&
    isProxyUsed()
    {
        return isProxyUsed_;
    }
    const bool&
    isProxyUsed() const
    {
        return isProxyUsed_;
    }

    uint8_t&
    redirectCount()
    {
        return redirectCount_;
    }
    const uint8_t&
    redirectCount() const
    {
        return redirectCount_;
    }

private:
    void
    StaticAssertions() const;
    RefPtr<nsITransportSecurityInfo> securityInfo_;
    RefPtr<nsIReferrerInfo> overrideReferrerInfo_;
    nsCString altDataType_;
    nsCString cookie_;
    NetAddr selfAddr_;
    NetAddr peerAddr_;
    ResourceTimingStructArgs timing_;
    ParentLoadInfoForwarderArgs loadInfoForwarder_;
    nsresult channelStatus_;
    TRRMode effectiveTRRMode_;
    TRRSkippedReason trrSkipReason_;
    mozilla::Maybe<uint32_t> multiPartID_;
    bool isFromCache_;
    bool isRacing_;
    bool cacheEntryAvailable_;
    bool deliveringAltData_;
    bool applyConversion_;
    bool isResolvedByTRR_;
    bool allRedirectsSameOrigin_;
    bool isFirstPartOfMultiPart_;
    bool isLastPartOfMultiPart_;
    CrossOriginOpenerPolicy openerPolicy_;
    bool shouldWaitForOnStartRequestSent_;
    bool dataFromSocketProcess_;
    bool hasHTTPSRR_;
    bool isProxyUsed_;
    uint64_t cacheEntryId_;
    int64_t altDataLength_;
    uint32_t cacheFetchCount_;
    uint32_t cacheExpirationTime_;
    uint32_t cacheKey_;
    uint8_t redirectCount_;
};
} // namespace net
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::net::HttpChannelOnStartRequestArgs>
{
    typedef ::mozilla::net::HttpChannelOnStartRequestArgs paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static mozilla::Maybe<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelAltDataStream|
//
namespace mozilla {
namespace net {
class HttpChannelAltDataStream final
{
private:
    typedef ::mozilla::ipc::IPCStream IPCStream;

public:
    MOZ_IMPLICIT HttpChannelAltDataStream() :
        altDataInputStream_()
    {
    }

    MOZ_IMPLICIT HttpChannelAltDataStream(const mozilla::Maybe<IPCStream>& _altDataInputStream) :
        altDataInputStream_(_altDataInputStream)
    {
    }

    mozilla::Maybe<IPCStream>&
    altDataInputStream()
    {
        return altDataInputStream_;
    }
    const mozilla::Maybe<IPCStream>&
    altDataInputStream() const
    {
        return altDataInputStream_;
    }

private:
    mozilla::Maybe<IPCStream> altDataInputStream_;
};
} // namespace net
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <::mozilla::net::HttpChannelAltDataStream>
{
    typedef ::mozilla::net::HttpChannelAltDataStream paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static mozilla::Maybe<paramType>
    Read(IPC::MessageReader* aReader);
};
} // namespace IPC

#endif // ifndef HttpChannelParams_h
