// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

pub mod browser_launched_to_handle {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SystemNotificationExtra {
        pub action: Option<String>,
        pub name: Option<String>,
    }

    impl ExtraKeys for SystemNotificationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.name.and_then(|val| map.insert("name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.launched_to_handle.system_notification
    ///
    /// Recorded when Firefox launches to complete a native notification popped by a
    /// system (chrome privileged) alert.  Windows-only at the time of writing.
    pub static system_notification: Lazy<EventMetric<SystemNotificationExtra>> = Lazy::new(|| {
        EventMetric::new(1.into(), CommonMetricData {
            name: "system_notification".into(),
            category: "browser.launched_to_handle".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_update {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons_to_not_update
    ///
    /// Records which error was causing the background updater to fail. This list
    /// supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
    pub static reasons_to_not_update: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(2.into(), CommonMetricData {
            name: "reasons_to_not_update".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.time_last_update_scheduled
    ///
    /// Last time the background update was triggered.
    pub static time_last_update_scheduled: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(3.into(), CommonMetricData {
            name: "time_last_update_scheduled".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.client_id
    ///
    /// The legacy Telemetry client ID of this installation's default profile.
    /// The default profile is as determined by the Profile Service, namely
    /// `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one
    /// Firefox installation and only one profile, so the default profile is their
    /// regular browsing profile.
    /// It is possible for a Firefox installation to not have a default profile, but in
    /// such cases the background update task will abort before sending any telemetry;
    /// therefore, the legacy Telemetry client ID should always be present.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(4.into(), CommonMetricData {
            name: "client_id".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into(), "baseline".into(), "events".into(), "metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exists
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, and
    /// there was no exception thrown reading it.
    pub static targeting_exists: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(5.into(), CommonMetricData {
            name: "targeting_exists".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exception
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, but an
    /// exception was thrown reading it.
    pub static targeting_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(6.into(), CommonMetricData {
            name: "targeting_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_version
    ///
    /// If the default profile had a targeting snapshot serialized to disk, the
    /// `version` of the snapshot.
    /// This version number does not have a physical unit: it's only useful to compare
    /// between versions.
    pub static targeting_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(7.into(), CommonMetricData {
            name: "targeting_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_firefox_version
    ///
    /// The `environment.firefoxVersion` of the default profile's serialized targeting
    /// snapshot.  At the time of writing, this version is an integer representing the
    /// Firefox major version, e.g., `109`.
    pub static targeting_env_firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(8.into(), CommonMetricData {
            name: "targeting_env_firefox_version".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_current_date
    ///
    /// The `environment.currentDate` of the default profile's serialized targeting
    /// snapshot.
    pub static targeting_env_current_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(9.into(), CommonMetricData {
            name: "targeting_env_current_date".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_profile_age
    ///
    /// The `environment.profileAgeCreated` of the default profile's serialized
    /// targeting snapshot.
    pub static targeting_env_profile_age: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(10.into(), CommonMetricData {
            name: "targeting_env_profile_age".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.final_state
    ///
    /// String description of the final state the update state machine reached.
    pub static final_state: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(11.into(), CommonMetricData {
            name: "final_state".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.states
    ///
    /// Ordered list of string descriptions of the states that the update state machine
    /// reached.
    pub static states: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(12.into(), CommonMetricData {
            name: "states".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons
    ///
    /// List of reasons that the background update task did not run.
    pub static reasons: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(13.into(), CommonMetricData {
            name: "reasons".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_success
    ///
    /// True if the exit code/status of the background update task is 0, which means
    /// success.
    pub static exit_code_success: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(14.into(), CommonMetricData {
            name: "exit_code_success".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_exception
    ///
    /// True if the exit code/status of the background update task is 3, which means an
    /// exception was thrown.
    pub static exit_code_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(15.into(), CommonMetricData {
            name: "exit_code_exception".into(),
            category: "background_update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.locale
    ///
    /// The application's locale as of when newtab's TelemetryFeed was init. Comes from
    /// `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(16.into(), CommonMetricData {
            name: "locale".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.newtab_category
    ///
    /// The current setting of the newtab page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `newtab_url_category`. Sampled once after newtab init.
    pub static newtab_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(17.into(), CommonMetricData {
            name: "newtab_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.homepage_category
    ///
    /// The current setting of the home page. One of ["enabled", "disabled",
    /// "extension"] or any value from SiteClassifier like "known-hijacker" or "social-
    /// media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's
    /// `home_url_category`. Sampled once after newtab init.
    pub static homepage_category: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(18.into(), CommonMetricData {
            name: "homepage_category".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct OpenedExtra {
        pub newtab_visit_id: Option<String>,
        pub source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.opened
    ///
    /// Recorded when newtab UI is opened via `about:newtab` or `about:home` or
    /// `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in
    /// [detect-user-session-start.js](https://searchfox.org/mozilla-
    /// central/source/browser/components/newtab/content-src/lib/detect-user-session-
    /// start.js)).
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        EventMetric::new(19.into(), CommonMetricData {
            name: "opened".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClosedExtra {
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.closed
    ///
    /// Recorded when newtab UI is closed by * navigation * closing the tab
    /// Doesn't mean that the newtab was ever visible to a user.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        EventMetric::new(20.into(), CommonMetricData {
            name: "closed".into(),
            category: "newtab".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.enabled
    ///
    /// Whether the search input is enabled on the newtab. Corresponds to the value of
    /// the `browser.newtabpage.activity-stream.showSearch` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(21.into(), CommonMetricData {
            name: "enabled".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct IssuedExtra {
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for IssuedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.issued
    ///
    /// When Firefox was asked to issue a search from a Search Access Point (SAP) on a
    /// newtab page. Doesn't record searches in Private Browsing Mode unless
    /// `browser.engagement.search_counts.pbm` is set to `true`.
    pub static issued: Lazy<EventMetric<IssuedExtra>> = Lazy::new(|| {
        EventMetric::new(22.into(), CommonMetricData {
            name: "issued".into(),
            category: "newtab.search".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod topsites {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from topsites.enabled
    ///
    /// Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section.
    /// Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.topsites` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(23.into(), CommonMetricData {
            name: "enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_enabled
    ///
    /// Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored
    /// Shortcuts" section. Corresponds to the value of the
    /// `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true`
    /// even if topsites.enabled is `false`.
    pub static sponsored_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(24.into(), CommonMetricData {
            name: "sponsored_enabled".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.impression
    ///
    /// Recorded when topsite tiles are loaded.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(25.into(), CommonMetricData {
            name: "impression".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.click
    ///
    /// Recorded when a topsite tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(26.into(), CommonMetricData {
            name: "click".into(),
            category: "topsites".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pocket {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from pocket.is_signed_in
    ///
    /// Whether the Firefox user is signed in to Pocket. Does not correspond to a pref,
    /// so its value is resampled at newtab's component init and whenever there is a
    /// Discovery Stream user event.
    pub static is_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(27.into(), CommonMetricData {
            name: "is_signed_in".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.enabled
    ///
    /// Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket"
    /// section. Corresponds to the value of the `browser.newtabpage.activity-
    /// stream.feeds.section.topstories` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(28.into(), CommonMetricData {
            name: "enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.sponsored_stories_enabled
    ///
    /// Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the
    /// value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be
    /// `true` even if pocket.enabled is `false`.
    pub static sponsored_stories_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(29.into(), CommonMetricData {
            name: "sponsored_stories_enabled".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(30.into(), CommonMetricData {
            name: "impression".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-
    /// click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(31.into(), CommonMetricData {
            name: "click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct SaveExtra {
        pub is_sponsored: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub position: Option<u32>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_sponsored", "newtab_visit_id", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.save
    ///
    /// Recorded when a user decides to save a pocket tile. Does not mean it ends up
    /// successfully saved. Just that the user clicked on "Save to Pocket" in the
    /// little pocket tile menu.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        EventMetric::new(32.into(), CommonMetricData {
            name: "save".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct TopicClickExtra {
        pub newtab_visit_id: Option<String>,
        pub topic: Option<String>,
    }

    impl ExtraKeys for TopicClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.topic_click
    ///
    /// Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not
    /// on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static topic_click: Lazy<EventMetric<TopicClickExtra>> = Lazy::new(|| {
        EventMetric::new(33.into(), CommonMetricData {
            name: "topic_click".into(),
            category: "pocket".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod newtab_search_ad {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.impression
    ///
    /// Recorded when a newtab visit resulted in a search that loaded a Search Engine
    /// Result Page (SERP) that contains an ad link. And the SERP is visible.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(34.into(), CommonMetricData {
            name: "impression".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ClickExtra {
        pub is_follow_on: Option<bool>,
        pub is_tagged: Option<bool>,
        pub newtab_visit_id: Option<String>,
        pub search_access_point: Option<String>,
        pub telemetry_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.click
    ///
    /// Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which
    /// was loaded by a seach that began on a newtab page.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        EventMetric::new(35.into(), CommonMetricData {
            name: "click".into(),
            category: "newtab.search.ad".into(),
            send_in_pings: vec!["newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod serp {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub impression_id: Option<String>,
        pub partner_code: Option<String>,
        pub provider: Option<String>,
        pub source: Option<String>,
        pub tagged: Option<bool>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "partner_code", "provider", "source", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.impression
    ///
    /// Recorded when a search engine results page (SERP) is shown to a user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(36.into(), CommonMetricData {
            name: "impression".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub action: Option<String>,
        pub impression_id: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "impression_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.engagement
    ///
    /// Recorded user actions on a SERP.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(37.into(), CommonMetricData {
            name: "engagement".into(),
            category: "serp".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod urlbar {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AbandonmentExtra {
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["groups", "interaction", "n_chars", "n_results", "n_words", "results", "sap", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.abandonment
    ///
    /// Recorded when the user abandons a search (blurring the urlbar).
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        EventMetric::new(38.into(), CommonMetricData {
            name: "abandonment".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EngagementExtra {
        pub engagement_type: Option<String>,
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub provider: Option<String>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
        pub selected_result: Option<String>,
        pub selected_result_subtype: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["engagement_type", "groups", "interaction", "n_chars", "n_results", "n_words", "provider", "results", "sap", "search_mode", "selected_result", "selected_result_subtype"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.engagement_type.and_then(|val| map.insert("engagement_type".into(), val.to_string()));
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          self.selected_result.and_then(|val| map.insert("selected_result".into(), val.to_string()));
          self.selected_result_subtype.and_then(|val| map.insert("selected_result_subtype".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.engagement
    ///
    /// Recorded when the user executes an action on a result.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        EventMetric::new(39.into(), CommonMetricData {
            name: "engagement".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ImpressionExtra {
        pub groups: Option<String>,
        pub interaction: Option<String>,
        pub n_chars: Option<u32>,
        pub n_results: Option<u32>,
        pub n_words: Option<u32>,
        pub reason: Option<String>,
        pub results: Option<String>,
        pub sap: Option<String>,
        pub search_mode: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["groups", "interaction", "n_chars", "n_results", "n_words", "reason", "results", "sap", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.impression
    ///
    /// Recorded when urlbar results are shown to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        EventMetric::new(40.into(), CommonMetricData {
            name: "impression".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_max_results
    ///
    /// Maximum results to show in the Address Bar. Corresponds to the value of the
    /// `browser.urlbar.maxRichResults` pref.
    pub static pref_max_results: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(41.into(), CommonMetricData {
            name: "pref_max_results".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_topsites
    ///
    /// Whether topsite results are enabled in the urlbar. Corresponds to the value of
    /// the `browser.urlbar.suggest.topsites` pref.
    pub static pref_suggest_topsites: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(42.into(), CommonMetricData {
            name: "pref_suggest_topsites".into(),
            category: "urlbar".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod browser_engagement {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.active_ticks
    ///
    /// The number of five-second intervals ('ticks') the user was considered
    /// 'active'.
    /// 
    /// 'active' means keyboard or mouse interaction with the application.
    /// It doesn't take into account whether or not the window has focus or is in
    /// the foreground, only if it is receiving these interaction events.
    /// 
    /// Migrated from Telemetry's `browser.engagement.active_ticks`.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(43.into(), CommonMetricData {
            name: "active_ticks".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count
    ///
    /// The number of total non-unique http(s) URIs visited, including page
    /// reloads, after the session has been restored. URIs on minimized or
    /// background tabs may also be counted. Private browsing uris are included.
    /// 
    /// Migrated from Telemetry's
    /// `browser.engagement.total_uri_count_normal_and_private_mode`.
    pub static uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(44.into(), CommonMetricData {
            name: "uri_count".into(),
            category: "browser.engagement".into(),
            send_in_pings: vec!["baseline".into(), "metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod ping_centre {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_failures
    ///
    /// The number of PingCentre send failures.
    pub static send_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(45.into(), CommonMetricData {
            name: "send_failures".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_failures_by_namespace
    ///
    /// The number of PingCentre send failures,
    /// broken down by structured ingestion namespace.
    pub static send_failures_by_namespace: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(46.into(), CommonMetricData {
            name: "send_failures_by_namespace".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("activity_stream"), ::std::borrow::Cow::from("contextual_services"), ::std::borrow::Cow::from("messaging_system")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from ping.centre.send_successes_by_namespace
    ///
    /// The number of PingCentre send successes,
    /// broken down by structured ingestion namespace.
    pub static send_successes_by_namespace: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(47.into(), CommonMetricData {
            name: "send_successes_by_namespace".into(),
            category: "ping.centre".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("activity_stream"), ::std::borrow::Cow::from("contextual_services"), ::std::borrow::Cow::from("messaging_system")]))
    });

}
pub mod gmp {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from gmp.update_xml_fetch_result
    ///
    /// The result of Gecko fetching an update.xml from Balrog. This captures 3
    /// different data points: success or failure of the request, if cert pinning or
    /// content signatures were used to verify the result, and the reason for failure,
    /// if the request failed.
    pub static update_xml_fetch_result: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(48.into(), CommonMetricData {
            name: "update_xml_fetch_result".into(),
            category: "gmp".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "cert_pin_abortcert_pin_failedcert_pin_invalidcert_pin_missing_datacert_pin_net_request_errorcert_pin_net_timeoutcert_pin_successcert_pin_unknown_errorcert_pin_xml_parse_errorcontent_sig_abortcontent_sig_failedcontent_sig_invalidcontent_sig_missing_datacontent_sig_net_request_errorcontent_sig_net_timeoutcontent_sig_successcontent_sig_unknown_errorcontent_sig_xml_parse_error";const LENGTHS: [u8; 18] = [14, 15, 16, 21, 26, 20, 16, 22, 24, 17, 18, 19, 24, 29, 23, 19, 25, 27];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod rtcrtpsender {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count
    ///
    /// The number of RTCRtpSenders created.
    pub static count: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(49.into(), CommonMetricData {
            name: "count".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "used_sendencodings".into(), category: "rtcrtpsender".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_other".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count_setparameters_compat
    ///
    /// The number of RTCRtpSenders created that use the compatibility mode for
    /// setParameters.
    pub static count_setparameters_compat: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(50.into(), CommonMetricData {
            name: "count_setparameters_compat".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "warn_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_encodings".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.used_sendencodings
    ///
    /// The proportion of RTCRtpSenders that were created by an addTransceivers call
    /// that was passed a sendEncodings.
    pub static used_sendencodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(51.into(), CommonMetricData {
            name: "used_sendencodings".into(),
            category: "rtcrtpsender".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod rtcrtpsender_setparameters {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_getparameters
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call because
    /// [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough
    /// call to getParameters)
    pub static warn_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(52.into(), CommonMetricData {
            name: "warn_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_length_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the number of encodings.
    pub static warn_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(53.into(), CommonMetricData {
            name: "warn_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_rid_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that attempted to
    /// change the rid on an encoding (note that we only check this if the encoding
    /// count did not change, see warn_length_changed).
    pub static warn_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(54.into(), CommonMetricData {
            name: "warn_rid_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that did not set the
    /// transactionId field.
    pub static warn_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(55.into(), CommonMetricData {
            name: "warn_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have warned at least once about a setParameters call that used a stale
    /// transaction id.
    pub static warn_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(56.into(), CommonMetricData {
            name: "warn_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_length_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the number of encodings.
    pub static fail_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(57.into(), CommonMetricData {
            name: "fail_length_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_rid_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that attempted to change the rid on an encoding (note that
    /// we only check this if the encoding count did not change, see
    /// fail_length_changed).
    pub static fail_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(58.into(), CommonMetricData {
            name: "fail_rid_changed".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_getparameters
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call because [[LastReturnedParameters]] was not set. (ie; there
    /// was not a recent enough call to getParameters)
    pub static fail_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(59.into(), CommonMetricData {
            name: "fail_no_getparameters".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that did not set the transactionId field.
    pub static fail_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(60.into(), CommonMetricData {
            name: "fail_no_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that used a stale transaction id.
    pub static fail_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(61.into(), CommonMetricData {
            name: "fail_stale_transactionid".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_encodings
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode
    /// that have thrown an error at least once about a setParameters call that had no
    /// encodings (we do not measure this against the general population of
    /// RTCRtpSenders, since without the compat mode this failure is never observed,
    /// because it fails the length change check).
    pub static fail_no_encodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(62.into(), CommonMetricData {
            name: "fail_no_encodings".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_other
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a
    /// setParameters call that had no encodings.
    pub static fail_other: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(63.into(), CommonMetricData {
            name: "fail_other".into(),
            category: "rtcrtpsender.setparameters".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod perf {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct PageLoadExtra {
        pub fcp_time: Option<u32>,
        pub http_ver: Option<u32>,
        pub js_exec_time: Option<u32>,
        pub load_time: Option<u32>,
        pub load_type: Option<String>,
        pub redirect_count: Option<u32>,
        pub redirect_time: Option<u32>,
        pub response_time: Option<u32>,
        pub same_origin_nav: Option<bool>,
        pub trr_domain: Option<String>,
    }

    impl ExtraKeys for PageLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fcp_time", "http_ver", "js_exec_time", "load_time", "load_type", "redirect_count", "redirect_time", "response_time", "same_origin_nav", "trr_domain"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.fcp_time.and_then(|val| map.insert("fcp_time".into(), val.to_string()));
          self.http_ver.and_then(|val| map.insert("http_ver".into(), val.to_string()));
          self.js_exec_time.and_then(|val| map.insert("js_exec_time".into(), val.to_string()));
          self.load_time.and_then(|val| map.insert("load_time".into(), val.to_string()));
          self.load_type.and_then(|val| map.insert("load_type".into(), val.to_string()));
          self.redirect_count.and_then(|val| map.insert("redirect_count".into(), val.to_string()));
          self.redirect_time.and_then(|val| map.insert("redirect_time".into(), val.to_string()));
          self.response_time.and_then(|val| map.insert("response_time".into(), val.to_string()));
          self.same_origin_nav.and_then(|val| map.insert("same_origin_nav".into(), val.to_string()));
          self.trr_domain.and_then(|val| map.insert("trr_domain".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from perf.page_load
    ///
    /// Recorded when a top level content document has been loaded.
    pub static page_load: Lazy<EventMetric<PageLoadExtra>> = Lazy::new(|| {
        EventMetric::new(64.into(), CommonMetricData {
            name: "page_load".into(),
            category: "perf".into(),
            send_in_pings: vec!["pageload".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod paint {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from paint.build_displaylist_time
    ///
    /// The time to build a Gecko display list.
    pub static build_displaylist_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(65.into(), CommonMetricData {
            name: "build_displaylist_time".into(),
            category: "paint".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

}
pub mod wr {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from wr.gpu_wait_time
    ///
    /// The time spent waiting for the GPU to complete previously issued drawing
    /// commands.
    pub static gpu_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(66.into(), CommonMetricData {
            name: "gpu_wait_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_glyphs_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static rasterize_glyphs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(67.into(), CommonMetricData {
            name: "rasterize_glyphs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_blobs_time
    ///
    /// The time to rasterize blobs for consumption by WebRender.
    pub static rasterize_blobs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(68.into(), CommonMetricData {
            name: "rasterize_blobs_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time
    ///
    /// WebRender renderer time.
    pub static renderer_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(69.into(), CommonMetricData {
            name: "renderer_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time_no_sc
    ///
    /// WebRender renderer time excluding frames in which shader compilation took
    /// place.
    pub static renderer_time_no_sc: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(70.into(), CommonMetricData {
            name: "renderer_time_no_sc".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.framebuild_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static framebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(71.into(), CommonMetricData {
            name: "framebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.scenebuild_time
    ///
    /// WebRender scene build time.
    pub static scenebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(72.into(), CommonMetricData {
            name: "scenebuild_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.sceneswap_time
    ///
    /// WebRender scene swap time.
    pub static sceneswap_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(73.into(), CommonMetricData {
            name: "sceneswap_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.texture_cache_update_time
    ///
    /// Time taken by WebRender to update the texture cache.
    pub static texture_cache_update_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(74.into(), CommonMetricData {
            name: "texture_cache_update_time".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_frame_build
    ///
    /// Time elapsed between the construction of a transaction and the associated frame
    /// build beginning.
    pub static time_to_frame_build: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(75.into(), CommonMetricData {
            name: "time_to_frame_build".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_render_start
    ///
    /// Time elapsed between the construction of a frame and the start of rendering.
    pub static time_to_render_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(76.into(), CommonMetricData {
            name: "time_to_render_start".into(),
            category: "wr".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

}
pub mod netwerk {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from netwerk.early_hints
    ///
    /// Counts the different type of resources that are sent for early hints.
    pub static early_hints: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(77.into(), CommonMetricData {
            name: "early_hints".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("fetch"), ::std::borrow::Cow::from("fonts"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("scripts"), ::std::borrow::Cow::from("stylesheet")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from netwerk.eh_link_type
    ///
    /// Counts different type of link headers that are sent in early hint
    pub static eh_link_type: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(78.into(), CommonMetricData {
            name: "eh_link_type".into(),
            category: "netwerk".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "dns-prefetchiconmodulepreloadotherpreconnectprefetchpreloadprerenderstylesheet";const LENGTHS: [u8; 9] = [12, 4, 13, 5, 10, 8, 7, 9, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod network {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_per_type: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(79.into(), CommonMetricData {
            name: "data_size_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "application_otheraudiocompressediconimagemultipartocspoctet_streampdfproxytext_csstext_htmltext_javascripttext_jsontext_othertext_plainvideowasmx509xpinstall";const LENGTHS: [u8; 20] = [17, 5, 10, 4, 5, 9, 4, 12, 3, 5, 8, 9, 15, 9, 10, 10, 5, 4, 4, 9];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.data_size_pb_per_type
    ///
    /// Number of KB we transferred keyed by "contentType"
    pub static data_size_pb_per_type: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(80.into(), CommonMetricData {
            name: "data_size_pb_per_type".into(),
            category: "network".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "application_otheraudiocompressediconimagemultipartocspoctet_streampdfproxytext_csstext_htmltext_javascripttext_jsontext_othertext_plainvideowasmx509xpinstall";const LENGTHS: [u8; 20] = [17, 5, 10, 4, 5, 9, 4, 12, 3, 5, 8, 9, 15, 9, 10, 10, 5, 4, 4, 9];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod background_tasks_rmdir_base {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(81.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(82.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(83.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(84.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(85.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(86.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(87.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(88.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.base".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_quota {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(89.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(90.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(91.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(92.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(93.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(94.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(95.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(96.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.quota".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod background_tasks_rmdir_http_cache {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(97.into(), CommonMetricData {
            name: "metric_base".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(98.into(), CommonMetricData {
            name: "elapsed_ms".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(99.into(), CommonMetricData {
            name: "was_first".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.retry_count
    ///
    /// The number of retries before the task started removing the child directory.
    /// This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(100.into(), CommonMetricData {
            name: "retry_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory
    /// itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(101.into(), CommonMetricData {
            name: "removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(102.into(), CommonMetricData {
            name: "succeeded".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(103.into(), CommonMetricData {
            name: "suffix_removal_count".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(104.into(), CommonMetricData {
            name: "suffix_ever_failed".into(),
            category: "background_tasks.rmdir.http_cache".into(),
            send_in_pings: vec!["remove-directory".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.normal_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for normal windows.
    pub static normal_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric>> = Lazy::new(|| {
        LabeledMetric::new(105.into(), CommonMetricData {
            name: "normal_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.private_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for private windows.
    pub static private_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric>> = Lazy::new(|| {
        LabeledMetric::new(106.into(), CommonMetricData {
            name: "private_window_service_mode".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.service_detect_only
    ///
    /// Tracks the value of the cookiebanners.service.detectOnly pref.
    pub static service_detect_only: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(107.into(), CommonMetricData {
            name: "service_detect_only".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_load
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for every load. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads.
    pub static rule_lookup_by_load: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(108.into(), CommonMetricData {
            name: "rule_lookup_by_load".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "iframe_click_hitiframe_click_hit_opt_iniframe_click_hit_opt_outiframe_click_missiframe_cookie_hitiframe_cookie_hit_opt_iniframe_cookie_hit_opt_outiframe_cookie_missiframe_hitiframe_hit_opt_iniframe_hit_opt_outiframe_misstop_click_hittop_click_hit_opt_intop_click_hit_opt_outtop_click_misstop_cookie_hittop_cookie_hit_opt_intop_cookie_hit_opt_outtop_cookie_misstop_hittop_hit_opt_intop_hit_opt_outtop_miss";const LENGTHS: [u8; 24] = [16, 23, 24, 17, 17, 24, 25, 18, 10, 17, 18, 11, 13, 20, 21, 14, 14, 21, 22, 15, 7, 14, 15, 8];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.rule_lookup_by_domain
    ///
    /// Counts the number of hit/miss of cookie banner rule lookups for domain. We
    /// collect three types of counters, including counters for overall rule lookup,
    /// counters for cookie rule lookup and counters for click rule lookup. We also
    /// divide the counter by top-level loads and iframe loads. For each domain, we
    /// will only collect once.
    pub static rule_lookup_by_domain: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(109.into(), CommonMetricData {
            name: "rule_lookup_by_domain".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "iframe_click_hitiframe_click_hit_opt_iniframe_click_hit_opt_outiframe_click_missiframe_cookie_hitiframe_cookie_hit_opt_iniframe_cookie_hit_opt_outiframe_cookie_missiframe_hitiframe_hit_opt_iniframe_hit_opt_outiframe_misstop_click_hittop_click_hit_opt_intop_click_hit_opt_outtop_click_misstop_cookie_hittop_cookie_hit_opt_intop_cookie_hit_opt_outtop_cookie_misstop_hittop_hit_opt_intop_hit_opt_outtop_miss";const LENGTHS: [u8; 24] = [16, 23, 24, 17, 17, 24, 25, 18, 10, 17, 18, 11, 13, 20, 21, 14, 14, 21, 22, 15, 7, 14, 15, 8];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ReloadExtra {
        pub has_click_rule: Option<bool>,
        pub has_cookie_rule: Option<bool>,
        pub no_rule: Option<bool>,
    }

    impl ExtraKeys for ReloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_click_rule", "has_cookie_rule", "no_rule"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.has_click_rule.and_then(|val| map.insert("has_click_rule".into(), val.to_string()));
          self.has_cookie_rule.and_then(|val| map.insert("has_cookie_rule".into(), val.to_string()));
          self.no_rule.and_then(|val| map.insert("no_rule".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.reload
    ///
    /// Recorded when the top-level page is reloaded. We use this event metric to know
    /// whether or not the reloading domain has cookie banner rule.
    pub static reload: Lazy<EventMetric<ReloadExtra>> = Lazy::new(|| {
        EventMetric::new(110.into(), CommonMetricData {
            name: "reload".into(),
            category: "cookie.banners".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod cookie_banners_click {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.handle_duration
    ///
    /// Counts how long it takes to handle cookie banners successfully from
    /// DOMContentLoaded until click.
    pub static handle_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(111.into(), CommonMetricData {
            name: "handle_duration".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.click.result
    ///
    /// Given a matching cookie banner click rule, how often do we handle or fail to
    /// handle cookie banners, labelled by reason. The 'success' and 'fail' counters
    /// count the total numbers independently of the reason counters. Counters are
    /// incremented after the content window has been destroyed.
    pub static result: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(112.into(), CommonMetricData {
            name: "result".into(),
            category: "cookie.banners.click".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "failfail_actor_destroyedfail_banner_not_foundfail_banner_not_visiblefail_button_not_foundfail_no_rule_for_modesuccesssuccess_dom_content_loadedsuccess_mutation_post_loadsuccess_mutation_pre_load";const LENGTHS: [u8; 10] = [4, 20, 21, 23, 21, 21, 7, 26, 26, 25];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod crash {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from crash.uptime
    ///
    /// The application uptime. This is equivalent to the legacy crash ping's
    /// `UptimeTS` field.
    pub static uptime: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(113.into(), CommonMetricData {
            name: "uptime".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options
    /// [here](https://firefox-source-
    /// docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-
    /// types).
    pub static process_type: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(114.into(), CommonMetricData {
            name: "process_type".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(115.into(), CommonMetricData {
            name: "time".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Minute)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(116.into(), CommonMetricData {
            name: "startup".into(),
            category: "crash".into(),
            send_in_pings: vec!["crash".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod extensions {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_load_time
    ///
    /// Time to load and deserialize the extensions startupCache data.
    pub static startup_cache_load_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(117.into(), CommonMetricData {
            name: "startup_cache_load_time".into(),
            category: "extensions".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Millisecond)
    });

}
pub mod fog {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(118.into(), CommonMetricData {
            name: "initialization".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.failed_idle_registration
    ///
    /// True if we failed to register with the idle service. Absent otherwise.
    /// Means IPC probably isn't working well.
    /// Child-process data will likely be absent, or incomplete.
    pub static failed_idle_registration: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(119.into(), CommonMetricData {
            name: "failed_idle_registration".into(),
            category: "fog".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod fog_ipc {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(120.into(), CommonMetricData {
            name: "replay_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.buffer_sizes
    ///
    /// The number and size of the IPC buffers being received over FOG IPC.
    pub static buffer_sizes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(121.into(), CommonMetricData {
            name: "buffer_sizes".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_durations
    ///
    /// The length of time between asking the child processes for their
    /// IPC buffers and all of them being received by the parent.
    pub static flush_durations: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(122.into(), CommonMetricData {
            name: "flush_durations".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_failures
    ///
    /// The number of times we failed to flush all non-parent-process data,
    /// throwing even partial results into the trash.
    /// If this number is high, we might consider writing custom `MozPromise`-
    /// handling code instead of using `MozPromise::All`.
    pub static flush_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(123.into(), CommonMetricData {
            name: "flush_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.shutdown_registration_failures
    ///
    /// The number of times we tried to register shutdown flush routines for
    /// content child processes, and failed (probably because there was no main
    /// thread).
    /// As a result there may be data loss from content child processes.
    /// Large or rising number of clients experiencing this indicates we should
    /// perhaps refactor content child shutdown in FOG to try harder to register
    /// flush operations.
    /// Will likely be obsoleted by bug 1641989.
    pub static shutdown_registration_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(124.into(), CommonMetricData {
            name: "shutdown_registration_failures".into(),
            category: "fog.ipc".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod server_knobs {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from server_knobs.validation
    ///
    /// This is a temporary event intented to be used to validate the Glean
    /// Server Knobs capabilities. See Bug 1811561 for more information.
    pub static validation: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(125.into(), CommonMetricData {
            name: "validation".into(),
            category: "server_knobs".into(),
            send_in_pings: vec!["events".into(), "newtab".into()],
            lifetime: Lifetime::Ping,
            disabled: true,
            ..Default::default()
        })
    });

}
pub mod test_only {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(126.into(), CommonMetricData {
            name: "bad_code".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(127.into(), CommonMetricData {
            name: "can_we_time_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(128.into(), CommonMetricData {
            name: "cheesy_string".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string_list
    ///
    /// Only the cheesiest of strings. In list form!
    /// This is a test-only metric.
    pub static cheesy_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(129.into(), CommonMetricData {
            name: "cheesy_string_list".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_a_date
    ///
    /// ...To be writing FOG code. This is a test-only metric.
    pub static what_a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(130.into(), CommonMetricData {
            name: "what_a_date".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(131.into(), CommonMetricData {
            name: "what_id_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_flag_it
    ///
    /// Test metric for a boolean.
    /// This is a test-only metric.
    pub static can_we_flag_it: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(132.into(), CommonMetricData {
            name: "can_we_flag_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.do_you_remember
    ///
    /// They say it's the second thing to go.
    /// This is a test-only metric.
    pub static do_you_remember: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(133.into(), CommonMetricData {
            name: "do_you_remember".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_time_is_it
    ///
    /// Adheres to at least two of the top ten fallacies programmers believe
    /// about time.
    /// This is a test-only metric.
    pub static what_time_is_it: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(134.into(), CommonMetricData {
            name: "what_time_is_it".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_kitchen_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// This is a test-only metric.
    pub static mabels_kitchen_counters: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(135.into(), CommonMetricData {
            name: "mabels_kitchen_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_bathroom_counters
    ///
    /// Counts Mabels labeled by their bathroom counters.
    /// This is a test-only metric.
    pub static mabels_bathroom_counters: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(136.into(), CommonMetricData {
            name: "mabels_bathroom_counters".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_balloons: Lazy<LabeledMetric<LabeledBooleanMetric>> = Lazy::new(|| {
        LabeledMetric::new(137.into(), CommonMetricData {
            name: "mabels_like_balloons".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_strings
    ///
    /// What do the labeled Mabel's liked balloons' strings say?
    /// This is a test-only metric.
    pub static mabels_balloon_strings: Lazy<LabeledMetric<LabeledStringMetric>> = Lazy::new(|| {
        LabeledMetric::new(138.into(), CommonMetricData {
            name: "mabels_balloon_strings".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_label_maker
    ///
    /// Mabel just got a label maker and wants to party like it's
    /// 1999.
    /// This is a test-only metric.
    pub static mabels_label_maker: Lazy<LabeledMetric<LabeledStringMetric>> = Lazy::new(|| {
        LabeledMetric::new(139.into(), CommonMetricData {
            name: "mabels_label_maker".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(140.into(), CommonMetricData {
            name: "mirror_time".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time_nanos
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time_nanos: Lazy<TimespanMetric> = Lazy::new(|| {
        TimespanMetric::new(141.into(), CommonMetricData {
            name: "mirror_time_nanos".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirrors_for_labeled_bools
    ///
    /// Mirrored metric.
    /// This is a test-only metric.
    pub static mirrors_for_labeled_bools: Lazy<LabeledMetric<LabeledBooleanMetric>> = Lazy::new(|| {
        LabeledMetric::new(142.into(), CommonMetricData {
            name: "mirrors_for_labeled_bools".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.one_ping_one_bool
    ///
    /// One bool for one ping only.
    /// This is a test-only metric.
    pub static one_ping_one_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(143.into(), CommonMetricData {
            name: "one_ping_one_bool".into(),
            category: "test_only".into(),
            send_in_pings: vec!["one-ping-only".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.meaning_of_life
    ///
    /// Measures the one true answer to the Ultimate Question of Life,
    /// the Universe, and Everything.
    /// Approximately.
    /// This is a test-only metric.
    pub static meaning_of_life: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(144.into(), CommonMetricData {
            name: "meaning_of_life".into(),
            category: "test_only".into(),
            send_in_pings: vec!["test-ping".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(145.into(), CommonMetricData {
            name: "a_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(146.into(), CommonMetricData {
            name: "a_bool".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        DatetimeMetric::new(147.into(), CommonMetricData {
            name: "a_date".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(148.into(), CommonMetricData {
            name: "a_string".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        MemoryDistributionMetric::new(149.into(), CommonMetricData {
            name: "a_memory_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        TimingDistributionMetric::new(150.into(), CommonMetricData {
            name: "a_timing_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_custom_dist
    ///
    /// This is a test-only metric.
    /// Just measuring samples.
    pub static a_custom_dist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(151.into(), CommonMetricData {
            name: "a_custom_dist".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 2147483646, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        StringListMetric::new(152.into(), CommonMetricData {
            name: "a_string_list".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(153.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EventWithExtraExtra {
        pub extra1: Option<String>,
        pub extra2: Option<u32>,
        pub extra3_longer_name: Option<bool>,
    }

    impl ExtraKeys for EventWithExtraExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "extra3_longer_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.extra3_longer_name.and_then(|val| map.insert("extra3_longer_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.event_with_extra
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static event_with_extra: Lazy<EventMetric<EventWithExtraExtra>> = Lazy::new(|| {
        EventMetric::new(154.into(), CommonMetricData {
            name: "event_with_extra".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.no_extra_event
    ///
    /// This is a test-only metric.
    /// Just recording some events without the extra fuss.
    pub static no_extra_event: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        EventMetric::new(155.into(), CommonMetricData {
            name: "no_extra_event".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(156.into(), CommonMetricData {
            name: "a_uuid".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just counting labeled things.
    pub static a_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(157.into(), CommonMetricData {
            name: "a_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.another_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just another metric counting labeled things.
    pub static another_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(158.into(), CommonMetricData {
            name: "another_labeled_counter".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_quantity
    ///
    /// This is a test-only metric.
    /// Just quantifying things.
    pub static a_quantity: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(159.into(), CommonMetricData {
            name: "a_quantity".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.irate
    ///
    /// This is a test-only metric.
    /// A rate that isn't happy about it.
    pub static irate: Lazy<RateMetric> = Lazy::new(|| {
        RateMetric::new(160.into(), CommonMetricData {
            name: "irate".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.rate_with_external_denominator
    ///
    /// This is a test-only metric.
    /// A rate with a denominator that is Out There.
    pub static rate_with_external_denominator: Lazy<NumeratorMetric> = Lazy::new(|| {
        NumeratorMetric::new(161.into(), CommonMetricData {
            name: "rate_with_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_external_denominator
    ///
    /// This is a test-only metric.
    /// A denominator not from around here.
    pub static an_external_denominator: Lazy<DenominatorMetric> = Lazy::new(|| {
        DenominatorMetric::new(162.into(), CommonMetricData {
            name: "an_external_denominator".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, vec![CommonMetricData {name: "rate_with_external_denominator".into(), category: "test_only.ipc".into(), send_in_pings: vec!["store1".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_url
    ///
    /// This is a test-only metric.
    /// Just setting some Urls.
    pub static a_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(163.into(), CommonMetricData {
            name: "a_url".into(),
            category: "test_only.ipc".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod test_only_jog {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    /// Tied closely to test_jog_name_collision.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(164.into(), CommonMetricData {
            name: "a_counter".into(),
            category: "test_only.jog".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct AnEventExtra {
        pub extra1: Option<String>,
        pub extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    /// Tied closely to test_jog_name_collision.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        EventMetric::new(165.into(), CommonMetricData {
            name: "an_event".into(),
            category: "test_only.jog".into(),
            send_in_pings: vec!["store1".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod nimbus_events {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollmentExtra {
        pub branch: Option<String>,
        pub enrollment_id: Option<String>,
        pub experiment: Option<String>,
        pub experiment_type: Option<String>,
    }

    impl ExtraKeys for EnrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "enrollment_id", "experiment", "experiment_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.enrollment_id.and_then(|val| map.insert("enrollment_id".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.experiment_type.and_then(|val| map.insert("experiment_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment
    ///
    /// Recorded when a user has met the conditions and is first bucketed into an
    /// experiment (i.e. targeting matched and they were randomized into a bucket and
    /// branch of the experiment). Expected a maximum of once per experiment per user.
    pub static enrollment: Lazy<EventMetric<EnrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(166.into(), CommonMetricData {
            name: "enrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct EnrollFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for EnrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enroll_failed
    ///
    /// Recorded when an enrollment fails, including the reason for the failure.
    pub static enroll_failed: Lazy<EventMetric<EnrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(167.into(), CommonMetricData {
            name: "enroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollmentExtra {
        pub branch: Option<String>,
        pub enrollment_id: Option<String>,
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "enrollment_id", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.enrollment_id.and_then(|val| map.insert("enrollment_id".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenrollment
    ///
    /// Recorded when either telemetry is disabled, or the experiment has run for its
    /// designed duration (i.e. it is no longer present in the Nimbus Remote Settings
    /// collection)
    pub static unenrollment: Lazy<EventMetric<UnenrollmentExtra>> = Lazy::new(|| {
        EventMetric::new(168.into(), CommonMetricData {
            name: "unenrollment".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct UnenrollFailedExtra {
        pub experiment: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenroll_failed
    ///
    /// Recorded when an unenrollment fails, including the reason for the failure.
    pub static unenroll_failed: Lazy<EventMetric<UnenrollFailedExtra>> = Lazy::new(|| {
        EventMetric::new(169.into(), CommonMetricData {
            name: "unenroll_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ExposureExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature_id: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature_id.and_then(|val| map.insert("feature_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.exposure
    ///
    /// Recorded when a user actually observes an experimental treatment, or would have
    /// observed an experimental treatment if they had been in a branch that would have
    /// shown one.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        EventMetric::new(170.into(), CommonMetricData {
            name: "exposure".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ValidationFailedExtra {
        pub branch: Option<String>,
        pub experiment: Option<String>,
        pub feature: Option<String>,
        pub reason: Option<String>,
    }

    impl ExtraKeys for ValidationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.validation_failed
    ///
    /// This records when validation of a recipe fails.
    pub static validation_failed: Lazy<EventMetric<ValidationFailedExtra>> = Lazy::new(|| {
        EventMetric::new(171.into(), CommonMetricData {
            name: "validation_failed".into(),
            category: "nimbus_events".into(),
            send_in_pings: vec!["background-update".into(), "events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod pdfjs {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static editing: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(172.into(), CommonMetricData {
            name: "editing".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("freetext"), ::std::borrow::Cow::from("ink"), ::std::borrow::Cow::from("print"), ::std::borrow::Cow::from("save")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.buttons
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static buttons: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(173.into(), CommonMetricData {
            name: "buttons".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "cursor_hand_toolcursor_select_tooldocument_propertiesfirst_pagelast_pagepage_rotate_ccwpage_rotate_cwpresentation_modepresentation_mode_keyboardscroll_horizontalscroll_pagescroll_verticalscroll_wrappedspread_evenspread_nonespread_oddview_bookmark";const LENGTHS: [u8; 17] = [16, 18, 19, 10, 9, 15, 14, 17, 26, 17, 11, 15, 14, 11, 11, 10, 13];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.used
    ///
    /// How many times PDF Viewer was used.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(174.into(), CommonMetricData {
            name: "used".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.time_to_view
    ///
    /// Time spent to display first page in PDF Viewer (ms).
    pub static time_to_view: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(175.into(), CommonMetricData {
            name: "time_to_view".into(),
            category: "pdfjs".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 1, 10000, 50, HistogramType::Exponential)
    });

}
pub mod power {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_bogus_values
    ///
    /// Impossibly large CPU time values that were discarded.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(176.into(), CommonMetricData {
            name: "cpu_time_bogus_values".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_process_type_ms
    ///
    /// CPU time used by each process type in ms.
    pub static cpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(177.into(), CommonMetricData {
            name: "cpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "extensiongmplugingpuparent.activeparent.active.playing-audioparent.active.playing-videoparent.inactiveparent.inactive.playing-audioparent.inactive.playing-videopreallocprivilegedaboutrddsocketutilityweb.backgroundweb.background-perceivableweb.foreground";const LENGTHS: [u8; 17] = [9, 8, 3, 13, 27, 27, 15, 29, 29, 8, 15, 3, 6, 7, 14, 26, 14];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_tracker_type_ms
    ///
    /// CPU time used by content processes used only for tracking resources, labeled by
    /// the category of the tracker.
    pub static cpu_time_per_tracker_type_ms: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(178.into(), CommonMetricData {
            name: "cpu_time_per_tracker_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("ad"), ::std::borrow::Cow::from("analytics"), ::std::borrow::Cow::from("cryptomining"), ::std::borrow::Cow::from("fingerprinting"), ::std::borrow::Cow::from("social"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_per_process_type_ms
    ///
    /// GPU time used by each process type in ms.
    pub static gpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(179.into(), CommonMetricData {
            name: "gpu_time_per_process_type_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "extensiongmplugingpuparent.activeparent.active.playing-audioparent.active.playing-videoparent.inactiveparent.inactive.playing-audioparent.inactive.playing-videopreallocprivilegedaboutrddsocketutilityweb.backgroundweb.background-perceivableweb.foreground";const LENGTHS: [u8; 17] = [9, 8, 3, 13, 27, 27, 15, 29, 29, 8, 15, 3, 6, 7, 14, 26, 14];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_bogus_values
    ///
    /// Impossibly large GPU time values that were discarded.
    pub static gpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(180.into(), CommonMetricData {
            name: "gpu_time_bogus_values".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_process_type
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by process type.
    pub static wakeups_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(181.into(), CommonMetricData {
            name: "wakeups_per_process_type".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "extensiongmplugingpuparent.activeparent.active.playing-audioparent.active.playing-videoparent.inactiveparent.inactive.playing-audioparent.inactive.playing-videopreallocprivilegedaboutrddsocketutilityweb.backgroundweb.background-perceivableweb.foreground";const LENGTHS: [u8; 17] = [9, 8, 3, 13, 27, 27, 15, 29, 29, 8, 15, 3, 6, 7, 14, 26, 14];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_cpu_time_ms
    ///
    /// Total CPU time used by all processes in ms.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(182.into(), CommonMetricData {
            name: "total_cpu_time_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_gpu_time_ms
    ///
    /// Total GPU time used by all processes in ms.
    pub static total_gpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(183.into(), CommonMetricData {
            name: "total_gpu_time_ms".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_thread_wakeups
    ///
    /// How many times threads woke up and could have woken up a CPU core.
    pub static total_thread_wakeups: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::new(184.into(), CommonMetricData {
            name: "total_thread_wakeups".into(),
            category: "power".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod power_wakeups_per_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_active
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(185.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_inactive
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(186.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_foreground
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(187.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_background
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(188.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.gpu_process
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down
    /// by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(189.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.wakeups_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod power_cpu_ms_per_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_active
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(190.into(), CommonMetricData {
            name: "parent_active".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_inactive
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(191.into(), CommonMetricData {
            name: "parent_inactive".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_foreground
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(192.into(), CommonMetricData {
            name: "content_foreground".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_background
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(193.into(), CommonMetricData {
            name: "content_background".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.gpu_process
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a
    /// given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(194.into(), CommonMetricData {
            name: "gpu_process".into(),
            category: "power.cpu_ms_per_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some({const S: &'static str = "asyncloggeraudioipcaudioipc_callback_rpcaudioipc_client_callbackaudioipc_client_rpcaudioipc_devicecollection_rpcaudioipc_server_callbackaudioipc_server_rpcbackgroundthreadpoolbgiothreadpoolbgreadurlsbhmgr_monitorbhmgr_processorcameras_ipccapturethreadclassifier_updatecom_mtacompositorcookiecubeboperationdatachannel_iodns_resolverdom_workerdomcachethreadextensionprotocolhandlerfont_loaderfontenumthreadfs_brokergeckomaingmpthreadgraphrunnerhtml5_parserimagebridgechldimageioindexeddbinitfontlistinotifyeventthreadipc_i_o_childipc_i_o_parentipc_launchipdl_backgroundjs_watchdogjump_listlibwebrtcmodulethreadlink_monitorls_threadmediacachemediadecoderstatemachinemediapdecodermediasupervisormediatimermediatrackgrphmemorypollermozstoragemtransportnetlink_monitorpacerthreadpermissionplayeventsoundprocesshangmonprofilerchildproxyresolutionquotamanager_ioregisterfontsremotebackbufferremotelzystreamremvidchildrenderersandboxreportersavescriptssocket_threadsoftwarevsyncthreadssl_certstartupcachestreamtransstylethreadswcompositetaskcontrollertimertoastbgthreadtrr_backgrounduntrusted_modulesurl_classifiervideocapturevsynciothreadwebrtccallthreadwebrtcworkerwincompositorwindowsvsyncthreadwinwindowocclusioncalcworker_launcherwrrenderbackendwrscenebuilderwrscenebuilderlpwrworkerwrworkerlp";const LENGTHS: [u8; 96] = [11, 8, 21, 24, 19, 29, 24, 19, 20, 14, 10, 13, 15, 11, 13, 17, 7, 10, 6, 14, 14, 12, 10, 14, 24, 11, 14, 9, 9, 9, 11, 12, 15, 7, 9, 12, 18, 13, 14, 10, 15, 11, 9, 21, 12, 9, 10, 24, 13, 15, 10, 14, 12, 10, 10, 15, 11, 10, 14, 14, 13, 15, 15, 13, 16, 15, 11, 8, 15, 11, 13, 19, 8, 12, 11, 11, 11, 14, 5, 13, 14, 17, 14, 12, 13, 16, 12, 13, 18, 22, 15, 15, 14, 16, 8, 10];let mut offset = 0;LENGTHS.iter().map(|len| {  let start = offset;  offset += *len as usize;  S[start..offset].into()}).collect()}))
    });

}
pub mod power_battery {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from power.battery.percentage_when_user_active
    ///
    /// Records how many percent of battery was available for each period of user
    /// activity.
    pub static percentage_when_user_active: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(195.into(), CommonMetricData {
            name: "percentage_when_user_active".into(),
            category: "power.battery".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 100, 100, HistogramType::Linear)
    });

}
pub mod search_engine_default {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(196.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.display_name
    ///
    /// The display name of the user's default engine.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(197.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(198.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(199.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(200.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.changed
    ///
    /// Recorded when the default search engine is changed.
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(201.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.default".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod search_engine_private {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.engine_id
    ///
    /// The telemetry id of the search engine.
    /// For application provided engines, this is either supplied by the
    /// configuration or from the first part of the associated WebExtension Id.
    /// For other engines, this is `other-<extensionName>`.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(202.into(), CommonMetricData {
            name: "engine_id".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.display_name
    ///
    /// The display name of the user's default engine.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(203.into(), CommonMetricData {
            name: "display_name".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[addon]<extension id>` for a WebExtension based
    ///   engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch based
    ///   engine.
    /// Note: this metric is truncated at 100 characters.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(204.into(), CommonMetricData {
            name: "load_path".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        UrlMetric::new(205.into(), CommonMetricData {
            name: "submission_url".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.verified
    ///
    /// The verified status of the search engine.
    /// For application provided engines, this will always be `default`.
    /// For other engines this will either be `verified` or `unverified` depending
    /// on if the loadPathHash is valid.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static verified: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(206.into(), CommonMetricData {
            name: "verified".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    pub struct ChangedExtra {
        pub change_source: Option<String>,
        pub new_display_name: Option<String>,
        pub new_engine_id: Option<String>,
        pub new_load_path: Option<String>,
        pub new_submission_url: Option<String>,
        pub previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_source", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.change_source.and_then(|val| map.insert("change_source".into(), val.to_string()));
          self.new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.changed
    ///
    /// Recorded when the default search engine is changed
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        EventMetric::new(207.into(), CommonMetricData {
            name: "changed".into(),
            category: "search.engine.private".into(),
            send_in_pings: vec!["events".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod dap {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from dap.upload_status
    ///
    /// The result of trying to upload a report to the DAP server.
    pub static upload_status: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(208.into(), CommonMetricData {
            name: "upload_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dap.report_generation_status
    ///
    /// The result of trying to generate a DAP report.
    pub static report_generation_status: Lazy<LabeledMetric<LabeledCounterMetric>> = Lazy::new(|| {
        LabeledMetric::new(209.into(), CommonMetricData {
            name: "report_generation_status".into(),
            category: "dap".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod legacy_telemetry {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        UuidMetric::new(210.into(), CommonMetricData {
            name: "client_id".into(),
            category: "legacy.telemetry".into(),
            send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into(), "newtab".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod first_startup {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.status_code
    ///
    /// Status of the FirstStartup service, which runs
    /// post-install/early-startup in Firefox.
    pub static status_code: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(211.into(), CommonMetricData {
            name: "status_code".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.elapsed
    ///
    /// Number of milliseconds the FirstStartup service took to run.
    pub static elapsed: Lazy<QuantityMetric> = Lazy::new(|| {
        QuantityMetric::new(212.into(), CommonMetricData {
            name: "elapsed".into(),
            category: "first_startup".into(),
            send_in_pings: vec!["first-startup".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod update {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from update.service_enabled
    ///
    /// Preference "app.update.service.enabled": whether the Mozilla Maintenance
    /// Service is enabled.
    pub static service_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(213.into(), CommonMetricData {
            name: "service_enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.auto_download
    ///
    /// Per-installation preference "app.update.auto": whether to fetch and install
    /// updates without user intervention.
    pub static auto_download: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(214.into(), CommonMetricData {
            name: "auto_download".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.background_update
    ///
    /// Per-installation preference "app.update.background.enabled": whether to fetch
    /// and install updates in the background when Firefox is not running.
    pub static background_update: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(215.into(), CommonMetricData {
            name: "background_update".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.enabled
    ///
    /// True when policies are disabled or when the "DisableAppUpdate" is not in
    /// effect.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(216.into(), CommonMetricData {
            name: "enabled".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.channel
    ///
    /// The update channel.
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        StringMetric::new(217.into(), CommonMetricData {
            name: "channel".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_apply_updates
    ///
    /// Whether or not the Update Service can usually download and install updates. See
    /// `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_apply_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(218.into(), CommonMetricData {
            name: "can_usually_apply_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_check_for_updates
    ///
    /// Whether or not the Update Service can usually check for updates. See
    /// `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_check_for_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(219.into(), CommonMetricData {
            name: "can_usually_check_for_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_stage_updates
    ///
    /// Whether the Update Service is usually able to stage updates. See
    /// `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_stage_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(220.into(), CommonMetricData {
            name: "can_usually_stage_updates".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_use_bits
    ///
    /// On Windows, whether the Update Service can usually use BITS. See
    /// `canUsuallyUseBits` in https://searchfox.org/mozilla-
    /// central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_use_bits: Lazy<BooleanMetric> = Lazy::new(|| {
        BooleanMetric::new(221.into(), CommonMetricData {
            name: "can_usually_use_bits".into(),
            category: "update".into(),
            send_in_pings: vec!["background-update".into()],
            lifetime: Lifetime::Application,
            disabled: false,
            ..Default::default()
        })
    });

}
pub mod timer_thread {
    use crate::private::*;
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(non_upper_case_globals)]
    /// generated from timer_thread.timers_fired_per_wakeup
    ///
    /// How many timers were processed in a single wake-up of the Timer Thread.
    pub static timers_fired_per_wakeup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        CustomDistributionMetric::new(222.into(), CommonMetricData {
            name: "timers_fired_per_wakeup".into(),
            category: "timer_thread".into(),
            send_in_pings: vec!["metrics".into()],
            lifetime: Lifetime::Ping,
            disabled: false,
            ..Default::default()
        }, 0, 80, 20, HistogramType::Exponential)
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;

    use crate::metrics::extra_keys_len;
    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static STRING_LIST_MAP: Lazy<HashMap<MetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(5);
        map.insert(2.into(), &super::background_update::reasons_to_not_update);
        map.insert(12.into(), &super::background_update::states);
        map.insert(13.into(), &super::background_update::reasons);
        map.insert(129.into(), &super::test_only::cheesy_string_list);
        map.insert(152.into(), &super::test_only_ipc::a_string_list);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<MetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(3.into(), &super::background_update::time_last_update_scheduled);
        map.insert(9.into(), &super::background_update::targeting_env_current_date);
        map.insert(10.into(), &super::background_update::targeting_env_profile_age);
        map.insert(115.into(), &super::crash::time);
        map.insert(130.into(), &super::test_only::what_a_date);
        map.insert(147.into(), &super::test_only_ipc::a_date);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<MetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(4);
        map.insert(4.into(), &super::background_update::client_id);
        map.insert(131.into(), &super::test_only::what_id_it);
        map.insert(156.into(), &super::test_only_ipc::a_uuid);
        map.insert(210.into(), &super::legacy_telemetry::client_id);
        map
    });

    pub static BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(34);
        map.insert(5.into(), &super::background_update::targeting_exists);
        map.insert(6.into(), &super::background_update::targeting_exception);
        map.insert(14.into(), &super::background_update::exit_code_success);
        map.insert(15.into(), &super::background_update::exit_code_exception);
        map.insert(21.into(), &super::newtab_search::enabled);
        map.insert(23.into(), &super::topsites::enabled);
        map.insert(24.into(), &super::topsites::sponsored_enabled);
        map.insert(27.into(), &super::pocket::is_signed_in);
        map.insert(28.into(), &super::pocket::enabled);
        map.insert(29.into(), &super::pocket::sponsored_stories_enabled);
        map.insert(42.into(), &super::urlbar::pref_suggest_topsites);
        map.insert(83.into(), &super::background_tasks_rmdir_base::was_first);
        map.insert(86.into(), &super::background_tasks_rmdir_base::succeeded);
        map.insert(88.into(), &super::background_tasks_rmdir_base::suffix_ever_failed);
        map.insert(91.into(), &super::background_tasks_rmdir_quota::was_first);
        map.insert(94.into(), &super::background_tasks_rmdir_quota::succeeded);
        map.insert(96.into(), &super::background_tasks_rmdir_quota::suffix_ever_failed);
        map.insert(99.into(), &super::background_tasks_rmdir_http_cache::was_first);
        map.insert(102.into(), &super::background_tasks_rmdir_http_cache::succeeded);
        map.insert(104.into(), &super::background_tasks_rmdir_http_cache::suffix_ever_failed);
        map.insert(107.into(), &super::cookie_banners::service_detect_only);
        map.insert(116.into(), &super::crash::startup);
        map.insert(119.into(), &super::fog::failed_idle_registration);
        map.insert(132.into(), &super::test_only::can_we_flag_it);
        map.insert(143.into(), &super::test_only::one_ping_one_bool);
        map.insert(146.into(), &super::test_only_ipc::a_bool);
        map.insert(213.into(), &super::update::service_enabled);
        map.insert(214.into(), &super::update::auto_download);
        map.insert(215.into(), &super::update::background_update);
        map.insert(216.into(), &super::update::enabled);
        map.insert(218.into(), &super::update::can_usually_apply_updates);
        map.insert(219.into(), &super::update::can_usually_check_for_updates);
        map.insert(220.into(), &super::update::can_usually_stage_updates);
        map.insert(221.into(), &super::update::can_usually_use_bits);
        map
    });

    pub static QUANTITY_MAP: Lazy<HashMap<MetricId, &Lazy<QuantityMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(19);
        map.insert(7.into(), &super::background_update::targeting_version);
        map.insert(8.into(), &super::background_update::targeting_env_firefox_version);
        map.insert(41.into(), &super::urlbar::pref_max_results);
        map.insert(82.into(), &super::background_tasks_rmdir_base::elapsed_ms);
        map.insert(84.into(), &super::background_tasks_rmdir_base::retry_count);
        map.insert(85.into(), &super::background_tasks_rmdir_base::removal_count);
        map.insert(87.into(), &super::background_tasks_rmdir_base::suffix_removal_count);
        map.insert(90.into(), &super::background_tasks_rmdir_quota::elapsed_ms);
        map.insert(92.into(), &super::background_tasks_rmdir_quota::retry_count);
        map.insert(93.into(), &super::background_tasks_rmdir_quota::removal_count);
        map.insert(95.into(), &super::background_tasks_rmdir_quota::suffix_removal_count);
        map.insert(98.into(), &super::background_tasks_rmdir_http_cache::elapsed_ms);
        map.insert(100.into(), &super::background_tasks_rmdir_http_cache::retry_count);
        map.insert(101.into(), &super::background_tasks_rmdir_http_cache::removal_count);
        map.insert(103.into(), &super::background_tasks_rmdir_http_cache::suffix_removal_count);
        map.insert(144.into(), &super::test_only::meaning_of_life);
        map.insert(159.into(), &super::test_only_ipc::a_quantity);
        map.insert(211.into(), &super::first_startup::status_code);
        map.insert(212.into(), &super::first_startup::elapsed);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<MetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(16);
        map.insert(11.into(), &super::background_update::final_state);
        map.insert(16.into(), &super::newtab::locale);
        map.insert(17.into(), &super::newtab::newtab_category);
        map.insert(18.into(), &super::newtab::homepage_category);
        map.insert(114.into(), &super::crash::process_type);
        map.insert(128.into(), &super::test_only::cheesy_string);
        map.insert(148.into(), &super::test_only_ipc::a_string);
        map.insert(196.into(), &super::search_engine_default::engine_id);
        map.insert(197.into(), &super::search_engine_default::display_name);
        map.insert(198.into(), &super::search_engine_default::load_path);
        map.insert(200.into(), &super::search_engine_default::verified);
        map.insert(202.into(), &super::search_engine_private::engine_id);
        map.insert(203.into(), &super::search_engine_private::display_name);
        map.insert(204.into(), &super::search_engine_private::load_path);
        map.insert(206.into(), &super::search_engine_private::verified);
        map.insert(217.into(), &super::update::channel);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(15);
        map.insert(43.into(), &super::browser_engagement::active_ticks);
        map.insert(44.into(), &super::browser_engagement::uri_count);
        map.insert(45.into(), &super::ping_centre::send_failures);
        map.insert(120.into(), &super::fog_ipc::replay_failures);
        map.insert(123.into(), &super::fog_ipc::flush_failures);
        map.insert(124.into(), &super::fog_ipc::shutdown_registration_failures);
        map.insert(126.into(), &super::test_only::bad_code);
        map.insert(145.into(), &super::test_only_ipc::a_counter);
        map.insert(164.into(), &super::test_only_jog::a_counter);
        map.insert(174.into(), &super::pdfjs::used);
        map.insert(176.into(), &super::power::cpu_time_bogus_values);
        map.insert(180.into(), &super::power::gpu_time_bogus_values);
        map.insert(182.into(), &super::power::total_cpu_time_ms);
        map.insert(183.into(), &super::power::total_gpu_time_ms);
        map.insert(184.into(), &super::power::total_thread_wakeups);
        map
    });

    pub static LABELED_COUNTER_MAP: Lazy<HashMap<MetricId, &Lazy<LabeledMetric<LabeledCounterMetric>>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(32);
        map.insert(46.into(), &super::ping_centre::send_failures_by_namespace);
        map.insert(47.into(), &super::ping_centre::send_successes_by_namespace);
        map.insert(48.into(), &super::gmp::update_xml_fetch_result);
        map.insert(77.into(), &super::netwerk::early_hints);
        map.insert(78.into(), &super::netwerk::eh_link_type);
        map.insert(79.into(), &super::network::data_size_per_type);
        map.insert(80.into(), &super::network::data_size_pb_per_type);
        map.insert(108.into(), &super::cookie_banners::rule_lookup_by_load);
        map.insert(109.into(), &super::cookie_banners::rule_lookup_by_domain);
        map.insert(112.into(), &super::cookie_banners_click::result);
        map.insert(135.into(), &super::test_only::mabels_kitchen_counters);
        map.insert(136.into(), &super::test_only::mabels_bathroom_counters);
        map.insert(157.into(), &super::test_only_ipc::a_labeled_counter);
        map.insert(158.into(), &super::test_only_ipc::another_labeled_counter);
        map.insert(172.into(), &super::pdfjs::editing);
        map.insert(173.into(), &super::pdfjs::buttons);
        map.insert(177.into(), &super::power::cpu_time_per_process_type_ms);
        map.insert(178.into(), &super::power::cpu_time_per_tracker_type_ms);
        map.insert(179.into(), &super::power::gpu_time_per_process_type_ms);
        map.insert(181.into(), &super::power::wakeups_per_process_type);
        map.insert(185.into(), &super::power_wakeups_per_thread::parent_active);
        map.insert(186.into(), &super::power_wakeups_per_thread::parent_inactive);
        map.insert(187.into(), &super::power_wakeups_per_thread::content_foreground);
        map.insert(188.into(), &super::power_wakeups_per_thread::content_background);
        map.insert(189.into(), &super::power_wakeups_per_thread::gpu_process);
        map.insert(190.into(), &super::power_cpu_ms_per_thread::parent_active);
        map.insert(191.into(), &super::power_cpu_ms_per_thread::parent_inactive);
        map.insert(192.into(), &super::power_cpu_ms_per_thread::content_foreground);
        map.insert(193.into(), &super::power_cpu_ms_per_thread::content_background);
        map.insert(194.into(), &super::power_cpu_ms_per_thread::gpu_process);
        map.insert(208.into(), &super::dap::upload_status);
        map.insert(209.into(), &super::dap::report_generation_status);
        map
    });

    pub static DENOMINATOR_MAP: Lazy<HashMap<MetricId, &Lazy<DenominatorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(49.into(), &super::rtcrtpsender::count);
        map.insert(50.into(), &super::rtcrtpsender::count_setparameters_compat);
        map.insert(162.into(), &super::test_only_ipc::an_external_denominator);
        map
    });

    pub static NUMERATOR_MAP: Lazy<HashMap<MetricId, &Lazy<NumeratorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(14);
        map.insert(51.into(), &super::rtcrtpsender::used_sendencodings);
        map.insert(52.into(), &super::rtcrtpsender_setparameters::warn_no_getparameters);
        map.insert(53.into(), &super::rtcrtpsender_setparameters::warn_length_changed);
        map.insert(54.into(), &super::rtcrtpsender_setparameters::warn_rid_changed);
        map.insert(55.into(), &super::rtcrtpsender_setparameters::warn_no_transactionid);
        map.insert(56.into(), &super::rtcrtpsender_setparameters::warn_stale_transactionid);
        map.insert(57.into(), &super::rtcrtpsender_setparameters::fail_length_changed);
        map.insert(58.into(), &super::rtcrtpsender_setparameters::fail_rid_changed);
        map.insert(59.into(), &super::rtcrtpsender_setparameters::fail_no_getparameters);
        map.insert(60.into(), &super::rtcrtpsender_setparameters::fail_no_transactionid);
        map.insert(61.into(), &super::rtcrtpsender_setparameters::fail_stale_transactionid);
        map.insert(62.into(), &super::rtcrtpsender_setparameters::fail_no_encodings);
        map.insert(63.into(), &super::rtcrtpsender_setparameters::fail_other);
        map.insert(161.into(), &super::test_only_ipc::rate_with_external_denominator);
        map
    });

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(16);
        map.insert(65.into(), &super::paint::build_displaylist_time);
        map.insert(66.into(), &super::wr::gpu_wait_time);
        map.insert(67.into(), &super::wr::rasterize_glyphs_time);
        map.insert(68.into(), &super::wr::rasterize_blobs_time);
        map.insert(69.into(), &super::wr::renderer_time);
        map.insert(70.into(), &super::wr::renderer_time_no_sc);
        map.insert(71.into(), &super::wr::framebuild_time);
        map.insert(72.into(), &super::wr::scenebuild_time);
        map.insert(73.into(), &super::wr::sceneswap_time);
        map.insert(74.into(), &super::wr::texture_cache_update_time);
        map.insert(75.into(), &super::wr::time_to_frame_build);
        map.insert(76.into(), &super::wr::time_to_render_start);
        map.insert(111.into(), &super::cookie_banners_click::handle_duration);
        map.insert(122.into(), &super::fog_ipc::flush_durations);
        map.insert(134.into(), &super::test_only::what_time_is_it);
        map.insert(150.into(), &super::test_only_ipc::a_timing_dist);
        map
    });

    pub static LABELED_BOOLEAN_MAP: Lazy<HashMap<MetricId, &Lazy<LabeledMetric<LabeledBooleanMetric>>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(4);
        map.insert(105.into(), &super::cookie_banners::normal_window_service_mode);
        map.insert(106.into(), &super::cookie_banners::private_window_service_mode);
        map.insert(137.into(), &super::test_only::mabels_like_balloons);
        map.insert(142.into(), &super::test_only::mirrors_for_labeled_bools);
        map
    });

    pub static TIMESPAN_MAP: Lazy<HashMap<MetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(6);
        map.insert(113.into(), &super::crash::uptime);
        map.insert(117.into(), &super::extensions::startup_cache_load_time);
        map.insert(118.into(), &super::fog::initialization);
        map.insert(127.into(), &super::test_only::can_we_time_it);
        map.insert(140.into(), &super::test_only::mirror_time);
        map.insert(141.into(), &super::test_only::mirror_time_nanos);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(121.into(), &super::fog_ipc::buffer_sizes);
        map.insert(133.into(), &super::test_only::do_you_remember);
        map.insert(149.into(), &super::test_only_ipc::a_memory_dist);
        map
    });

    pub static LABELED_STRING_MAP: Lazy<HashMap<MetricId, &Lazy<LabeledMetric<LabeledStringMetric>>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2);
        map.insert(138.into(), &super::test_only::mabels_balloon_strings);
        map.insert(139.into(), &super::test_only::mabels_label_maker);
        map
    });

    pub static CUSTOM_DISTRIBUTION_MAP: Lazy<HashMap<MetricId, &Lazy<CustomDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(4);
        map.insert(151.into(), &super::test_only_ipc::a_custom_dist);
        map.insert(175.into(), &super::pdfjs::time_to_view);
        map.insert(195.into(), &super::power_battery::percentage_when_user_active);
        map.insert(222.into(), &super::timer_thread::timers_fired_per_wakeup);
        map
    });

    pub static RATE_MAP: Lazy<HashMap<MetricId, &Lazy<RateMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(1);
        map.insert(160.into(), &super::test_only_ipc::irate);
        map
    });

    pub static URL_MAP: Lazy<HashMap<MetricId, &Lazy<UrlMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(3);
        map.insert(163.into(), &super::test_only_ipc::a_url);
        map.insert(199.into(), &super::search_engine_default::submission_url);
        map.insert(205.into(), &super::search_engine_private::submission_url);
        map
    });


    /// Wrapper to record an event based on its metric ID.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
    pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          1 => {
              assert!(
                  extra_keys_len(&super::browser_launched_to_handle::system_notification) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::browser_launched_to_handle::system_notification.record_raw(extra);
              Ok(())
          }
          19 => {
              assert!(
                  extra_keys_len(&super::newtab::opened) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::opened.record_raw(extra);
              Ok(())
          }
          20 => {
              assert!(
                  extra_keys_len(&super::newtab::closed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab::closed.record_raw(extra);
              Ok(())
          }
          22 => {
              assert!(
                  extra_keys_len(&super::newtab_search::issued) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search::issued.record_raw(extra);
              Ok(())
          }
          25 => {
              assert!(
                  extra_keys_len(&super::topsites::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::impression.record_raw(extra);
              Ok(())
          }
          26 => {
              assert!(
                  extra_keys_len(&super::topsites::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::topsites::click.record_raw(extra);
              Ok(())
          }
          30 => {
              assert!(
                  extra_keys_len(&super::pocket::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::impression.record_raw(extra);
              Ok(())
          }
          31 => {
              assert!(
                  extra_keys_len(&super::pocket::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::click.record_raw(extra);
              Ok(())
          }
          32 => {
              assert!(
                  extra_keys_len(&super::pocket::save) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::save.record_raw(extra);
              Ok(())
          }
          33 => {
              assert!(
                  extra_keys_len(&super::pocket::topic_click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::pocket::topic_click.record_raw(extra);
              Ok(())
          }
          34 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::impression.record_raw(extra);
              Ok(())
          }
          35 => {
              assert!(
                  extra_keys_len(&super::newtab_search_ad::click) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::newtab_search_ad::click.record_raw(extra);
              Ok(())
          }
          36 => {
              assert!(
                  extra_keys_len(&super::serp::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::impression.record_raw(extra);
              Ok(())
          }
          37 => {
              assert!(
                  extra_keys_len(&super::serp::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::serp::engagement.record_raw(extra);
              Ok(())
          }
          38 => {
              assert!(
                  extra_keys_len(&super::urlbar::abandonment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::abandonment.record_raw(extra);
              Ok(())
          }
          39 => {
              assert!(
                  extra_keys_len(&super::urlbar::engagement) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::engagement.record_raw(extra);
              Ok(())
          }
          40 => {
              assert!(
                  extra_keys_len(&super::urlbar::impression) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::urlbar::impression.record_raw(extra);
              Ok(())
          }
          64 => {
              assert!(
                  extra_keys_len(&super::perf::page_load) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::perf::page_load.record_raw(extra);
              Ok(())
          }
          81 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_base::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_base::metric_base.record_raw(extra);
              Ok(())
          }
          89 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_quota::metric_base.record_raw(extra);
              Ok(())
          }
          97 => {
              assert!(
                  extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::background_tasks_rmdir_http_cache::metric_base.record_raw(extra);
              Ok(())
          }
          110 => {
              assert!(
                  extra_keys_len(&super::cookie_banners::reload) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::cookie_banners::reload.record_raw(extra);
              Ok(())
          }
          125 => {
              assert!(
                  extra_keys_len(&super::server_knobs::validation) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::server_knobs::validation.record_raw(extra);
              Ok(())
          }
          153 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::an_event.record_raw(extra);
              Ok(())
          }
          154 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::event_with_extra) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::event_with_extra.record_raw(extra);
              Ok(())
          }
          155 => {
              assert!(
                  extra_keys_len(&super::test_only_ipc::no_extra_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_ipc::no_extra_event.record_raw(extra);
              Ok(())
          }
          165 => {
              assert!(
                  extra_keys_len(&super::test_only_jog::an_event) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::test_only_jog::an_event.record_raw(extra);
              Ok(())
          }
          166 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enrollment.record_raw(extra);
              Ok(())
          }
          167 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::enroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::enroll_failed.record_raw(extra);
              Ok(())
          }
          168 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenrollment) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenrollment.record_raw(extra);
              Ok(())
          }
          169 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::unenroll_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::unenroll_failed.record_raw(extra);
              Ok(())
          }
          170 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::exposure) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::exposure.record_raw(extra);
              Ok(())
          }
          171 => {
              assert!(
                  extra_keys_len(&super::nimbus_events::validation_failed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::nimbus_events::validation_failed.record_raw(extra);
              Ok(())
          }
          201 => {
              assert!(
                  extra_keys_len(&super::search_engine_default::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_default::changed.record_raw(extra);
              Ok(())
          }
          207 => {
              assert!(
                  extra_keys_len(&super::search_engine_private::changed) != 0 || extra.is_empty(),
                  "No extra keys allowed, but some were passed"
              );

              super::search_engine_private::changed.record_raw(extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to record an event based on its metric ID, with a provided timestamp.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `timestamp` - The time at which this event was recorded.
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the event doesn't take extra pairs,
    /// but some are passed in.
    pub(crate) fn record_event_by_id_with_time(metric_id: MetricId, timestamp: u64, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          MetricId(1) => {
              if extra_keys_len(&super::browser_launched_to_handle::system_notification) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_launched_to_handle::system_notification.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(19) => {
              if extra_keys_len(&super::newtab::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(20) => {
              if extra_keys_len(&super::newtab::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(22) => {
              if extra_keys_len(&super::newtab_search::issued) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search::issued.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(25) => {
              if extra_keys_len(&super::topsites::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(26) => {
              if extra_keys_len(&super::topsites::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(30) => {
              if extra_keys_len(&super::pocket::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(31) => {
              if extra_keys_len(&super::pocket::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(32) => {
              if extra_keys_len(&super::pocket::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::save.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(33) => {
              if extra_keys_len(&super::pocket::topic_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::topic_click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(34) => {
              if extra_keys_len(&super::newtab_search_ad::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(35) => {
              if extra_keys_len(&super::newtab_search_ad::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::click.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(36) => {
              if extra_keys_len(&super::serp::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(37) => {
              if extra_keys_len(&super::serp::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(38) => {
              if extra_keys_len(&super::urlbar::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(39) => {
              if extra_keys_len(&super::urlbar::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(40) => {
              if extra_keys_len(&super::urlbar::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(64) => {
              if extra_keys_len(&super::perf::page_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::perf::page_load.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(81) => {
              if extra_keys_len(&super::background_tasks_rmdir_base::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_base::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(89) => {
              if extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_quota::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(97) => {
              if extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_http_cache::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(110) => {
              if extra_keys_len(&super::cookie_banners::reload) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::reload.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(125) => {
              if extra_keys_len(&super::server_knobs::validation) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::server_knobs::validation.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(153) => {
              if extra_keys_len(&super::test_only_ipc::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(154) => {
              if extra_keys_len(&super::test_only_ipc::event_with_extra) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::event_with_extra.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(155) => {
              if extra_keys_len(&super::test_only_ipc::no_extra_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::no_extra_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(165) => {
              if extra_keys_len(&super::test_only_jog::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_jog::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(166) => {
              if extra_keys_len(&super::nimbus_events::enrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(167) => {
              if extra_keys_len(&super::nimbus_events::enroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(168) => {
              if extra_keys_len(&super::nimbus_events::unenrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(169) => {
              if extra_keys_len(&super::nimbus_events::unenroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(170) => {
              if extra_keys_len(&super::nimbus_events::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(171) => {
              if extra_keys_len(&super::nimbus_events::validation_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::validation_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(201) => {
              if extra_keys_len(&super::search_engine_default::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_default::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          MetricId(207) => {
              if extra_keys_len(&super::search_engine_private::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_private::changed.record_with_time(timestamp, extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to get the currently stored events for event metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded events or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    pub(crate) fn event_test_get_value_wrapper(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
        match metric_id {
           1 => super::browser_launched_to_handle::system_notification.test_get_value(ping_name.as_deref()),
           19 => super::newtab::opened.test_get_value(ping_name.as_deref()),
           20 => super::newtab::closed.test_get_value(ping_name.as_deref()),
           22 => super::newtab_search::issued.test_get_value(ping_name.as_deref()),
           25 => super::topsites::impression.test_get_value(ping_name.as_deref()),
           26 => super::topsites::click.test_get_value(ping_name.as_deref()),
           30 => super::pocket::impression.test_get_value(ping_name.as_deref()),
           31 => super::pocket::click.test_get_value(ping_name.as_deref()),
           32 => super::pocket::save.test_get_value(ping_name.as_deref()),
           33 => super::pocket::topic_click.test_get_value(ping_name.as_deref()),
           34 => super::newtab_search_ad::impression.test_get_value(ping_name.as_deref()),
           35 => super::newtab_search_ad::click.test_get_value(ping_name.as_deref()),
           36 => super::serp::impression.test_get_value(ping_name.as_deref()),
           37 => super::serp::engagement.test_get_value(ping_name.as_deref()),
           38 => super::urlbar::abandonment.test_get_value(ping_name.as_deref()),
           39 => super::urlbar::engagement.test_get_value(ping_name.as_deref()),
           40 => super::urlbar::impression.test_get_value(ping_name.as_deref()),
           64 => super::perf::page_load.test_get_value(ping_name.as_deref()),
           81 => super::background_tasks_rmdir_base::metric_base.test_get_value(ping_name.as_deref()),
           89 => super::background_tasks_rmdir_quota::metric_base.test_get_value(ping_name.as_deref()),
           97 => super::background_tasks_rmdir_http_cache::metric_base.test_get_value(ping_name.as_deref()),
           110 => super::cookie_banners::reload.test_get_value(ping_name.as_deref()),
           125 => super::server_knobs::validation.test_get_value(ping_name.as_deref()),
           153 => super::test_only_ipc::an_event.test_get_value(ping_name.as_deref()),
           154 => super::test_only_ipc::event_with_extra.test_get_value(ping_name.as_deref()),
           155 => super::test_only_ipc::no_extra_event.test_get_value(ping_name.as_deref()),
           165 => super::test_only_jog::an_event.test_get_value(ping_name.as_deref()),
           166 => super::nimbus_events::enrollment.test_get_value(ping_name.as_deref()),
           167 => super::nimbus_events::enroll_failed.test_get_value(ping_name.as_deref()),
           168 => super::nimbus_events::unenrollment.test_get_value(ping_name.as_deref()),
           169 => super::nimbus_events::unenroll_failed.test_get_value(ping_name.as_deref()),
           170 => super::nimbus_events::exposure.test_get_value(ping_name.as_deref()),
           171 => super::nimbus_events::validation_failed.test_get_value(ping_name.as_deref()),
           201 => super::search_engine_default::changed.test_get_value(ping_name.as_deref()),
           207 => super::search_engine_private::changed.test_get_value(ping_name.as_deref()),
           _ => panic!("No event for metric id {}", metric_id),
        }
    }

    /// Check the provided event for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn event_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           1 => test_get_errors!(super::browser_launched_to_handle::system_notification),
           19 => test_get_errors!(super::newtab::opened),
           20 => test_get_errors!(super::newtab::closed),
           22 => test_get_errors!(super::newtab_search::issued),
           25 => test_get_errors!(super::topsites::impression),
           26 => test_get_errors!(super::topsites::click),
           30 => test_get_errors!(super::pocket::impression),
           31 => test_get_errors!(super::pocket::click),
           32 => test_get_errors!(super::pocket::save),
           33 => test_get_errors!(super::pocket::topic_click),
           34 => test_get_errors!(super::newtab_search_ad::impression),
           35 => test_get_errors!(super::newtab_search_ad::click),
           36 => test_get_errors!(super::serp::impression),
           37 => test_get_errors!(super::serp::engagement),
           38 => test_get_errors!(super::urlbar::abandonment),
           39 => test_get_errors!(super::urlbar::engagement),
           40 => test_get_errors!(super::urlbar::impression),
           64 => test_get_errors!(super::perf::page_load),
           81 => test_get_errors!(super::background_tasks_rmdir_base::metric_base),
           89 => test_get_errors!(super::background_tasks_rmdir_quota::metric_base),
           97 => test_get_errors!(super::background_tasks_rmdir_http_cache::metric_base),
           110 => test_get_errors!(super::cookie_banners::reload),
           125 => test_get_errors!(super::server_knobs::validation),
           153 => test_get_errors!(super::test_only_ipc::an_event),
           154 => test_get_errors!(super::test_only_ipc::event_with_extra),
           155 => test_get_errors!(super::test_only_ipc::no_extra_event),
           165 => test_get_errors!(super::test_only_jog::an_event),
           166 => test_get_errors!(super::nimbus_events::enrollment),
           167 => test_get_errors!(super::nimbus_events::enroll_failed),
           168 => test_get_errors!(super::nimbus_events::unenrollment),
           169 => test_get_errors!(super::nimbus_events::unenroll_failed),
           170 => test_get_errors!(super::nimbus_events::exposure),
           171 => test_get_errors!(super::nimbus_events::validation_failed),
           201 => test_get_errors!(super::search_engine_default::changed),
           207 => test_get_errors!(super::search_engine_private::changed),
           _ => panic!("No event for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    pub(crate) mod submetric_maps {
        use std::sync::{
          atomic::AtomicU32,
          RwLock,
        };
        use super::*;

        pub(crate) const SUBMETRIC_BIT: u32 = 25;
        pub(crate) static NEXT_LABELED_SUBMETRIC_ID: AtomicU32 = AtomicU32::new((1 << SUBMETRIC_BIT) + 1);
        pub(crate) static LABELED_METRICS_TO_IDS: Lazy<RwLock<HashMap<(u32, String), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );

        pub static BOOLEAN_MAP: Lazy<RwLock<HashMap<MetricId, LabeledBooleanMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static STRING_MAP: Lazy<RwLock<HashMap<MetricId, LabeledStringMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static COUNTER_MAP: Lazy<RwLock<HashMap<MetricId, LabeledCounterMetric>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
    }
}

